//global function fot getting the definition of a custom block
function getCustomBlockDefinition(customBlock){
    var rcvr;
    if (customBlock.isGlobal){
        return customBlock.definition;
    } else{
        rcvr = customBlock.scriptTarget();
        return rcvr.getMethod(customBlock.blockSpec);
    }
}

/*
function CustomBlockDefinition(spec, receiver) {
    this.body = null; // a Context (i.e. a reified top block)
    this.scripts = [];
    this.category = null;
    this.isGlobal = false;
    this.type = 'command';
    this.spec = spec || '';
    // format: {'inputName' : [type, default, options, readonly]}
    this.declarations = {};
    this.variableNames = [];
    this.comment = null;
    this.codeMapping = null; // experimental, generate text code
    this.codeHeader = null; // experimental, generate text code

    // don't serialize (not needed for functionality):
    this.receiver = receiver || null; // for serialization only (pointer)
    this.editorDimensions = null; // a rectangle, last bounds of the editor
	this.isLocked = false; //@@////// for locking custom blocks ////////////
	this.isHidden = false; //@@/////// for hidding custom blocks ///////////
}
*/
CustomBlockDefinition.prototype.isLocked = false; //@@////// for locking custom blocks ////////////
CustomBlockDefinition.prototype.isHidden = false; //@@/////// for hidding custom blocks ///////////

CustomBlockDefinition.prototype.prototypeInstance = function (isReadOnly) {  //--++ isReadOnly
    var block, slot, myself = this;

    // make a new block instance and mark it as prototype
    if (this.type === 'command') {
        block = new CustomCommandBlockMorph(this, true);
    } else {
        block = new CustomReporterBlockMorph(
            this,
            this.type === 'predicate',
            true
        );
    }
if (isReadOnly) { block.userMenu = function () {return;}} //--+++
    // assign slot declarations to prototype inputs
    block.parts().forEach(function (part) {
if (isReadOnly) { //--++
	part.userMenu = function () {return;}
	part.mouseClickLeft = function () { return;} 
} //--+++
        if (part instanceof BlockInputFragmentMorph) {
            slot = myself.declarations[part.fragment.labelString];
            if (slot) {
                part.fragment.type = slot[0];
                part.fragment.defaultValue = slot[1];
                part.fragment.options = slot[2];
                part.fragment.isReadOnly = slot[3] || false;
            }
        }
    });

    return block;
};

CustomCommandBlockMorph.prototype.edit = function () {
    var myself = this,  def = this.definition,
        editor, block,
        hat,
        ide,
        rcvr;

    if (this.isPrototype) {
        block = this.definition.blockInstance();
        block.addShadow();
        hat = this.parentThatIsA(PrototypeHatBlockMorph);
//@@
		rcvr = this.scriptTarget();//myself.receiver();
		ide = rcvr.parentThatIsA(IDE_Morph);
		if (world.role == 'STUDENT' && ide.currentCategory == 'depository' ) {return;}     // do not allow student to change the category of a custom block if in depository
//@@
        new BlockDialogMorph(
            null,
            function (definition) {
                if (definition) { // temporarily update everything
                    hat.blockCategory = definition.category;
                    hat.type = definition.type;
                    myself.refreshPrototype();
                }
            },
            myself
        ).openForChange(
            'Change block',
            hat.blockCategory,
            hat.type,
            myself.world(),
            block.fullImage(),
            myself.isInUse()
        );
    } else {
       // check for local custom block inheritance
        rcvr = this.scriptTarget();
        if (!this.isGlobal) {
            if (contains(
                    Object.keys(rcvr.inheritedBlocks()),
                    this.blockSpec
                )
            ) {
                this.duplicateBlockDefinition();
                return;
            }
            def = rcvr.getMethod(this.blockSpec);
        }
        Morph.prototype.trackChanges = false;
        editor = new BlockEditorMorph(def, rcvr);
        editor.popUp();
        Morph.prototype.trackChanges = true;
        editor.changed();
    }
};

CustomCommandBlockMorph.prototype.userMenu = function () {
    var hat = this.parentThatIsA(PrototypeHatBlockMorph),
        rcvr = this.scriptTarget(),
        myself = this,
        shiftClicked = this.world().currentKey === 16,
        menu,
	ide = rcvr.parentThatIsA(IDE_Morph),
        definition = getCustomBlockDefinition(this);
   
    function addOption(label, toggle, test, onHint, offHint) {
        var on = '\u2611 ',
            off = '\u2610 ';
        menu.addItem(
            (test ? on : off) + localize(label),
            toggle,
            test ? onHint : offHint
        );
    }
    
   function monitor(vName) {
        var stage = rcvr.parentThatIsA(StageMorph),
            varFrame = myself.variables;
        menu.addItem(
            vName + '...',
            function () {
                var watcher = detect(
                    stage.children,
                    function (morph) {
                        return morph instanceof WatcherMorph
                            && morph.target === varFrame
                            && morph.getter === vName;
                    }
                ),
                    others;
                if (watcher !== null) {
                    watcher.show();
                    watcher.fixLayout(); // re-hide hidden parts
                    return;
                }
                watcher = new WatcherMorph(
                    vName + ' ' + localize('(temporary)'),
                    SpriteMorph.prototype.blockColor.variables,
                    varFrame,
                    vName
                );
                watcher.setPosition(stage.position().add(10));
                others = stage.watchers(watcher.left());
                if (others.length > 0) {
                    watcher.setTop(others[others.length - 1].bottom());
                }
                stage.add(watcher);
                watcher.fixLayout();
            }
        );
    }
	
	/////////////////// copied from gui.js /////////////////////////////////
	function addPreference(label, toggle, test, onHint, offHint, hide) {
		var on = '\u2611 ',
			off = '\u2610 ';
		if (!hide) {
			menu.addItem(
						(test ? on : off) + localize(label),
						toggle,
						test ? onHint : offHint,
						hide ? new Color(100, 0, 0) : null
					);
		}
	}

    if (this.isPrototype) {
        menu = new MenuMorph(this);
        menu.addItem(
            "script pic...",
            function () {
                var ide = this.world().children[0];
                ide.saveCanvasAs(
                    this.topBlock().scriptPic(),
                    ide.projectName || localize('Untitled') + ' ' +
                        localize('script pic')
                );
            },
            'open a new window\nwith a picture of this script'
        );
        if (this.isGlobal) {
            if (hat.inputs().length < 2) {
                menu.addItem(
                    "block variables...",
                    function () {
                        hat.enableBlockVars();
                    },
                    'experimental -\nunder construction'
                );
            } else {
                menu.addItem(
                    "remove block variables...",
                    function () {
                        hat.enableBlockVars(false);
                    },
                    'experimental -\nunder construction'
                );
            }
        }    
    } else {
        menu = this.constructor.uber.userMenu.call(this);
        if (!menu) {
            menu = new MenuMorph(this);
        } else {
			if(world.role != "STUDENT") {  menu.addLine(); }
        }  
		
///////////////////////// hide the export,delete and edit for STUDENT when block is Locked or isHidden///////////////////////////
	if(world.role != "STUDENT" || (!definition.isLocked && !definition.isHidden)){//(this.definition && (!this.definition.isLocked && !this.definition.isHidden))) { 
	//	menu.addItem("export definition...", 'exportBlockDefinition');  //temporarily from official Snap
            if (ide.currentCategory!='depository' || world.role != 'STUDENT' ) { // do not allow student to delete block definition in depository
                if (shiftClicked) {
                    menu.addItem(
                        "duplicate block definition...",
                        'duplicateBlockDefinition',
                         null,
                         new Color(100, 0, 0)
                    );
                }
             if (this.isTemplate) { // inside the palette
                    if (this.isGlobal) {
                        menu.addItem(
                            "delete block definition...",
                            'deleteBlockDefinition'
                        );
                    } else { // local method
                        if (contains(
                                Object.keys(rcvr.inheritedBlocks()),
                                this.blockSpec
                        )) {
                            // inherited
                            addOption(
                                'inherited',
                                function () {
                                    var ide = myself.parentThatIsA(IDE_Morph);
                                    rcvr.customBlocks.push(
                                        rcvr.getMethod(
                                            myself.blockSpec
                                        ).copyAndBindTo(rcvr)
                                    );
                                    if (ide) {
                                        ide.flushPaletteCache();
                                        ide.refreshPalette();
                                    }
                                },
                                true,
                                'uncheck to\ndisinherit',
                                null
                            );
                        } else if (rcvr.exemplar &&
                            rcvr.exemplar.getMethod(this.blockSpec
                        )) {
                            // shadowed
                            addOption(
                                'inherited',
                                'deleteBlockDefinition',
                                false,
                                null,
                                localize('check to inherit\nfrom')
                                    + ' ' + rcvr.exemplar.name
                            );
                        } else {
                            // own block
                            menu.addItem(
                                "delete block definition...",
                                'deleteBlockDefinition'
                            );
                        }
                    }
                } else { // inside a script
                    // if global or own method - let the user delete the definition
                    if (this.isGlobal ||
                        contains(
                            Object.keys(rcvr.ownBlocks()),
                            this.blockSpec
                        )
                    ) {
                        menu.addItem(
                            "delete block definition...",
                            'deleteBlockDefinition'
                        );
                    }
                }    
                
            }

            //if (this.definition){
		///////////////// add locked selection for dev mode /////////////////////
		addPreference(
		'locked',
		'toggleIsLockedBlock', //--------
		definition.isLocked,
		'click to make the block definition visible to student',
		'click to make the block definition invisible to student',
		world.role=='STUDENT'
		);
            //}    
////////////////////////////////////////////////////////////////////////////////////////////////////////
        }	
        // menu.addItem("export definition...", 'exportBlockDefinition');
        //menu.addItem("delete block definition...", 'deleteBlockDefinition');

        this.variables.names().forEach(function (vName) {
            monitor(vName);
        });
    }
	if (world.role != 'STUDENT' || (!definition.isLocked && !definition.isHidden)){ //(this.definition && (!this.definition.isLocked && !this.definition.isHidden))) { // do not allow student to edit block definition of hidden or locked custom blocks            
		menu.addItem("edit...", 'edit'); // works also for prototypes
	}       
    return menu;
};

//////////////// isLocked block toggle function ////////////////////////
CustomCommandBlockMorph.prototype.toggleIsLockedBlock = function () {
var definition = getCustomBlockDefinition(this);    
definition.isLocked = !definition.isLocked;
};

CustomCommandBlockMorph.prototype.deleteBlockDefinition = function () {
    var idx,idx_d, rcvr = this.scriptTarget(),
        stage, ide, method, myself = this, block,block_d;
    if (this.isPrototype) {
        return null; // under construction...
    }
    method = this.isGlobal? this.definition
            : rcvr.getLocalMethod(this.blockSpec);
    block = method.blockInstance();
    block.addShadow();
    new DialogBoxMorph(
        this,
        function () {
            rcvr.deleteAllBlockInstances(method);
			ide = rcvr.parentThatIsA(IDE_Morph);
            if (method.isGlobal) {
                stage = rcvr.parentThatIsA(StageMorph);
                idx = stage.globalBlocks.indexOf(method);
                if (idx !== -1) {
                    stage.globalBlocks.splice(idx, 1); 
				}
//+++++++++++++++ delete custom block from depository if exist
			block_d = ['custom-block', myself.definition.blockSpec(),myself.definition.category];
			idx_d = indexOf(ide.stage.depositoryCommands, block_d);

			if (idx_d !== -1) {
				ide.stage.depositoryCommands.splice(idx_d, 1);
				ide.flushBlocksCache('depository');	
			}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                
            } else {
                // delete local definition
                idx = rcvr.customBlocks.indexOf(method);
                if (idx !== -1) {
                    rcvr.customBlocks.splice(idx, 1);
                }
                // refresh instances of inherited method, if any
                method = rcvr.getMethod(myself.blockSpec);
                if (method) {
                    rcvr.allDependentInvocationsOf(myself.blockSpec).forEach(
                        function (block) {
                            block.refresh(method);
                        }
                    );
                }
            }

            if (ide) {
                ide.flushPaletteCache();
                ide.refreshPalette();
            }
        },
        this
    ).askYesNo(
        'Delete Custom Block',
        localize('block deletion dialog text'), // long string lookup
        myself.world(),
        block.fullImage()
    );
};

///////// isLocked toggle for reporter ////////////////////////////////
CustomReporterBlockMorph.prototype.edit =
	CustomCommandBlockMorph.prototype.edit;
CustomReporterBlockMorph.prototype.userMenu =
	CustomCommandBlockMorph.prototype.userMenu;
CustomReporterBlockMorph.prototype.deleteBlockDefinition = 
	CustomCommandBlockMorph.prototype.deleteBlockDefinition;
CustomReporterBlockMorph.prototype.toggleIsLockedBlock  =
	CustomCommandBlockMorph.prototype.toggleIsLockedBlock;

// new custom block help, accepts help file information in comment
CustomBlockDefinition.prototype.helpSpec = function () {
    var ans = [], parts,
            comment,helpLine, helpFile,i,j;
    
    //search the first line of the comment, for help file information <format> help  : <filename>, no extension (should be png picture)    
    if (this.comment){
        comment = this.comment.fullCopy();
        comment.contents.parse(),i,j;
        helpLine=comment.contents.lines[0];
        i = helpLine.indexOf("help");
        if ( i != -1){
            j = helpLine.indexOf(":",i+4);
            if (j != -1){
                helpFile = helpLine.substr(j+1).trim(); //kill whitespace
                if (helpFile.length>0){
                    return helpFile;
                }
            }
        }
        
    }
    
    parts = this.parseSpec(this.spec);
    parts.forEach(function (part) {
        if (part[0] !== '%') {
            ans.push(part);
        }
    });
    return ''.concat.apply('', ans).replace(/\?/g, '');
};


///////////////////////////////////////////////////////////////////////////////////////////////////


BlockDialogMorph.prototype.init = function (target, action, environment) {
    // additional properties:
    this.blockType = 'command';
    this.category = SpriteMorph.prototype.categories()[0]; //custom categories
    this.isGlobal = true;
    this.types = null;
    this.categories = null;

    // initialize inherited properties:
    BlockDialogMorph.uber.init.call(
        this,
        target,
        action,
        environment
    );

    // override inherited properites:
    this.key = 'makeABlock';

    this.types = new AlignmentMorph('row', this.padding);
    this.add(this.types);
    this.scopes = new AlignmentMorph('row', this.padding);
    this.add(this.scopes);

    this.categories = new BoxMorph();
    this.categories.color = SpriteMorph.prototype.paletteColor.lighter(8);
    this.categories.borderColor = this.categories.color.lighter(40);
    this.createCategoryButtons();
    this.fixCategoriesLayout();
    this.add(this.categories);

    this.createTypeButtons();
    this.createScopeButtons();
    this.fixLayout();
};

BlockDialogMorph.prototype.createCategoryButtons = function () {
    var myself = this,
        oldFlag = Morph.prototype.trackChanges;

    Morph.prototype.trackChanges = false;
    SpriteMorph.prototype.categories().forEach(function (cat) {
	if (cat != 'depository' ) {   //++++++++++++++ do not add category in the custom block category selection 
        myself.addCategoryButton(cat); }
    });
    Morph.prototype.trackChanges = oldFlag;
}
/*
// CategoryDialogMorph //////////////////////////////// custom categories
// CategoryDialogMorph inherits from BlockDialogMorph:
CategoryDialogMorph.prototype = new BlockDialogMorph();
CategoryDialogMorph.prototype.constructor = CategoryDialogMorph;
CategoryDialogMorph.uber = BlockDialogMorph.prototype;

// CategoryDialogMorph instance creation:

function CategoryDialogMorph(target, categories, action, environment,world,label) {
    this.init(target, categories, action, environment,world,label);
}

CategoryDialogMorph.prototype.init = function (target, categories, action, environment,world,label) { //customCats: (true) for custom categories, (false) for standard categories
	this.categoryList = categories;	
	this.action = action;
	this.category = null;
    // initialize inherited properties:
    BlockDialogMorph.uber.init.call(
        this,
        target,
        action,
        environment
    );

    this.key = 'deleteACategory';

	this.categories = new BoxMorph();
    this.categories.color = SpriteMorph.prototype.paletteColor.lighter(8);
    this.categories.borderColor = this.categories.color.lighter(40);
    if (!this.createCategoryButtons()){ 		//if createButton was not successfull, that is there are no categories left to delete
	world.inform('No categories available');	// inform the user and return
	return;}
    this.fixCategoriesLayout();
    this.addBody(this.categories);
	
    this.labelString = label;//'Delete a category';
    this.createLabel();

    this.addButton('ok', 'OK');
    this.addButton('cancel', 'Cancel');
 
    this.types = null;
    this.scopes = null;

	this.fixLayout();
    this.drawNew();
	
    this.popUp(world);
};

//overide the createCategoryButtons method
CategoryDialogMorph.prototype.createCategoryButtons = function () {  
    var myself = this,
        oldFlag = Morph.prototype.trackChanges;

   
    if (this.categoryList.length>0) { // if there are categories 
	Morph.prototype.trackChanges = false;
	this.categoryList.forEach(function (cat) {
	if (cat != 'depository' ) {   //++++++++++++++ do not add category in the custom block category selection 
        myself.addCategoryButton(cat); }
    });
	Morph.prototype.trackChanges = oldFlag;
	return true; //return success
	} else {
	return false; //return failure
    }
};

// overide fixLayout
CategoryDialogMorph.prototype.fixLayout = function () {
    var th = fontHeight(this.titleFontSize) + this.titlePadding * 2;

   if (this.body) {
        this.body.setPosition(this.position().add(new Point(
            this.padding,
            th + this.padding
        )));
        this.silentSetWidth(this.body.width() + this.padding * 2);
        this.silentSetHeight(
            this.body.height()
                + this.padding * 2
                + th
        );
        if (this.categories) {
            this.categories.setCenter(this.body.center());
            this.categories.setTop(this.body.top());
            this.silentSetHeight(
                this.height()
				+ this.padding
            );
       }
   } 

   if (this.label) {
        this.label.setCenter(this.center());
        this.label.setTop(this.top() + (th - this.label.height()) / 2);
    }


    if (this.buttons && (this.buttons.children.length > 0)) {
        this.buttons.fixLayout();
        this.silentSetHeight(
            this.height()
                    + this.buttons.height()
                    + this.padding
        );
        this.buttons.setCenter(this.center());
        this.buttons.setBottom(this.bottom() - this.padding);
    }
};
///////////////// custom categories end
*/
BlockEditorMorph.prototype.init = function (definition, target) {
    var scripts, proto, scriptsFrame, block, comment, myself = this,
        isLive = Process.prototype.enableLiveCoding || // v 4.0.10.2
                 Process.prototype.enableSingleStepping,    
		ide = target.parentThatIsA(IDE_Morph), isReadOnly; //--++

    // additional properties:
    this.definition = definition;
    this.handle = null;

    // initialize inherited properties:
    BlockEditorMorph.uber.init.call(
        this,
        target,
        function () { myself.updateDefinition();},
        target
    );

    // override inherited properites:
    this.key = 'editBlock' + definition.spec;
    this.labelString = this.definition.isGlobal ? 'Block Editor'
    		: 'Method Editor';
    this.createLabel();

    // create scripting area
    scripts = new ScriptsMorph(target);
    scripts.rejectsHats = true;
    scripts.isDraggable = false;
    scripts.color = IDE_Morph.prototype.groupColor;
    scripts.cachedTexture = IDE_Morph.prototype.scriptsPaneTexture;
    scripts.cleanUpMargin = 10;
		isReadOnly = ide.currentCategory == 'depository' && world.role == 'STUDENT'; //--++ if in depository in student mode, make head readonly
		proto =	new PrototypeHatBlockMorphNew(this.definition,isReadOnly); //--++ the New version
	

    proto.setPosition(scripts.position().add(10));

    if (definition.comment !== null) {
        comment = definition.comment.fullCopy();
        proto.comment = comment;
        comment.block = proto;
    }

    if (definition.body !== null) {      
        //proto.nextBlock(definition.body.expression.fullCopy());
         proto.nextBlock(isLive ? definition.body.expression   // v 4.0.10.2
                : definition.body.expression.fullCopy()
        );
        proto.nextBlock().isDraggable = definition.body.expression.isDraggable; //fix the top block's isDraggable status -- snapHE.gr  
    }

    scripts.add(proto);
    proto.fixBlockColor(null, true);
    proto.drawNew();
	
     this.definition.scripts.forEach(function (element) {        
        block = element.fullCopy();
        block.setPosition(scripts.position().add(element.position()));
        scripts.add(block);
        if (block instanceof BlockMorph) {
            block.allComments().forEach(function (comment) {
                comment.align(block);
            });
        }
    });
    proto.allComments().forEach(function (comment) {
        comment.align(proto);
    });

    scriptsFrame = new ScrollFrameMorph(scripts);
    scriptsFrame.padding = 10;
    scriptsFrame.growth = 50;
    scriptsFrame.isDraggable = false;
    scriptsFrame.acceptsDrops = false;
    scriptsFrame.contents.acceptsDrops = true;
    scripts.scrollFrame = scriptsFrame;
    scripts.updateToolbar();

    this.addBody(scriptsFrame);
    this.addButton('ok', 'OK');
    if (!isLive) {  // v 4.0.10.2
        this.addButton('updateDefinition', 'Apply');
        this.addButton('cancel', 'Cancel');
    }

    this.setExtent(new Point(375, 300)); // normal initial extent
    this.fixLayout();
    scripts.fixMultiArgs();

    block = proto.parts()[0];
    block.forceNormalColoring();
    block.fixBlockColor(proto, true);
};

BlockEditorMorph.prototype.updateDefinition = function () {
    var head, ide,
        pos = this.body.contents.position(),
        element,
        myself = this,
		depositoryblock =['custom-block',this.definition.blockSpec(),this.definition.category], //handle hiddens
		idx, //handle hiddens
		oldSpec = this.definition.blockSpec(); //for restoring
		
    this.definition.receiver = this.target; // only for serialization
    this.definition.spec = this.prototypeSpec();
    this.definition.declarations = this.prototypeSlots();
    this.definition.variableNames = this.variableNames();
    this.definition.scripts = [];
    this.definition.editorDimensions = this.bounds.copy();
    this.definition.cachedIsRecursive = null; // flush the cache, don't update
   
    this.body.contents.children.forEach(function (morph) {
        if (morph instanceof PrototypeHatBlockMorph) {
            head = morph;
        } else if (morph instanceof BlockMorph ||
                (morph instanceof CommentMorph && !morph.block)) {          
            element = morph.fullCopy();
            element.parent = null;
            element.setPosition(morph.position().subtract(pos));
            myself.definition.scripts.push(element);
        }
    });

    if (head) {
        if (this.definition.category !== head.blockCategory) {
            this.target.shadowAttribute('scripts');
        }
        this.definition.category = head.blockCategory;
        this.definition.type = head.type;
        if (head.comment) {
            this.definition.comment = head.comment.fullCopy();
            this.definition.comment.block = true; // serialize in short form
        } else {
            this.definition.comment = null;
        }
    }

    this.definition.body = this.context(head);
    if (this.definition.body !== null){
        this.definition.body.expression.isDraggable = head.nextBlock().isDraggable; //fix the top block's isDraggable status -- snapHE.gr
    }
    this.refreshAllBlockInstances(oldSpec);

    ide = this.target.parentThatIsA(IDE_Morph);
//handle hiddens         
	idx = indexOf(ide.stage.depositoryCommands, depositoryblock);
	
	if (this.definition.spec.indexOf("$$")==0) {          
		if (world.role === 'STUDENT'){
			ide.stage.inform("Custom block name can not start with $$"); // Do not allow student to create hidden block by accident
			this.definition.spec = oldSpec; // restore the name
		} else {
			if (!this.definition.isHidden){ //if the new block has $$ in front, and was not hidden, hide it and delete it from depository
				this.definition.isHidden = true;
				if (idx !== -1) {
					ide.stage.depositoryCommands.splice(idx, 1);
					ide.flushBlocksCache('depository');
				}
			}
		}	
	} else {
		if (this.definition.isHidden) {   //if the block was hidden, then show it
			this.definition.isHidden = false;
			ide.flushBlocksCache(this.definition.category);
		} else 	if (idx != -1){ //update depository if custom command is in there, in case we have an already shown block and we just changed it ** bug correction
					ide.stage.depositoryCommands[idx] = ['custom-block',this.definition.blockSpec(),this.definition.category]
					ide.flushBlocksCache('depository');
				}
	}
//handle hiddens end

    ide.flushPaletteCache();
    ide.refreshPalette();
};
// modified for dealing with undraggable block instances label color
BlockEditorMorph.prototype.refreshAllBlockInstances = function (oldSpec) {
    var def = this.definition,
        template = this.target.paletteBlockInstance(def);

    if (this.definition.isGlobal) {
        this.target.allBlockInstances(this.definition).forEach(
            function (block) {
                block.refresh();
                block.fixLabelColor(); // fix label color(in case it's undraggable)
            }
        );
    } else {
        this.target.allDependentInvocationsOf(oldSpec).forEach(
            function (block) {
                block.refresh(def);
                block.fixLabelColor(); // fix label color(in case it's undraggable)
            }
        );
    }
    if (template) {
        template.refreshDefaults();
    }
};

// inherits the original PrototypeHatBlockMorph but can make the hat block read-only
PrototypeHatBlockMorphNew.prototype.constructor = PrototypeHatBlockMorphNew;
PrototypeHatBlockMorphNew.prototype = Object.create(PrototypeHatBlockMorph.prototype)

function PrototypeHatBlockMorphNew(definition,isReadOnly) {
    this.init(definition,isReadOnly);     //--++
}

PrototypeHatBlockMorphNew.prototype.init = function (definition,isReadOnly) {
    var proto = definition.prototypeInstance(isReadOnly),
        vars;

    this.definition = definition;

    // additional attributes to store edited data
    this.blockCategory = definition ? definition.category : null;
    this.type = definition ? definition.type : null;

    // init inherited stuff
    HatBlockMorph.uber.init.call(this);
    this.color = SpriteMorph.prototype.blockColor.control;
    this.category = 'control';
    this.add(proto);
    if (definition.variableNames.length) {
        vars = this.labelPart('%blockVars');
        this.add(this.labelPart('%br'));
        this.add(vars);
        definition.variableNames.forEach(function (name) {
            vars.addInput(name);
        });
    }
    proto.refreshPrototypeSlotTypes(); // show slot type indicators
    this.fixLayout();
	return this;
};

//create the dialog with the exported blocks, Modified to prevent student from exporting hidden blocks and to support custom categories
BlockExportDialogMorph.prototype.buildContents = function () {
    var palette, x, y, block, checkBox, lastCat,
        myself = this,
        padding = 4;

    // create plaette
    palette = new ScrollFrameMorph(
        null,
        null,
        SpriteMorph.prototype.sliderColor
    );
    palette.color = SpriteMorph.prototype.paletteColor;
    palette.padding = padding;
    palette.isDraggable = false;
    palette.acceptsDrops = false;
    palette.contents.acceptsDrops = false;

    // populate palette
    x = palette.left() + padding;
    y = palette.top() + padding;
    SpriteMorph.prototype.categories().forEach(function (category) {  //--just the categories fix
        myself.blocks.forEach(function (definition) {
            if (definition.category === category && !(world.role=='STUDENT' && definition.isHidden)) { //--do not allow student to export hidden blocks
                if (lastCat && (category !== lastCat)) {
                    y += padding;
                }
                lastCat = category;
                block = definition.templateInstance();
                checkBox = new ToggleMorph(
                    'checkbox',
                    myself,
                    function () {
                        var idx = myself.blocks.indexOf(definition);
                        if (idx > -1) {
                            myself.blocks.splice(idx, 1);
                        } else {
                            myself.blocks.push(definition);
                        }
                    },
                    null,
                    function () {
                        return contains(
                            myself.blocks,
                            definition
                        );
                    },
                    null,
                    null,
                    null,
                    block.fullImage()
                );
                checkBox.setPosition(new Point(
                    x,
                    y + (checkBox.top() - checkBox.toggleElement.top())
                ));
                palette.addContents(checkBox);
                y += checkBox.fullBounds().height() + padding;
            }
        });
    });

    palette.scrollX(padding);
    palette.scrollY(padding);
    this.addBody(palette);

    this.addButton('ok', 'OK');
    this.addButton('cancel', 'Cancel');

    this.setExtent(new Point(220, 300));
    this.fixLayout();

};

//modified to add the custom categories tag
BlockExportDialogMorph.prototype.exportBlocks = function () {
    var str = this.serializer.serialize(this.blocks),
        ide = this.world().children[0],
		catArray=[]; //for the custom categories tag, contains the custom category names and the number of blocks they contain

    if (this.blocks.length > 0) {
//populate the catArray
		this.blocks.forEach(function (el){
			if (contains(SpriteMorph.prototype.customCategories, el.category)){ //if the block belongs to a custom category, add the category to the array
				/*if (catArray[el.category]){ //if category already added, just increase the count
					catArray[el.category]++;
				} else{
					catArray[el.category] = 1; // else add it to the array	
				}*/
				if (!contains(catArray,el.category)){
					catArray.push(el.category);
				}
			}	
		});	
/////////////////////////////////////        
	str = '<blocks app="'
            + this.serializer.app
            + '" version="'
            + this.serializer.version
            + '">'
            + str
			+ this.serializer.format('<customCategories>%</customCategories>',  //add the custom categories tag
									  SpriteMorph.prototype.customCategoriestoXML(this.serializer,catArray)
									)
            + '</blocks>';
        ide.saveXMLAs(
            str,
            ide.projectName || localize('Untitled') + ' ' + localize('blocks')
        );
    } else {
        new DialogBoxMorph().inform(
            'Export blocks',
            'no blocks were selected',
            this.world()
        );
    }
};

BlockRemovalDialogMorph.prototype.buildContents
    = BlockExportDialogMorph.prototype.buildContents;

/*
//modified for supporting custom categories	
BlockRemovalDialogMorph.prototype.removeBlocks = function () {
    var ide = this.target.parentThatIsA(IDE_Morph);
    if (!ide) {return; }
    if (this.blocks.length > 0) {
        this.blocks.forEach(function (def) {
            var idx = ide.stage.globalBlocks.indexOf(def);
            if (idx !== -1) {
                ide.stage.globalBlocks.splice(idx, 1);
            }
        });
        ide.flushPaletteCache();
        ide.refreshPalette();
        ide.showMessage(
            this.blocks.length + ' ' + localize('unused block(s) removed'),
            2
        );
    } else {
        new DialogBoxMorph().inform(
            'Remove unused blocks',
            'no blocks were selected',
            this.world()
        );
    }
};
*/
//remove the annoyin help bubbles from custom blocks
CustomCommandBlockMorph.prototype.mouseEnter = nop;
CustomCommandBlockMorph.prototype.mouseLeave = nop;
CustomCommandBlockMorph.prototype.bubbleHelp = nop;
CustomCommandBlockMorph.prototype.popUpbubbleHelp = nop;