var host = location.href.substr(0, location.href.substr(0,location.href.indexOf('.html')).lastIndexOf('/')) ;  // define the host path of the application

var originalIDEinit = IDE_Morph.prototype.init,
    originalIDEdroppedText = IDE_Morph.prototype.droppedText;

IDE_Morph.prototype.init = function (isAutoFill) {
	originalIDEinit.call(this,isAutoFill);
	this.cloudPublic = null;  //++ the cloud project is public
	this.cloudPath = ''; //++ the cloud path for the administrator
        this.firstProject = true; //for the HOC mode. not to send project_loaded event in the first time.
    this.logoURL = 'snap_he_logo.png';	 
};
///////////////////////////////////////////////////////returns the first not secret sprite or the stage or null if everything is secret
IDE_Morph.prototype.chooseSprite = function (slist,stage){   
	var index=-1,i;
	if (world.role!=='STUDENT') {
		return (slist[0] || stage);
	} else {
		for ( i=0; i<slist.length && slist[i].isSecret; i++) {index=i;}
		index++;
		if (index<slist.length) {return slist[index];}
		else {return stage;}
			
	}
}
//////////////////////////////////////////////////////
IDE_Morph.prototype.openIn = function (world) {
    var hash, usr, myself = this, urlLanguage = null, msg;
	
	this.userLanguage = world.HOCmode ? "el" : this.userLanguage; //force language to Greek in Hour Of Code mode
	
	if (world.HOCmode){
		this.setFlatDesign();
	 }	
	 
    this.buildPanes();
    world.add(this);
    world.userMenu = this.userMenu;

    // get persistent user data, if any
    if (localStorage) {
        usr = localStorage['-snap-user'];
        if (usr) {
            usr = SnapCloud.parseResponse(usr)[0];
            if (usr) {
                SnapCloud.username = usr.username || null;
                SnapCloud.password = usr.password || null;
            }
        }
    }



    // prevent non-DialogBoxMorphs from being dropped
    // onto the World in user-mode
    world.reactToDropOf = function (morph) {
        if (!(morph instanceof DialogBoxMorph)) {
            if (world.hand.grabOrigin) {
                morph.slideBackTo(world.hand.grabOrigin);
            } else {
                world.hand.grab(morph);
            }
        }
    };


    this.reactToWorldResize(world.bounds);

    function getURL(url) {
        try {
            var request = new XMLHttpRequest();
            request.open('GET', url, false);
            request.send();
            if (request.status === 200) {
                return request.responseText;
            }
            throw new Error('unable to retrieve ' + url);
        } catch (err) {
            return;
        }
    }

   

    function interpretUrlAnchors() {
        var dict,project_string;
		
        if (location.hash.substr(0, 6) === '#open:') {
            hash = location.hash.substr(6);
            if (hash.charAt(0) === '%'
                    || hash.search(/\%(?:[0-9a-f]{2})/i) > -1) {
                hash = decodeURIComponent(hash);
            }
            if (contains(
                    ['project', 'blocks', 'sprites', 'snapdata'].map(
                        function (each) {
                            return hash.substr(0, 8).indexOf(each);
                        }
                    ),
                    1
                )) {
                this.droppedText(hash);
            } else {
                this.droppedText(getURL(hash));
            }
        } else if (location.hash.substr(0, 5) === '#run:') {
            hash = location.hash.substr(5);
            if (hash.charAt(0) === '%'
                    || hash.search(/\%(?:[0-9a-f]{2})/i) > -1) {
                hash = decodeURIComponent(hash);
            }  
//+++++++++
			this.shield = new Morph();
            this.shield.color = this.color;
            this.shield.setExtent(this.parent.extent());
            this.parent.add(this.shield);
//+++++++++

			myself.nextSteps([
				function () { msg = myself.showMessage('running project'); },
				function () {            
					if (hash.substr(0, 8) === '<project>') {
						myself.rawOpenProjectString(hash);
					} else {
						project_string = getURL(hash);//host+'/apps/'+hash);
						myself.rawOpenProjectString(project_string);
						myself.loadNewProject = false;
					}
				},
				function () { 
					myself.shield.destroy();
					myself.shield = null;
					msg.destroy();	
					myself.controlBar.appModeButton.hide(); //+++
					myself.toggleAppMode(true);
					myself.runScripts();
				}
			]);  //+++++++++++++
        } else if (location.hash.substr(0, 9) === '#present:') {
            hash = location.hash.substr(9);
            if (hash.charAt(0) === '%'
                    || hash.search(/\%(?:[0-9a-f]{2})/i) > -1) {
                hash = decodeURIComponent(hash);
            }  
//+++++++++
			this.shield = new Morph();
            this.shield.color = this.color;
            this.shield.setExtent(this.parent.extent());
            this.parent.add(this.shield);
//+++++++++

			myself.nextSteps([
				function () { msg = myself.showMessage('opening presentation'); },
				function () {            
						if (hash.substr(0, 8) === '<project>') {
							myself.rawOpenProjectString(hash);
						} else {
							project_string = getURL(host+'/studentproj/'+hash)
							myself.rawOpenProjectString(project_string);
							myself.loadNewProject = false;
						}
				},
				function () { 
						myself.shield.destroy();
						myself.shield = null;
						msg.destroy();	
				//		myself.controlBar.appModeButton.hide(); //+++
						myself.toggleAppMode(true);
						myself.runScripts();
				}
			]);  //+++++++++++++

        } else if (location.hash.substr(0, 6) === '#lang:') {
	
            urlLanguage = location.hash.substr(6);
			this.setLanguage(urlLanguage);
			this.loadNewProject = true;            
            } 
		
    }

    if (this.userLanguage) {
		//this.loadNewProject = true;  
        this.setLanguage(this.userLanguage,interpretUrlAnchors);
    } else {

        interpretUrlAnchors.call(this);
    }
	
	if (world.HOCmode){ // Deal with Hour Of Code mode	
		window.addEventListener("load_project", function(evt){ //handle the project to load, triggered by the container page in HOC mode		
			if (myself.world().HOCmode) {
                                myself.firstProject = false;    
				if (evt.detail.URL == ""){
					myself.newProject(true);	
				} else {
					myself.droppedText(getURL(evt.detail.URL));
				}			
			}
		});
		
	}
};

// IDE_Morph construction
IDE_Morph.prototype.createControlBar = function () {
    // assumes the logo has already been created
    var padding = 5,
        button,
        stopButton,
        pauseButton,
        startButton,
        projectButton,
        settingsButton,
        stageSizeButton,
        appModeButton,
        cloudButton,
        x,
        colors = [
            this.groupColor,
            this.frameColor.darker(50),
            this.frameColor.darker(50)
        ],
        myself = this;

    if (this.controlBar) {
        this.controlBar.destroy();
    }

    this.controlBar = new Morph();
    this.controlBar.color = this.frameColor;
    this.controlBar.setHeight(this.logo.height()); // height is fixed
    this.controlBar.mouseClickLeft = function () {
        this.world().fillPage();
    };
    this.add(this.controlBar);

    //smallStageButton
    button = new ToggleButtonMorph(
        null, //colors,
        myself, // the IDE is the target
        'toggleStageSize',
        [
            new SymbolMorph('smallStage', 14),
            new SymbolMorph('normalStage', 14)
        ],
        function () {  // query
            return myself.isSmallStage;
        }
    );

    button.corner = 12;
    button.color = colors[0];
    button.highlightColor = colors[1];
    button.pressColor = colors[2];
    button.labelMinExtent = new Point(36, 18);
    button.padding = 0;
    button.labelShadowOffset = new Point(-1, -1);
    button.labelShadowColor = colors[1];
    button.labelColor = this.buttonLabelColor;
    button.contrast = this.buttonContrast;
    button.drawNew();
    // button.hint = 'stage size\nsmall & normal';
    button.fixLayout();
    button.refresh();
    stageSizeButton = button;
    this.controlBar.add(stageSizeButton);
    this.controlBar.stageSizeButton = button; // for refreshing

    //appModeButton
    button = new ToggleButtonMorph(
        null, //colors,
        myself, // the IDE is the target
        'toggleAppMode',
        [
            new SymbolMorph('fullScreen', 14),
            new SymbolMorph('normalScreen', 14)
        ],
        function () {  // query
            return myself.isAppMode;
        }
    );

    button.corner = 12;
    button.color = colors[0];
    button.highlightColor = colors[1];
    button.pressColor = colors[2];
    button.labelMinExtent = new Point(36, 18);
    button.padding = 0;
    button.labelShadowOffset = new Point(-1, -1);
    button.labelShadowColor = colors[1];
    button.labelColor = this.buttonLabelColor;
    button.contrast = this.buttonContrast;
    button.drawNew();
    // button.hint = 'app & edit\nmodes';
    button.fixLayout();
    button.refresh();
    appModeButton = button;
    this.controlBar.add(appModeButton);
    this.controlBar.appModeButton = appModeButton; // for refreshing

    // stopButton
    button = new ToggleButtonMorph(
        null, // colors
        this, // the IDE is the target
        'stopAllScripts',
        [
            new SymbolMorph('octagon', 14),
            new SymbolMorph('square', 14)
        ],
        function () {  // query
            return myself.stage ?
                    myself.stage.enableCustomHatBlocks &&
                        myself.stage.threads.pauseCustomHatBlocks
                        : true;
        }
    );

    button.corner = 12;
    button.color = colors[0];
    button.highlightColor = colors[1];
    button.pressColor = colors[2];
    button.labelMinExtent = new Point(36, 18);
    button.padding = 0;
    button.labelShadowOffset = new Point(-1, -1);
    button.labelShadowColor = colors[1];
    button.labelColor = new Color(200, 0, 0);
    button.contrast = this.buttonContrast;
    button.drawNew();
    // button.hint = 'stop\nevery-\nthing';
    button.fixLayout();
    button.refresh();
    stopButton = button;
    this.controlBar.add(stopButton);
    this.controlBar.stopButton = stopButton; // for refreshing

    //pauseButton
    button = new ToggleButtonMorph(
        null, //colors,
        this, // the IDE is the target
        'togglePauseResume',
        [
            new SymbolMorph('pause', 12),
            new SymbolMorph('pointRight', 14)
        ],
        function () {  // query
            return myself.isPaused();
        }
    );

    button.corner = 12;
    button.color = colors[0];
    button.highlightColor = colors[1];
    button.pressColor = colors[2];
    button.labelMinExtent = new Point(36, 18);
    button.padding = 0;
    button.labelShadowOffset = new Point(-1, -1);
    button.labelShadowColor = colors[1];
    button.labelColor = new Color(255, 220, 0);
    button.contrast = this.buttonContrast;
    button.drawNew();
    // button.hint = 'pause/resume\nall scripts';
    button.fixLayout();
    button.refresh();
    pauseButton = button;
    this.controlBar.add(pauseButton);
    this.controlBar.pauseButton = pauseButton; // for refreshing

    // startButton
    button = new PushButtonMorph(
        this,
        'pressStart',
        new SymbolMorph('flag', 14)
    );
    button.corner = 12;
    button.color = colors[0];
    button.highlightColor = colors[1];
    button.pressColor = colors[2];
    button.labelMinExtent = new Point(36, 18);
    button.padding = 0;
    button.labelShadowOffset = new Point(-1, -1);
    button.labelShadowColor = colors[1];
    button.labelColor = new Color(0, 200, 0);
    button.contrast = this.buttonContrast;
    button.drawNew();
    // button.hint = 'start green\nflag scripts';
    button.fixLayout();
    startButton = button;
    this.controlBar.add(startButton);
    this.controlBar.startButton = startButton;
                                        
    if (!world.HOCmode){ //<======================== official site
        // projectButton
        button = new PushButtonMorph(
            this,
            'projectMenu',
            new SymbolMorph('file', 14)
            //'\u270E'
        );
   
    button.corner = 12;
    button.color = colors[0];
    button.highlightColor = colors[1];
    button.pressColor = colors[2];
    button.labelMinExtent = new Point(36, 18);
    button.padding = 0;
    button.labelShadowOffset = new Point(-1, -1);
    button.labelShadowColor = colors[1];
    button.labelColor = this.buttonLabelColor;
    button.contrast = this.buttonContrast;
    button.drawNew();
    // button.hint = 'open, save, & annotate project';
    button.fixLayout();
    projectButton = button;
    this.controlBar.add(projectButton);
    this.controlBar.projectButton = projectButton; // for menu positioning
    }
    
    // settingsButton
    button = new PushButtonMorph(
        this,
        'settingsMenu',
        new SymbolMorph('gears', 14)
        //'\u2699'
    );
    button.corner = 12;
    button.color = colors[0];
    button.highlightColor = colors[1];
    button.pressColor = colors[2];
    button.labelMinExtent = new Point(36, 18);
    button.padding = 0;
    button.labelShadowOffset = new Point(-1, -1);
    button.labelShadowColor = colors[1];
    button.labelColor = this.buttonLabelColor;
    button.contrast = this.buttonContrast;
    button.drawNew();
    // button.hint = 'edit settings';
    button.fixLayout();
    settingsButton = button;
    this.controlBar.add(settingsButton);
    this.controlBar.settingsButton = settingsButton; // for menu positioning

    // cloudButton
    button = new PushButtonMorph(
        this,
        'networkMenu',
        new SymbolMorph('network', 11)
    );
    button.corner = 12;
    button.color = colors[0];
    button.highlightColor = colors[1];
    button.pressColor = colors[2];
    button.labelMinExtent = new Point(36, 18);
    button.padding = 0;
    button.labelShadowOffset = new Point(-1, -1);
    button.labelShadowColor = colors[1];
    button.labelColor = this.buttonLabelColor;
    button.contrast = this.buttonContrast;
    button.drawNew();
    // button.hint = 'cloud operations';
	//button.hide();
    button.fixLayout();
    cloudButton = button;	
    this.controlBar.add(cloudButton);
    this.controlBar.cloudButton = cloudButton; // for menu positioning

    this.controlBar.fixLayout = function () {
        x = this.right() - padding;
        [stopButton, pauseButton, startButton].forEach(
            function (button) {
                button.setCenter(myself.controlBar.center());
                button.setRight(x);
                x -= button.width();
                x -= padding;
            }
        );

        x = Math.min(
            startButton.left() - (3 * padding + 2 * stageSizeButton.width()),
            myself.right() - StageMorph.prototype.dimensions.x *
                (myself.isSmallStage ? myself.stageRatio : 1)
        );
        [stageSizeButton, appModeButton].forEach(
            function (button) {
                x += padding;
                button.setCenter(myself.controlBar.center());
                button.setLeft(x);
                x += button.width();
            }
        );

        settingsButton.setCenter(myself.controlBar.center());
        settingsButton.setLeft(this.left());

        cloudButton.setCenter(myself.controlBar.center());
        cloudButton.setLeft(settingsButton.right() + padding);
        if (!world.HOCmode){ //<======================== official site
            projectButton.setCenter(myself.controlBar.center());
            projectButton.setRight(settingsButton.left() - padding);
        }
        this.updateLabel();
    };

    this.controlBar.updateLabel = function () {
        var suffix = myself.world().isDevMode ?
                ' - ' + localize('development mode') : '';

        if (this.label) {
            this.label.destroy();
        }
        if (myself.isAppMode) {
            return;
        }

        this.label = new StringMorph(
            (myself.projectName || localize('untitled')) + suffix,
            14,
            'sans-serif',
            true,
            false,
            false,
            MorphicPreferences.isFlat ? null : new Point(2, 1),
            myself.frameColor.darker(myself.buttonContrast)
        );
        this.label.color = myself.buttonLabelColor;
        this.label.drawNew();
        this.add(this.label);
        this.label.setCenter(this.center());
        this.label.setLeft(this.cloudButton.right() + padding);
    };
};

IDE_Morph.prototype.createCategories = function () {
    // assumes the logo has already been created
    var myself = this;

    if (this.categories) {
        this.categories.destroy();
    }
    this.categories = new Morph();
    this.categories.color = this.groupColor;
    this.categories.silentSetWidth(this.logo.width()); // width is fixed

    function addCategoryButton(category) {
        var labelWidth = 75,
            colors = [
                myself.frameColor,
                myself.frameColor.darker(50),
                SpriteMorph.prototype.blockColor[category]
            ],
            button;
//------------------------ Set the depository category button
		if (category=='depository') {labelWidth = 168;}
//------------------------
        button = new ToggleButtonMorph(
            colors,
            myself, // the IDE is the target
            function () {
                myself.currentCategory = category;
                myself.categories.children.forEach(function (each) {
                    each.refresh();
                });
                myself.refreshPalette(true);
            },
            category[0].toUpperCase().concat(category.slice(1)), // label
            function () {  // query
                return myself.currentCategory === category;
            },
            null, // env
            null, // hint
            null, // template cache
            labelWidth, // minWidth
            true // has preview
        );
		if (world.role !== 'STUDENT' && SpriteMorph.prototype.hiddenStandardCategories.indexOf(category) >=0) { //custom categories
		 	button.alpha = 0.1;  // if its a hidden standard category faint in development mode
		}  //custom categories end
        button.corner = 8;
        button.padding = 0;
        button.labelShadowOffset = new Point(-1, -1);
        button.labelShadowColor = colors[1];
        button.labelColor = myself.buttonLabelColor;
        button.fixLayout();
        button.refresh();
		button.category = category; //store the category for seperating standard from custom categories
		//set the menu
		if (category!=='depository'){
				button.userMenu = function(){ return catMenu(button,category) };
			}
        myself.categories.add(button);		
        return button;
    }

    function fixCategoriesLayout() {
        var buttonWidth , // 
            buttonHeight , //
            border ,  //
            rows =  Math.ceil((myself.categories.children.length) / 2),
            xPadding , //
            yPadding , //
            l = myself.categories.left(),
            t = myself.categories.top(),
            i = 0,
            row,
            col;

		buttonWidth = myself.categories.children.length>0 ? Math.min(81,myself.categories.children[0].width()) : 81;	//
		border = 	myself.categories.children.length>0 ? 3 : 0 ;														//
		xPadding = (myself.categories.width()																			//
                - border																								//	in case of no visible categories	
                - buttonWidth * 2) / 3 ;																				//	
		buttonHeight = myself.categories.children.length>0 ? myself.categories.children[0].height()	: 0 ;				//
		yPadding = 	myself.categories.children.length>0 ? 2 : 0 ;														//
		
        myself.categories.children.forEach(function (button) {
            i += 1;
            row = Math.ceil(i / 2);
            col = 2 - (i % 2);
			if (button.labelString == 'Depository' && col == 2) { col = 1; row +=1; rows +=1;}  //custom categories   put the depository(wide) button in a single row
            button.setPosition(new Point(
                l + (col * xPadding + ((col - 1) * buttonWidth)),
                t + (row * yPadding + ((row - 1) * buttonHeight) + border)
            ));
        });

        myself.categories.setHeight(
            (rows + 1) * yPadding
                + rows * buttonHeight
                + 2 * border
        );
    }
	
	//checks if there are global blocks in a category
	function hasGlobalBlocks(category){
		var categories = category == 'variables' ? ['variables','lists','other'] : [category];
		return myself.stage.globalBlocks.some(function(any){
			return contains(categories,any.category);
		});
	}
	
	//checks if a sprite has custom blocks in a category, sprite is optional, missing means any sprite
	function hasCustomBlocks(category,sprite){
		var categories = category == 'variables' ? ['variables','lists','other'] : [category];
		if (sprite){
			return sprite.customBlocks.some(function(any){
				return contains(categories,any.category);
			});
		} else{
			return myself.sprites.asArray().some(function(spr){
				return spr.customBlocks.some(function(any){
					return contains(categories,any.category);
				});				
			});
		}		
	}
	
	//returns the global custom blocks of the category. Used in export category menu
	function categoryBlocks(category){
		return myself.stage.globalBlocks.filter(function (definition){
			return definition.category == category && !definition.isHidden;
		});
		
	}
	
// menu constructors	
	function catMenu(button,category){
		var menu = new MenuMorph();
			
		if (!isNil(button)) { //null button means the menu is created for the category frame
			if (contains(SpriteMorph.prototype.standardCategories,category) && world.role !== 'STUDENT'){ //if it is a standard category and not in STUDENT mode
				if (contains(SpriteMorph.prototype.hiddenStandardCategories,category)) { // if it is a hidden standard category
					menu.addItem(
						'show',
						function(){
								var count = category=='variables' ? 3 : 1 ; //when variables shown so does lists and other
									SpriteMorph.prototype.hiddenStandardCategories.splice(
										SpriteMorph.prototype.hiddenStandardCategories.indexOf(category),count);
								button.alpha = 1;
								button.changed();		
								}
					);
				} else {
					menu.addItem(
						'hide',
						function(){
									SpriteMorph.prototype.hiddenStandardCategories.push(category);
									if (category == 'variables') {  //when variables hidden this also happens to lists and other
										SpriteMorph.prototype.hiddenStandardCategories.push('lists');
										SpriteMorph.prototype.hiddenStandardCategories.push('other');
										}
									button.alpha = 0.1;
									button.changed();
								}
					);
				} 
				menu.addLine();	
			} else { 
				if (contains(SpriteMorph.prototype.customCategories,category)) {	// if it is a custom category	
					if (!hasGlobalBlocks(category) && !hasCustomBlocks(category)) {
						menu.addItem(
							'delete',
							function(){
								SpriteMorph.prototype.customCategories.splice(
									SpriteMorph.prototype.customCategories.indexOf(category),1);
								delete SpriteMorph.prototype.blockColor[category];
								delete SpriteMorph.prototype.customCategories[category];
								myself.createCategories();										
								myself.fixLayout();
								if (myself.currentCategory == category) { //if the deleted category was the current, select a new one
									myself.currentCategory = SpriteMorph.prototype.categories()[0]; // the first category in the list (depository or motion)
									myself.refreshPalette(true);
								}
							}
						);
						menu.addLine();		
					}	
				}
						
			}
		} else{
			if (world.role!=='STUDENT'){ //add hide/show all for the teacher 
				if (SpriteMorph.prototype.hiddenStandardCategories.length>0) { // if there all hidden standard categories
					menu.addItem(
						'show all',
						function(){
							SpriteMorph.prototype.hiddenStandardCategories=[]; //empty the hidden standard categories
							myself.categories.children.forEach(function (button) {
																if (button.labelString !== 'Depository'){	
																	button.alpha = 1;
																	button.changed();
																}
															});								
						}
					);
				}
				if (SpriteMorph.prototype.hiddenStandardCategories.length<10) {	
					menu.addItem(
						'hide all',
						function(){
							var excludedCats = SpriteMorph.prototype.customCategories.concat('depository');
							SpriteMorph.prototype.hiddenStandardCategories = SpriteMorph.prototype.standardCategories.slice(); //fill the hidden standard categories
							myself.categories.children.forEach(function (button) {
																	if (!contains(excludedCats,button.category)){	
																		button.alpha = 0.1;
																		button.changed();
																	}
																});	
						}
					);
				} 
				menu.addLine();	
			}
		}
		if (!isNil(category)){ 
			if (!world.HOCmode){ //if not in HOC mode, export the global blocks of the category
					if (hasGlobalBlocks(category)){	
						menu.addItem(
							'export..',
							function () {
								var blocks= categoryBlocks(category),
									str,
									catArray = [category], customCategoryStr;
									//catArray[category] = blocks.length;
									customCategoryStr = contains(SpriteMorph.prototype.customCategories,category)
														? myself.serializer.format('<customCategories>%</customCategories>',  //add the custom categories tag
																					SpriteMorph.prototype.customCategoriestoXML(myself.serializer,catArray)
																					)
														:'';
										str = '<blocks app="'
											+ myself.serializer.app
											+ '" version="'
											+ myself.serializer.version
											+ '">'
											+ myself.serializer.serialize(blocks)
											+ customCategoryStr
											+ '</blocks>';
										myself.saveXMLAs(
											str,
											localize(category) 
										);
								}
						);
					}
				}
		}
		// add the create category ability, to all buttons		
		menu.addItem(
			'create category',
			function () {
			var dlg;
				dlg = new DialogBoxMorph(null,
						function(){
						var clr=null,
						name =dlg.getInput() ;
							if (dlg.head instanceof ColorSlotMorph)
								{clr = dlg.head.evaluate();}
							if (clr && name){
								name=name.substr(0,10).replace(/ /g,'_').toLowerCase();
								if (SpriteMorph.prototype.customCategories.indexOf(name)<0) {		
									SpriteMorph.prototype.customCategories.push(name);
									SpriteMorph.prototype.blockColor[name] = clr;
									myself.createCategories();
									myself.fixLayout();
								} else {myself.world().inform('The category already exists!');}	
							}		
					}
						,myself);
				dlg.addHead(new ColorSlotMorph());
				dlg.prompt('Create a category',null, myself.world());
			}
		);
		
		return  menu;
	}
// end menu constructors	
    SpriteMorph.prototype.categories().forEach(function (cat) { 
		if (!contains(['lists', 'other'], cat) && !(world.role==='STUDENT' && cat === 'depository')) {
			addCategoryButton(cat);				
		} 
	});   
// add menu for categories morph
	this.categories.userMenu = function() { return catMenu(); };
////////////////////////////////	
    fixCategoriesLayout();
    this.add(this.categories);
};

IDE_Morph.prototype.createPalette = function (forSearching) {
    // assumes that the logo pane has already been created
    // needs the categories pane for layout
    var myself = this,
		frame;  // for hidden vars

    if (this.palette) {
        this.palette.destroy();
    }
//////////////////////////////////////
if (this.currentSprite == null) {
return;
} else{
//////////////////////////////////////  
	 if (forSearching) {
        this.palette = new ScrollFrameMorph(
            null,
            null,
            this.currentSprite.sliderColor
        );
    } else {	
		this.palette = this.currentSprite.palette(this.currentCategory);		
	}
    this.palette.isDraggable = false;
    this.palette.acceptsDrops = true;
    this.palette.contents.acceptsDrops = false;

    this.palette.reactToDropOf = function (droppedMorph) {
        if (droppedMorph instanceof DialogBoxMorph) {
            myself.world().add(droppedMorph);
        } else if (droppedMorph instanceof SpriteMorph) {

            myself.removeSprite(droppedMorph);
        } else if (droppedMorph instanceof SpriteIconMorph) {
			droppedMorph.destroy();
		    myself.removeSprite(droppedMorph.object);
			myself.currentSprite = myself.chooseSprite(myself.stage.children,myself.stage);
///////////////////////////////// to correct the bug for selectin the next avail icon
			myself.selectSprite(myself.currentSprite);  /////////////////////
			} else if (droppedMorph instanceof CostumeIconMorph) {
            myself.currentSprite.wearCostume(null);
            droppedMorph.destroy();
        } else {
            droppedMorph.destroy();
        }
    };

    this.palette.setWidth(this.logo.width());
    this.add(this.palette);
    this.palette.scrollX(this.palette.padding);
    this.palette.scrollY(this.palette.padding);

	this.palette.contents.children.forEach(function (s) {				//
		if (StageMorph.prototype.hiddenPrimitives[s.selector]) {s.hide();}  //---------------- faint the hidden
		if (s.selector=='reportGetVar') { 									//
			frame=myself.currentSprite.variables.find(s.blockSpec); 			// --- faint the hidden variables
			if (frame.hiddenVars[s.blockSpec]){s.hide();}      				//
		}																	//	
		if (s.selector=='evaluateCustomBlock') { 							// --- faint the hidden custom blocks
			if (s.definition.isHidden) {s.hide();}								//
		}																	//
		if (s instanceof ToggleMorph) {s.refresh();}						// --- refresh the watcher toggle checkboxes //handle hiddens
	});																	//	
	return this.palette;
	} ////////////////////////////////////////////////////
};


IDE_Morph.prototype.createSpriteBar = function () {
    // assumes that the categories pane has already been created
    var rotationStyleButtons = [],
        thumbSize = new Point(45, 45),
        nameField,
        padlock,
        thumbnail,
        tabCorner = 15,
        tabColors = this.tabColors,
        tabBar = new AlignmentMorph('row', -tabCorner * 2),
        tab,
        myself = this;

    if (this.spriteBar) {
        this.spriteBar.destroy();
    } 

    this.spriteBar = new Morph();
    this.spriteBar.color = this.frameColor;
	this.add(this.spriteBar);
 
    function addRotationStyleButton(rotationStyle) {
        var colors = myself.rotationStyleColors,
            button;

        button = new ToggleButtonMorph(
            colors,
            myself, // the IDE is the target
            function () {
                if (myself.currentSprite instanceof SpriteMorph) {
                    myself.currentSprite.rotationStyle = rotationStyle;
                    myself.currentSprite.changed();
                    myself.currentSprite.drawNew();
                    myself.currentSprite.changed();
                }
                rotationStyleButtons.forEach(function (each) {
                    each.refresh();
                });
            },
            ['\u2192', '\u21BB', '\u2194'][rotationStyle], // label
            function () {  // query
                return myself.currentSprite instanceof SpriteMorph
                    && myself.currentSprite.rotationStyle === rotationStyle;
            },
            null, // environment
            localize(
                [
                    'don\'t rotate', 'can rotate', 'only face left/right'
                ][rotationStyle]
            )
        );

        button.corner = 8;
        button.labelMinExtent = new Point(11, 11);
        button.padding = 0;
        button.labelShadowOffset = new Point(-1, -1);
        button.labelShadowColor = colors[1];
        button.labelColor = myself.buttonLabelColor;
        button.fixLayout();
        button.refresh();
        rotationStyleButtons.push(button);
        button.setPosition(myself.spriteBar.position().add(2));
        button.setTop(button.top()
            + ((rotationStyleButtons.length - 1) * (button.height() + 2))
            );
        myself.spriteBar.add(button);
        if (myself.currentSprite instanceof StageMorph) {
            button.hide();
        }
        return button;
    }
//////////////////////////////////////////////
if (myself.currentSprite!=null) {
/////////////////////////////////////////////    
   if (world.role !== 'STUDENT'  || !myself.currentSprite.isLocked  ) {  // hide rotation if locked or null
        addRotationStyleButton(1);
        addRotationStyleButton(2);
        addRotationStyleButton(0);
        this.rotationStyleButtons = rotationStyleButtons;
    }
    thumbnail = new Morph();
    thumbnail.setExtent(thumbSize);
    thumbnail.image = this.currentSprite.thumbnail(thumbSize);
    if (world.role !== 'STUDENT'|| !myself.currentSprite.isLocked ) {   //hide rotation
        thumbnail.setPosition(
            rotationStyleButtons[0].topRight().add(new Point(5, 3))
        );
    }
    this.spriteBar.add(thumbnail);

    thumbnail.fps = 3;

    thumbnail.step = function () {
        if (thumbnail.version !== myself.currentSprite.version) {
            thumbnail.image = myself.currentSprite.thumbnail(thumbSize);
            thumbnail.changed();
            thumbnail.version = myself.currentSprite.version;
        }
    };
//+++---
	thumbnail.mouseDoubleClick = function () {  // reset the sprite heading to 90(east) on doubleclick
	if (this.world().currentKey === 16) {
		myself.currentSprite.silentGotoXY(0,0);
	} else {
		myself.currentSprite.setHeading(90); }
	}
//+++----
}///////////////////////////////////
//////////////////////////////////////////////
if (myself.currentSprite!=null) {
/////////////////////////////////////////////  
	 if (world.role !== 'STUDENT') { //------------------------------------    
		nameField = new InputFieldMorph(localize(this.currentSprite.name));
	} else {
		nameField = new InputFieldMorph(this.currentSprite.name,false,null,myself.currentSprite.isLocked);   //when a sprite isLocked it's name is readOnly
	} //-------------------------
    nameField.setWidth(100); // fixed dimensions
    nameField.contrast = 90;
    nameField.setPosition(thumbnail.topRight().add(new Point(10, 3)));
    this.spriteBar.add(nameField);
    nameField.drawNew();
//+++---
    nameField.accept = function () {
        var newName = nameField.getValue();
        myself.currentSprite.setName(
            myself.newSpriteName(newName, myself.currentSprite)
        );
        nameField.setContents(myself.currentSprite.name);
    };
    this.spriteBar.reactToEdit = nameField.accept;
//+++---
}///////////////////////////////////////////////////////////////////////////

    if (world.role !== 'STUDENT') {
        // padlock
        padlock = new ToggleMorph(
            'checkbox',
            null,
            function () {
                myself.currentSprite.isDraggable =
                    !myself.currentSprite.isDraggable;
            },
            localize('draggable'),
            function () {
                return myself.currentSprite.isDraggable;
            }
        );
        padlock.label.isBold = false;
        padlock.label.setColor(this.buttonLabelColor);
        padlock.color = tabColors[2];
        padlock.highlightColor = tabColors[0];
        padlock.pressColor = tabColors[1];

        padlock.tick.shadowOffset = MorphicPreferences.isFlat ?
                new Point() : new Point(-1, -1);
        padlock.tick.shadowColor = new Color(); // black
        padlock.tick.color = this.buttonLabelColor;
        padlock.tick.isBold = false;
        padlock.tick.drawNew();

        padlock.setPosition(nameField.bottomLeft().add(2));
        padlock.drawNew();
        this.spriteBar.add(padlock);
        if (this.currentSprite instanceof StageMorph) {
            padlock.hide();
        }
    }
// create "is secret" checkbox 
 if (world.role !== 'STUDENT') {
        // padlock
        padlock = new ToggleMorph(
            'checkbox',
            null,
            function () {
                myself.currentSprite.isSecret =
                    !myself.currentSprite.isSecret;
				myself.currentSprite.version = Date.now(); //update the sprite version to force the thumbnail and corral icon to update
				},
            localize('is secret'),
            function () {
			    return myself.currentSprite.isSecret;
            }
        );
        padlock.label.isBold = false;
        padlock.label.setColor(this.buttonLabelColor);
        padlock.color = tabColors[2];
        padlock.highlightColor = tabColors[0];
        padlock.pressColor = tabColors[1];

        padlock.tick.shadowOffset = MorphicPreferences.isFlat ?
                new Point() : new Point(-1, -1);
        padlock.tick.shadowColor = new Color(); // black
        padlock.tick.color = this.buttonLabelColor;
        padlock.tick.isBold = false;
        padlock.tick.drawNew();

        padlock.setPosition(nameField.topRight().add(2));
        padlock.drawNew();
        this.spriteBar.add(padlock);
   //     if (this.currentSprite instanceof StageMorph) {                // Do NOT HIDE is Secret Button for Stage
   //         padlock.hide();
    //    }
    }

// create "lock" checkbox 
 if (world.role !== 'STUDENT') {
        // padlock
        padlock = new ToggleMorph(
            'checkbox',
            null,
            function () {
                myself.currentSprite.isLocked =
                    !myself.currentSprite.isLocked;
            },
            localize('locked'),
            function () {
                return myself.currentSprite.isLocked;
            }
        );
        padlock.label.isBold = false;
        padlock.label.setColor(this.buttonLabelColor);
        padlock.color = tabColors[2];
        padlock.highlightColor = tabColors[0];
        padlock.pressColor = tabColors[1];

        padlock.tick.shadowOffset = MorphicPreferences.isFlat ?
                new Point() : new Point(-1, -1);
        padlock.tick.shadowColor = new Color(); // black
        padlock.tick.color = this.buttonLabelColor;
        padlock.tick.isBold = false;
        padlock.tick.drawNew();

        padlock.setPosition(nameField.bottomRight().add(2));
        padlock.drawNew();
        this.spriteBar.add(padlock);
        if (this.currentSprite instanceof StageMorph) {
            padlock.hide();
        }
    }
    // tab bar
    tabBar.tabTo = function (tabString) {
        var active;
        myself.currentTab = tabString;
        this.children.forEach(function (each) {
            each.refresh();
            if (each.state) {active = each; }
        });
        active.refresh(); // needed when programmatically tabbing
        myself.createSpriteEditor();
        myself.fixLayout('tabEditor');
    };

    tab = new TabMorph(
        tabColors,
        null, // target
        function () {tabBar.tabTo('scripts'); },
        localize('Scripts'), // label
        function () {  // query
            return myself.currentTab === 'scripts';
        }
    );
    tab.padding = 3;
    tab.corner = tabCorner;
    tab.edge = 1;
    tab.labelShadowOffset = new Point(-1, -1);
    tab.labelShadowColor = tabColors[1];
    tab.labelColor = this.buttonLabelColor;
    tab.drawNew();
    tab.fixLayout();
    tabBar.add(tab);
if (world.role !== 'STUDENT' || !this.stage.hideCostumes) { //--++-- hide costumes tab from student if checked
    tab = new TabMorph(
        tabColors,
        null, // target
        function () {tabBar.tabTo('costumes'); },
        localize('Costumes'), // label
        function () {  // query
            return myself.currentTab === 'costumes';
        }
    );
    tab.padding = 3;
    tab.corner = tabCorner;
    tab.edge = 1;
    tab.labelShadowOffset = new Point(-1, -1);
    tab.labelShadowColor = tabColors[1];
    tab.labelColor = this.buttonLabelColor;
    tab.drawNew();
    tab.fixLayout();
    tabBar.add(tab);
} //--++--
if (world.role !== 'STUDENT' || !this.stage.hideSounds) { //--++-- hide sounds tab from student if checked
    tab = new TabMorph(
        tabColors,
        null, // target
        function () {tabBar.tabTo('sounds'); },
        localize('Sounds'), // label
        function () {  // query
            return myself.currentTab === 'sounds';
        }
    );
    tab.padding = 3;
    tab.corner = tabCorner;
    tab.edge = 1;
    tab.labelShadowOffset = new Point(-1, -1);
    tab.labelShadowColor = tabColors[1];
    tab.labelColor = this.buttonLabelColor;
    tab.drawNew();
    tab.fixLayout();
    tabBar.add(tab);
} //--++--
    tabBar.fixLayout();
    tabBar.children.forEach(function (each) {
        each.refresh();
    });
    this.spriteBar.tabBar = tabBar;
    this.spriteBar.add(this.spriteBar.tabBar);

    this.spriteBar.fixLayout = function () {
        this.tabBar.setLeft(this.left());
        this.tabBar.setBottom(this.bottom());
    };

};

IDE_Morph.prototype.createSpriteEditor = function () {
    // assumes that the logo pane and the stage have already been created
	var scripts , //= this.currentSprite.scripts,
        myself = this;

    if (this.spriteEditor) {
        this.spriteEditor.destroy();
    }
////////////////////////////////////// if currentSprite is null create a dummy SpriteMorph
if (this.currentSprite !== null) {  /////////////////////////////////////// 
scripts = this.currentSprite.scripts; } 
else { scripts = new ScriptsMorph(null);} //-----------------------------------
//scripts.children.forEach(function (el){ alert(el.selector);});
////////////////////////////////////////////
    if (this.currentTab === 'scripts') {
     	scripts.isDraggable = false;
        scripts.color = this.groupColor;
        scripts.cachedTexture = this.scriptsPaneTexture;
		this.spriteEditor = new ScrollFrameMorph(
            scripts,
            null,
            this.sliderColor
        );
        this.spriteEditor.padding = 10;
        this.spriteEditor.growth = 50;
        this.spriteEditor.isDraggable = false;
        this.spriteEditor.acceptsDrops = false;
        this.spriteEditor.contents.acceptsDrops = true;
 
        scripts.scrollFrame = this.spriteEditor; 
        this.add(this.spriteEditor);
        this.spriteEditor.scrollX(this.spriteEditor.padding);
        this.spriteEditor.scrollY(this.spriteEditor.padding);
    } else if (this.currentTab === 'costumes') {
        this.spriteEditor = new WardrobeMorph(
            this.currentSprite,
            this.sliderColor
        );
        this.spriteEditor.color = this.groupColor;
        this.add(this.spriteEditor);
        this.spriteEditor.updateSelection();

        this.spriteEditor.acceptsDrops = false;
        this.spriteEditor.contents.acceptsDrops = false;
    } else if (this.currentTab === 'sounds') {
        this.spriteEditor = new JukeboxMorph(
            this.currentSprite,
            this.sliderColor
        );
        this.spriteEditor.color = this.groupColor;
        this.add(this.spriteEditor);
        this.spriteEditor.updateSelection();
        this.spriteEditor.acceptDrops = false;
        this.spriteEditor.contents.acceptsDrops = false;
    } else {
        this.spriteEditor = new Morph();
        this.spriteEditor.color = this.groupColor;
        this.spriteEditor.acceptsDrops = true;
        this.spriteEditor.reactToDropOf = function (droppedMorph) {
            if (droppedMorph instanceof DialogBoxMorph) {
                myself.world().add(droppedMorph);
            } else if (droppedMorph instanceof SpriteMorph) {
                myself.removeSprite(droppedMorph);
            } else {
                droppedMorph.destroy();
            }
        };
        this.add(this.spriteEditor);
    }

};

IDE_Morph.prototype.createCorralBar = function () {
    // assumes the stage has already been created
    var padding = 5,
		cambuttonpad,
		myself = this, //---
        newbutton,
        paintbutton,
//		camerabutton,
		padlock,  //--------
        colors = [
            this.groupColor,
            this.frameColor.darker(50),
            this.frameColor.darker(50)
        ],
		showCorralBar = world.role!='STUDENT' || (this.stage.canAddSprites && !this.stage.hideCorral); //determine when to show corral bar

    if (this.corralBar) {
        this.corralBar.destroy();
    }

    this.corralBar = new Morph();
    this.corralBar.color = this.frameColor;
    this.corralBar.setHeight(showCorralBar ? this.logo.height() : 0); // height is fixed
    this.add(this.corralBar);
//--------------------------------------------------------
if (showCorralBar) {
    // new sprite button
    newbutton = new PushButtonMorph(
        this,
        "addNewSprite",
        new SymbolMorph("turtle", 14)
    );
    newbutton.corner = 12;
    newbutton.color = colors[0];
    newbutton.highlightColor = colors[1];
    newbutton.pressColor = colors[2];
    newbutton.labelMinExtent = new Point(36, 18);
    newbutton.padding = 0;
    newbutton.labelShadowOffset = new Point(-1, -1);
    newbutton.labelShadowColor = colors[1];
    newbutton.labelColor = this.buttonLabelColor;
    newbutton.contrast = this.buttonContrast;
    newbutton.drawNew();
    newbutton.hint = "add a new Turtle sprite";
    newbutton.fixLayout();
    newbutton.setCenter(this.corralBar.center());
    newbutton.setLeft(this.corralBar.left() + padding);
    this.corralBar.add(newbutton);

    paintbutton = new PushButtonMorph(
        this,
        "paintNewSprite",
        new SymbolMorph("brush", 15)
    );
    paintbutton.corner = 12;
    paintbutton.color = colors[0];
    paintbutton.highlightColor = colors[1];
    paintbutton.pressColor = colors[2];
    paintbutton.labelMinExtent = new Point(36, 18);
    paintbutton.padding = 0;
    paintbutton.labelShadowOffset = new Point(-1, -1);
    paintbutton.labelShadowColor = colors[1];
    paintbutton.labelColor = this.buttonLabelColor;
    paintbutton.contrast = this.buttonContrast;
    paintbutton.drawNew();
    paintbutton.hint = "paint a new sprite";
    paintbutton.fixLayout();
    paintbutton.setCenter(this.corralBar.center());
	paintbutton.setLeft(
        this.corralBar.left() + padding + newbutton.width() + padding
    );
    this.corralBar.add(paintbutton);
}
//create camera button -- disabled at the moment
/*
if (world.role!='STUDENT' || !myself.stage.isSecret) {
camerabutton = new PushButtonMorph(
        this,
        "showCamera",
        new SymbolMorph("camera", 17)
    );
    camerabutton.corner = 12;
    camerabutton.color = colors[0];
    camerabutton.highlightColor = colors[1];
    camerabutton.pressColor = colors[2];
    camerabutton.labelMinExtent = new Point(36, 18);
    camerabutton.padding = 0;
    camerabutton.labelShadowOffset = new Point(-1, -1);
    camerabutton.labelShadowColor = colors[1];
    camerabutton.labelColor = this.buttonLabelColor;
    camerabutton.contrast = this.buttonContrast;
    camerabutton.drawNew();
    camerabutton.hint = "show camera";
    camerabutton.fixLayout();
    camerabutton.setCenter(this.corralBar.center());
	cambuttonpad=0;
    if (world.role !='STUDENT' || myself.stage.canAddSprites)
		{cambuttonpad = newbutton.width() + paintbutton.width();}
	camerabutton.setLeft(
        this.corralBar.left() + padding + cambuttonpad + padding
    );
	this.corralBar.add(camerabutton);  

}
*/
};

IDE_Morph.prototype.createCorral = function () {
    // assumes the corral bar has already been created
    var frame, template, padding = 5, myself = this;
	
	this.createStageHandle();
    if (this.corral) {
        this.corral.destroy();
    }

    this.corral = new Morph();
    this.corral.color = this.groupColor;
    this.add(this.corral);

    this.corral.stageIcon = new SpriteIconMorph(this.stage);
    this.corral.stageIcon.isDraggable = false;
	if(world.role!='STUDENT' || !this.stage.isSecret ) {     // ------------------------- hide stage icon if isSecret
    this.corral.add(this.corral.stageIcon); }

    frame = new ScrollFrameMorph(null, null, this.sliderColor);
    frame.acceptsDrops = false;
    frame.contents.acceptsDrops = false;

    frame.contents.wantsDropOf = function (morph) {
        return morph instanceof SpriteIconMorph;
    };

    frame.contents.reactToDropOf = function (spriteIcon) {
        myself.corral.reactToDropOf(spriteIcon);
    };

    frame.alpha = 0;

    this.sprites.asArray().forEach(function (morph) {
		if(world.role!='STUDENT' || !morph.isSecret ) {     //  if sprite isSecret then hide
       template = new SpriteIconMorph(morph, template);
       frame.contents.add(template);}
    });

    this.corral.frame = frame;
    this.corral.add(frame);

    this.corral.fixLayout = function () {
        this.stageIcon.setCenter(this.center());
        this.stageIcon.setLeft(this.left() + padding);
        this.frame.setLeft(this.stageIcon.right() + padding);
        this.frame.setExtent(new Point(
            this.right() - this.frame.left(),
            this.height()
        ));
        this.arrangeIcons();
        this.refresh();
    };

    this.corral.arrangeIcons = function () {
        var x = this.frame.left(),
            y = this.frame.top(),
            max = this.frame.right(),
            start = this.frame.left();

        this.frame.contents.children.forEach(function (icon) {
            var w = icon.width();

            if (x + w > max) {
                x = start;
                y += icon.height(); // they're all the same
            }
            icon.setPosition(new Point(x, y));
            x += w;
        });
        this.frame.contents.adjustBounds();
    };

    this.corral.addSprite = function (sprite) {
		this.frame.contents.add(new SpriteIconMorph(sprite));
        this.fixLayout();
    };

    this.corral.refresh = function () {
        this.stageIcon.refresh();
        this.frame.contents.children.forEach(function (icon) {
            icon.refresh();
        });
    };

    this.corral.wantsDropOf = function (morph) {
        return morph instanceof SpriteIconMorph;
    };

    this.corral.reactToDropOf = function (spriteIcon) {
        var idx = 1,
            pos = spriteIcon.position();
        spriteIcon.destroy();
        this.frame.contents.children.forEach(function (icon) {
            if (pos.gt(icon.position()) || pos.y > icon.bottom()) {
                idx += 1;
            }
        });
        myself.sprites.add(spriteIcon.object, idx);
        myself.createCorral();
        myself.fixLayout();
    };
};

// IDE_Morph layout
IDE_Morph.prototype.fixLayout = function (situation) {

    // situation is a string, i.e.
    // 'selectSprite' or 'refreshPalette' or 'tabEditor'
    var padding = this.padding;

    Morph.prototype.trackChanges = false;

    if (situation !== 'refreshPalette') {
        // controlBar
        this.controlBar.setPosition(this.logo.topRight());
        this.controlBar.setWidth(this.right() - this.controlBar.left());
        this.controlBar.fixLayout();

        // categories
        this.categories.setLeft(this.logo.left());
        this.categories.setTop(this.logo.bottom());
    }

    // palette
    this.palette.setLeft(this.logo.left());
    this.palette.setTop(this.categories.bottom());
    this.palette.setHeight(this.bottom() - this.palette.top());

    if (situation !== 'refreshPalette') {
        // stage
        if (this.isAppMode) {
            this.stage.setScale(Math.floor(Math.min(
                (this.width() - padding * 2) / this.stage.dimensions.x,
                (this.height() - this.controlBar.height() * 2 - padding * 2)
                    / this.stage.dimensions.y
            ) * 10) / 10);
            this.stage.setCenter(this.center());
        } else {
            this.stage.setScale(this.isSmallStage ? this.stageRatio : 1);
            this.stage.setTop(this.logo.bottom() + padding);
            this.stage.setRight(this.right());
            this.stageHandle.fixLayout();
        }

        // spriteBar
        this.spriteBar.setPosition(this.logo.bottomRight().add(padding));
		if (this.stage.hideSpriteBar && world.role == 'STUDENT'){ //if chosen, hide sprite bar from student
			this.spriteBar.hide();
			this.spriteBar.setExtent(new Point(
				Math.max(0, this.stage.left() - padding - this.spriteBar.left()),
				0));
		} else {
			this.spriteBar.setExtent(new Point(
				Math.max(0, this.stage.left() - padding - this.spriteBar.left()),
				78//fixed because the categories pallete height may vary because we do not have a fixed number of categories any more
			));
			this.spriteBar.fixLayout();
		}

        // spriteEditor
        if (this.spriteEditor.isVisible) {
            this.spriteEditor.setPosition(this.spriteBar.bottomLeft());
            this.spriteEditor.setExtent(new Point(
                this.spriteBar.width(),
                this.bottom() - this.spriteEditor.top()
            ));
        }

        // corralBar
        this.corralBar.setLeft(this.stage.left());
        this.corralBar.setTop(this.stage.bottom() + padding);
        this.corralBar.setWidth(this.stage.width());

        // corral
        if (!contains(['selectSprite', 'tabEditor'], situation)) {
            this.corral.setPosition(this.corralBar.bottomLeft());
            this.corral.setWidth(this.stage.width());
			if (this.stage.hideCorral && world.role == 'STUDENT'){ //if chosen, hide corral from student
				this.corral.hide();
			}
            this.corral.setHeight(this.bottom() - this.corral.top());
            this.corral.fixLayout();
        }
    }

    Morph.prototype.trackChanges = true;
    this.changed();
};


IDE_Morph.prototype.selectSprite = function (sprite) {
    if (this.currentSprite && this.currentSprite.scripts.focus) {
        this.currentSprite.scripts.focus.stopEditing();
    }
	this.currentSprite = sprite;
    this.createPalette();
    this.createSpriteBar();
    this.createSpriteEditor();
    this.corral.refresh();
    this.fixLayout('selectSprite');
if (sprite!=null){ //////////////////////////////
    this.currentSprite.scripts.fixMultiArgs();
}
};


//new show camera - disabled at the moment due to problematic browser support
/*
IDE_Morph.prototype.showCamera = function () {
var stage = this.stage,
    myself = this,
 canvas,
 ctx,
 //context,
 dlg = new DialogBoxMorph(),
 video = document.createElement("VIDEO"),
 orX=0,orY=0, zoom =100, //for zoomin-clipping
 playevt,
 localstream,
	videoObj = { "video": true }; 
	
if (document.getElementById('vd')){ return;}
 
 video = document.createElement("VIDEO");
 video.setAttribute("id","vd");
 video.style.visibility = "hidden";
 document.body.appendChild(video);
 
 navigator.mediaDevices = navigator.mediaDevices || ((navigator.mozGetUserMedia || navigator.webkitGetUserMedia) ? 
 { getUserMedia: function(c) {
   return new Promise(function(y, n) {
    (navigator.mozGetUserMedia || 
	navigator.webkitGetUserMedia).call(navigator, c, y, n); }); } } : null);
	if (!navigator.mediaDevices) {
		myself.inform("ΣΦΑΛΜΑ","Η κάμερα δεν υποστηρίζεται!");
		return; } 

navigator.mediaDevices.getUserMedia = navigator.mediaDevices.getUserMedia ||
                                      (function(c) {
										return new Promise(function(y, n) {
																			(navigator.mozGetUserMedia || 
																			navigator.webkitGetUserMedia).call(navigator, c, y, n); });
										});		
 
	navigator.mediaDevices.getUserMedia(videoObj)
	.then(function(stream) { 
	//var video = document.querySelector('video');
	video.src = window.URL.createObjectURL(stream);
	localstream = stream;
	video.onloadedmetadata = function(e) { 
	video.play(); }; }
	)
	
	.catch(function(err) { 	myself.inform("ΣΦΑΛΜΑ",err.name + ": " + err.message);
						}
	);

canvas = newCanvas(new Point(300, 225));
ctx = canvas.getContext('2d');
dlg.camDialog(
 'Camera',
 stage.world(),
 canvas
 );

video.addEventListener("play", function() {playevt = window.setInterval(function() { ctx.drawImage(video,
																								  orX, orY,
																								  100 * video.videoWidth / zoom,
																								  100 * video.videoHeight / zoom,
																								  0,0,300,300 * video.videoHeight / video.videoWidth); 
																					dlg.changed();
																					}
																		,200);
										  },
   					  false);

dlg.cancel = function() {
var vtrack;
if (localstream != undefined) { 
window.clearInterval(playevt); 
if(navigator.mozGetUserMedia) { // for firefox
localstream.stop(); 
} else { //for chrome and Opera
	vtrack = localstream.getVideoTracks();
	if (vtrack.length>0) {
		vtrack[0].stop();
		localstream.removeTrack(vtrack[0]);
		}
	}
}
document.body.removeChild(video);
this.destroy();
} 

dlg.ok = function() { 
context = stage.penTrails().getContext('2d'); 
context.save(); 
//context.scale(1 / stage.scale, 1 / stage.scale); 
context.drawImage(video,
				  orX, orY,
				  100 * video.videoWidth / zoom,
				  100 * video.videoHeight / zoom,
				  0,0,stage.dimensions.x,stage.dimensions.y); 
context.restore(); 
stage.changed(); 
}

dlg.save = function(){
var	data,costume,
    canvas,context;

if (localstream == undefined) {return;}

data = myself.currentSprite.newCostumeName('cam photo');
canvas = newCanvas(new Point(300,300 * video.videoHeight / video.videoWidth));
context = canvas.getContext('2d');
context.drawImage(video,
                 orX, orY,
				 100 * video.videoWidth / zoom,
				 100 * video.videoHeight / zoom,
				 0,0,300,300 * video.videoHeight / video.videoWidth);
costume = new Costume(canvas, data);
myself.currentSprite.addCostume(costume);	
}

function setZoom(n){ //helper for setting zoom in and out
var z,camRect,orRect, newRect,factor;
	
	if (localstream == undefined) {return;}
	z = (n<100 || n> 300) ? zoom : n ;
	
//if zoom didn't change return
	if (z==zoom) {return;}

//the whole camere rectangle
	camRect = new Rectangle(0,0, video.videoWidth, video.videoHeight);

//the rectangle before the new zoom
// grow-shrink factor = (originalcorner - zoomedcorner) / 2
	factor = camRect.corner.subtract(camRect.corner.floorDivideBy(zoom/100)).floorDivideBy(2);
	orRect = camRect.insetBy(factor);
	orRect = orRect.translateBy(orRect.origin.subtract(new Point(orX, orY)).neg());

//the rectangle after the new zoom
	factor = camRect.corner.subtract(camRect.corner.floorDivideBy(z/100)).floorDivideBy(2);
	newRect = camRect.insetBy(factor);
	newRect = newRect.translateBy(newRect.center().subtract(orRect.center()).neg());

// if new rectangle is not contained inside the camera rectangle 
	if (!(camRect.origin.le(newRect.origin) && camRect.corner.ge(newRect.corner))) {
// move it inside 
		newRect = newRect.translateBy(newRect.amountToTranslateWithin(camRect));
	}
	orX = newRect.origin.x;
	orY = newRect.origin.y;
	zoom = z;
}

dlg.zoomIn = function(){
	setZoom(zoom+20);	
}

dlg.zoomOut = function(){
	setZoom(zoom-20);
}

function move(x,y){ //helper for moving
var	camRect, orRect,factor;     

      
	if (localstream == undefined) {return;}

//the whole camere rectangle
	camRect = new Rectangle(0,0, video.videoWidth, video.videoHeight);

//the zoomed rectangle
	factor = camRect.corner.subtract(camRect.corner.floorDivideBy(zoom/100)).floorDivideBy(2); 
	orRect = camRect.insetBy(factor);
	orRect = orRect.translateBy(orRect.origin.subtract(new Point(orX, orY)).neg());

//move the zoomed rectangle in new position
	orRect = orRect.translateBy(new Point(x,-y));

//if it fits inside the camera rectangle, update position
	if (camRect.origin.le(orRect.origin) && camRect.corner.ge(orRect.corner)) { 
		orX = orRect.origin.x;
		orY = orRect.origin.y;
	}
}

dlg.left = function(){
	move(-20,0);
}

dlg.right = function(){
	move(20,0);
}

dlg.up = function(){
	move(0,20);
}

dlg.down = function(){
	move(0,-20);
}
}
//new show camera
*/
//+++---



IDE_Morph.prototype.removeSprite = function (sprite) {
    var idx = this.sprites.asArray().indexOf(sprite) + 1,
	myself=this;


	sprite.parts.forEach(function (part) {myself.removeSprite(part); });
	this.stage.threads.stopAllForReceiver(sprite);
    sprite.destroy();
    this.stage.watchers().forEach(function (watcher) {
        if (watcher.object() === sprite) {
            watcher.destroy();
        }
    });

   if (idx < 1) {return; }         


   this.sprites.remove(this.sprites.asArray().indexOf(sprite) + 1);
   this.createCorral();
   this.fixLayout();
   this.currentSprite = this.chooseSprite(this.sprites.asArray(),this.stage);///////////////////////////////// 
   this.selectSprite(this.currentSprite);
};


IDE_Morph.prototype.snapMenu = function () {
    var menu,
        world = this.world();
		
		if (world.HOCmode) {return;} //disable snapMenu in HOC mode
		
        menu = new MenuMorph(this);
        menu.addItem('About...', 'aboutSnap');
        menu.addLine();
        menu.addItem(
            'Reference manual',
            function () {
                window.open('http://byob.berkeley.edu//SnapManual.pdf', 'SnapReferenceManual');
            }
        );
        menu.addItem(
            'Snap! website',
            function () {
                window.open('http://snap.berkeley.edu/', 'SnapWebsite');
            }
        );
	if (world.role!='STUDENT'){
		menu.addItem(
            'Snap HE.gr manual',
            function () {
                window.open(host+'/archives/modification.pdf', 'ModificationSnapReferenceManual');
            }
        );
	}
        menu.addItem(
            'Download source',
            function () {
                window.open(
                    host+'/archives/snapHEgr.zip',
                    'SnapSource'
                );
            }
        );
   
    

	if (world.currentKey === 16) { // shift-click
	menu.addLine();
	if (world.role=='STUDENT') {
		   menu.addItem(
				'Switch to development mode',
				function (){
				world.role = 1;
				this.refreshIDE();
				},
				'show all hidden parts',           
				new Color(0, 100, 0)
			);
		} else  { 
			menu.addItem(
				'Switch to student mode',
				function (){
				world.role = 'STUDENT';
				this.refreshIDE();
				},
				'hide all hidden parts',
				 new Color(100, 0, 0)
			);
		}
	}
    menu.popup(world, this.logo.bottomLeft());
};

IDE_Morph.prototype.cloudMenu = nop;


IDE_Morph.prototype.settingsMenu = function () {
       var menu,
        stage = this.stage,
        world = this.world(),
        myself = this,
        pos = this.controlBar.settingsButton.bottomLeft(),
        shiftClicked = (world.currentKey === 16),
		visibleItem = world.role!== 'STUDENT' || !world.HOCmode; 				//determine when a menu item is visible to snap user

    function addPreference(label, toggle, test, onHint, offHint, hide) {
        var on = '\u2611 ',
            off = '\u2610 ';
        if (!hide || shiftClicked) {
            menu.addItem(
                (test ? on : off) + localize(label),
                toggle,
                test ? onHint : offHint,
                hide ? new Color(100, 0, 0) : null
            );
        }
    }
	
	//always visible
    menu = new MenuMorph(this);
    menu.addItem('Language...', 'languageMenu');
	if (visibleItem){
		menu.addItem(
			'Zoom blocks...',
			'userSetBlocksScale'
		);
		menu.addItem(
			'Stage size...',
			'userSetStageSize'
		);
		if (shiftClicked) {
			menu.addItem(
				'Dragging threshold...',
				'userSetDragThreshold',
				'specify the distance the hand has to move\n' +
					'before it picks up an object',
				new Color(100, 0, 0)
			);
		}
		menu.addLine();
		addPreference(
			'Blurred shadows',
			'toggleBlurredShadows',
			useBlurredShadows,
			'uncheck to use solid drop\nshadows and highlights',
			'check to use blurred drop\nshadows and highlights',
			true
		);
		addPreference(
			'Zebra coloring',
			'toggleZebraColoring',
			BlockMorph.prototype.zebraContrast,
			'uncheck to disable alternating\ncolors for nested block',
			'check to enable alternating\ncolors for nested blocks',
			true
		);
		addPreference(
			'Dynamic input labels',
			'toggleDynamicInputLabels',
			SyntaxElementMorph.prototype.dynamicInputLabels,
			'uncheck to disable dynamic\nlabels for variadic inputs',
			'check to enable dynamic\nlabels for variadic inputs',
			true
		);
		addPreference(
			'Prefer empty slot drops',
			'togglePreferEmptySlotDrops',
			ScriptsMorph.prototype.isPreferringEmptySlots,
			'uncheck to allow dropped\nreporters to kick out others',
			'settings menu prefer empty slots hint',
			true
		);
		addPreference(
			'Long form input dialog',
			'toggleLongFormInputDialog',
			InputSlotDialogMorph.prototype.isLaunchingExpanded,
			'uncheck to use the input\ndialog in short form',
			'check to always show slot\ntypes in the input dialog'
		);
		addPreference(
			'Plain prototype labels',
			'togglePlainPrototypeLabels',
			BlockLabelPlaceHolderMorph.prototype.plainLabel,
			'uncheck to always show (+) symbols\nin block prototype labels',
			'check to hide (+) symbols\nin block prototype labels'
		);
		addPreference(
			'Virtual keyboard',
			'toggleVirtualKeyboard',
			MorphicPreferences.useVirtualKeyboard,
			'uncheck to disable\nvirtual keyboard support\nfor mobile devices',
			'check to enable\nvirtual keyboard support\nfor mobile devices',
			true
		);
		addPreference(
			'Input sliders',
			'toggleInputSliders',
			MorphicPreferences.useSliderForInput,
			'uncheck to disable\ninput sliders for\nentry fields',
			'check to enable\ninput sliders for\nentry fields'
		);
		if (MorphicPreferences.useSliderForInput) {
			addPreference(
				'Execute on slider change',
				'toggleSliderExecute',
				InputSlotMorph.prototype.executeOnSliderEdit,
				'uncheck to supress\nrunning scripts\nwhen moving the slider',
				'check to run\nthe edited script\nwhen moving the slider'
			);
		}
		addPreference(
			'Clicking sound',
			function () {
				BlockMorph.prototype.toggleSnapSound();
				if (BlockMorph.prototype.snapSound) {
					myself.saveSetting('click', true);
				} else {
					myself.removeSetting('click');
				}
			},
			BlockMorph.prototype.snapSound,
			'uncheck to turn\nblock clicking\nsound off',
			'check to turn\nblock clicking\nsound on'
		);
		addPreference(
			'Animations',
			function () {myself.isAnimating = !myself.isAnimating; },
			myself.isAnimating,
			'uncheck to disable\nIDE animations',
			'check to enable\nIDE animations',
			true
		);
	}	
	
	// always visible
	addPreference(
		'Turbo mode',
		'toggleFastTracking',
		this.stage.isFastTracked,
		'uncheck to run scripts\nat normal speed',
		'check to prioritize\nscript execution'
	);
		
	if (visibleItem) {
		addPreference(
			'Cache Inputs',
			function () {
				BlockMorph.prototype.isCachingInputs =
					!BlockMorph.prototype.isCachingInputs;
			},
			BlockMorph.prototype.isCachingInputs,
			'uncheck to stop caching\ninputs (for debugging the evaluator)',
			'check to cache inputs\nboosts recursion',
			true
		);
		addPreference(
			'Rasterize SVGs',
			function () {
				MorphicPreferences.rasterizeSVGs =
					!MorphicPreferences.rasterizeSVGs;
			},
			MorphicPreferences.rasterizeSVGs,
			'uncheck for smooth\nscaling of vector costumes',
			'check to rasterize\nSVGs on import',
			true
		);
	}
	
	//always visible
    addPreference(
        'Flat design',
        function () {
            if (MorphicPreferences.isFlat) {
                return myself.defaultDesign();
            }
            myself.flatDesign();
        },
        MorphicPreferences.isFlat,
        'uncheck for default\nGUI design',
        'check for alternative\nGUI design',
        false
    );
	if (visibleItem) {
		addPreference(
			'Project URLs',
			function () {
				myself.projectsInURLs = !myself.projectsInURLs;
				if (myself.projectsInURLs) {
					myself.saveSetting('longurls', true);
				} else {
					myself.removeSetting('longurls');
				}
			},
			myself.projectsInURLs,
			'uncheck to disable\nproject data in URLs',
			'check to enable\nproject data in URLs',
			true
		);
		addPreference(
			'Sprite Nesting',
			function () {
				SpriteMorph.prototype.enableNesting =
					!SpriteMorph.prototype.enableNesting;
			},
			SpriteMorph.prototype.enableNesting,
			'uncheck to disable\nsprite composition',
			'check to enable\nsprite composition',
			true
		);
	}
	//always visible
    addPreference(
        'Keyboard Editing',
        function () {
            ScriptsMorph.prototype.enableKeyboard =
                !ScriptsMorph.prototype.enableKeyboard;
            if (ScriptsMorph.prototype.enableKeyboard) {
                myself.saveSetting('keyboard', true);
            } else {
                myself.removeSetting('keyboard');
            }
        },
        ScriptsMorph.prototype.enableKeyboard,
        'uncheck to disable\nkeyboard editing support',
        'check to enable\nkeyboard editing support',
        false
    );
	if (visibleItem) {
		menu.addLine(); // everything below this line is stored in the project
		addPreference(
			'Thread safe scripts',
			function () {stage.isThreadSafe = !stage.isThreadSafe; },
			this.stage.isThreadSafe,
			'uncheck to allow\nscript reentrance',
			'check to disallow\nscript reentrance'
		);
		addPreference(
			'Prefer smooth animations',
			'toggleVariableFrameRate',
			StageMorph.prototype.frameRate,
			'uncheck for greater speed\nat variable frame rates',
			'check for smooth, predictable\nanimations across computers'
		);
		addPreference(
			'Flat line ends',
			function () {
				SpriteMorph.prototype.useFlatLineEnds =
					!SpriteMorph.prototype.useFlatLineEnds;
			},
			SpriteMorph.prototype.useFlatLineEnds,
			'uncheck for round ends of lines',
			'check for flat ends of lines'
		);
		addPreference(
			'Codification support',
			function () {
				StageMorph.prototype.enableCodeMapping =
					!StageMorph.prototype.enableCodeMapping;
				myself.currentSprite.blocksCache.variables = null;
				myself.currentSprite.paletteCache.variables = null;
				myself.refreshPalette();
			},
			StageMorph.prototype.enableCodeMapping,
			'uncheck to disable\nblock to text mapping features',
			'check for block\nto text mapping features',
			false
		);
		addPreference(
			'Inheritance support',
			function () {
				StageMorph.prototype.enableInheritance =
					!StageMorph.prototype.enableInheritance;
				myself.currentSprite.blocksCache.variables = null;
				myself.currentSprite.paletteCache.variables = null;
				myself.refreshPalette();
			},
			StageMorph.prototype.enableInheritance,
			'uncheck to disable\nsprite inheritance features',
			'check for sprite\ninheritance features',
			false
		);
	}	
//---------------------  PROJECT MANAGEMENT -----------------------  
// not visible to students in any mode
	if (world.role !== 'STUDENT' ){ 
		menu.addLine();
		menu.addItem('Manage Project',nop,'',new Color(0, 125, 0),true);
		menu.addLine();
		addPreference( 					  //exercise mode
				'block execution on click',       
				function () {stage.exerciseMode = !stage.exerciseMode; },
				!this.stage.exerciseMode,
				'check to allow block execution on click',
				'uncheck to forbid block execution on click '
			);
		addPreference( 					  //can add sprites
				'can add sprites',       
				function () {stage.canAddSprites = !stage.canAddSprites; },
				this.stage.canAddSprites,
				'check to allow new sprites',
				'uncheck to forbid new sprites '
			);
		addPreference( 					  //hide costumes tab
				'Hide costumes from student',       
				function () {stage.hideCostumes = !stage.hideCostumes; },
				this.stage.hideCostumes,
				'uncheck to show\ncostumes tab from student',
				'check to hide\ncostumes tab from student'
			);
		addPreference(                    //hide sounds tab
				'Hide sounds from student',
				function () {stage.hideSounds = !stage.hideSounds; },
				this.stage.hideSounds,
				'uncheck to show\nsounds tab from student',
				'check to hide\nsounds tab from student'
			);
                 addPreference( 					  //can add sprites
				'import/export on HOC mode',       
				function () {stage.importExportHOC = !stage.importExportHOC; },
				this.stage.importExportHOC,
				'check to allow importing/exporting in HOC mode',
				'uncheck to forbid importing/exporting in HOC mode '
			);
		menu.addLine();	
		addPreference( 					  //hide sprite bar
				'Hide sprite bar from student',       
				function () {stage.hideSpriteBar = !stage.hideSpriteBar; },
				this.stage.hideSpriteBar,
				'uncheck to show\nsrpite bar from student',
				'check to hide\nsprite bar from student'
			);
		addPreference(                    //hide corral
				'Hide corral from student',
				function () {stage.hideCorral = !stage.hideCorral; },
				this.stage.hideCorral,
				'uncheck to show\ncorral from student',
				'check to hide\ncorral from student'
			);	
		menu.addLine();	
		addPreference(                    //allow only script variables
				'Only Script Variables',
				function () {stage.onlyScriptVars = !stage.onlyScriptVars; },
				this.stage.onlyScriptVars,
				'uncheck to allow\nvariable creation to student',
				'check to forbid\nvariable creation to student'
			);
		addPreference(                    //forbid custom block creation
				'No Custom Blocks',
				function () {stage.noCustomBlocks = !stage.noCustomBlocks; },
				this.stage.noCustomBlocks,
				'uncheck to allow\ncustom blocks creation to student',
				'check to forbid\ncustom blocks creation creation to student'
			);
		menu.addLine(); //Network support
		addPreference(                    //forbid custom block creation
				'No Network support',
				function () {
					stage.noNetworkSupport = !stage.noNetworkSupport;
					myself.currentSprite.blocksCache.control = null;
					myself.currentSprite.paletteCache.control = null;
					myself.currentSprite.blocksCache.sensing = null;
					myself.currentSprite.paletteCache.sensing = null;
					myself.currentSprite.blocksCache.variables = null;
					myself.currentSprite.paletteCache.variables = null;
					myself.refreshPalette();
				},
				stage.noNetworkSupport,
				'uncheck to allow\nstudent to connect to network',
				'check to forbid\nstudent to connect to network'
			);	
	}

    menu.popup(world, pos);
};


IDE_Morph.prototype.projectMenu = function () {
    var menu,
        myself = this,
        world = this.world(),
        pos = this.controlBar.projectButton.bottomLeft(),
        graphicsName = this.currentSprite instanceof SpriteMorph ?
                'Costumes' : 'Backgrounds',
        shiftClicked = (world.currentKey === 16),
		visibleItem = world.role!== 'STUDENT' || !world.HOCmode, 				//determine when a menu item is visible to snap user
		visibleCostumes = world.role!== 'STUDENT' || !this.stage.hideCostumes,	//
		visibleSounds = world.role!== 'STUDENT' || !this.stage.hideSounds;		//

    menu = new MenuMorph(this);
	if (visibleItem){
		menu.addItem('Project notes...', 'editProjectNotes');
		menu.addLine();
		menu.addItem(
			'New',
			function () {
				myself.confirm(
					'Replace the current project with a new one?',
					'New Project',
					function () {
						myself.newProject();
					}
				);
			}
		);
        }
	menu.addItem('Open...', 'openProjectsBrowser');
        if (visibleItem){        
		menu.addItem(
			'Save',
			function () {
		        if (myself.source === 'examples') {
		            myself.source = 'local'; // cannot save to examples
			    }
				if (myself.projectName) {
					if (myself.source === 'local') { // as well as 'examples'
						myself.saveProject(myself.projectName);
					} else { // 'cloud',('examples' only for admin)
						myself.saveProjectToCloud(myself.projectName);
					}
				} else {
					myself.saveProjectsBrowser();
				}
			}
		);
	}
	//always visible
    menu.addItem('Save As...', 'saveProjectsBrowser');
    
	if (visibleItem || this.stage.importExportHOC){
		menu.addLine();
		menu.addItem(
			'Import...',
			function () {
				var inp = document.createElement('input');
				if (myself.filePicker) {
					document.body.removeChild(myself.filePicker);
					myself.filePicker = null;
				}
				inp.type = 'file';
				inp.style.color = "transparent";
				inp.style.backgroundColor = "transparent";
				inp.style.border = "none";
				inp.style.outline = "none";
				inp.style.position = "absolute";
				inp.style.top = "0px";
				inp.style.left = "0px";
				inp.style.width = "0px";
				inp.style.height = "0px";
				inp.addEventListener(
					"change",
					function () {
						document.body.removeChild(inp);
						myself.filePicker = null;
						world.hand.processDrop(inp.files,true);
					},
					false
				);
				document.body.appendChild(inp);
				myself.filePicker = inp;
				inp.click();
			},
			'file menu import hint' // looks up the actual text in the translator
		);
        }
        if (visibleItem){
		if (shiftClicked) {
			menu.addItem(
				localize('Export project...') + ' ' + localize('(in a new window)'),
				function () {
					if (myself.projectName) {
						myself.exportProject(myself.projectName, shiftClicked);
					} else {
						myself.prompt('Export Project As...', function (name) {
							// false - override the shiftClick setting to use XML
							// true - open XML in a new tab
							myself.exportProject(name, false, true);
						}, null, 'exportProject');
					}
				},
				'show project data as XML\nin a new browser window',
				new Color(100, 0, 0)
			);
		}
		menu.addItem(
			shiftClicked ?
					'Export project as plain text...' : 'Export project...',
			function () {
				if (myself.projectName) {
					myself.exportProject(myself.projectName, shiftClicked);
				} else {
					myself.prompt('Export Project As...', function (name) {
						myself.exportProject(name, shiftClicked);
					}, null, 'exportProject');
				}
			},
			'save project data as XML\nto your downloads folder',
			shiftClicked ? new Color(100, 0, 0) : null
		);
        }
    if (visibleItem || this.stage.importExportHOC){    
		if (this.stage.globalBlocks.length) {
			menu.addItem(
				'Export blocks...',
				function () {myself.exportGlobalBlocks(); },
				'show global custom block definitions as XML' +
					'\nin a new browser window'
			);
			menu.addItem(
				'Unused blocks...',
				function () {myself.removeUnusedBlocks(); },
				'find unused global custom blocks' +
					'\nand remove their definitions'
			);
		}
    }            
    if (visibleItem){            
		menu.addItem(
			'Export summary...',
			function () {myself.exportProjectSummary(); },
			'open a new browser browser window\n with a summary of this project'
		);

		if (shiftClicked) {
			menu.addItem(
				'Export summary with drop-shadows...',
				function () {myself.exportProjectSummary(true); },
				'open a new browser browser window' +
					'\nwith a summary of this project' +
					'\nwith drop-shadows on all pictures.' +
					'\nnot supported by all browsers',
				new Color(100, 0, 0)
			);
			menu.addItem(
				'Export all scripts as pic...',
				function () {myself.exportScriptsPicture(); },
				'show a picture of all scripts\nand block definitions',
				new Color(100, 0, 0)
			);
		}

	/////////////
	  menu.addLine();      
			menu.addItem(
				'Import tools',
				function () {
					myself.droppedText(
						myself.getURL(
							'http://snap.berkeley.edu/snapsource/tools.xml'
						),
						'tools'
					);
				},
				'load the official library of\npowerful blocks'
			);

			menu.addItem(
				'Libraries...',
				function () {
					// read a list of libraries from an external file,
					var libMenu = new MenuMorph(this, 'Import library'),
						libUrl = host+'/libraries/' +//'http://snap.berkeley.edu/snapsource/libraries/' +
							'LIBRARIES.txt';
					

					function loadLib(name) {
						var url = host+'/libraries/'
								+ name
								+ '.xml';
						myself.droppedText(myself.getURL(url), name);
					}
	//this.showMessage(libUrl);
					myself.getURL(libUrl).split('\n').forEach(function (line) {
						if (line.length > 0) {
							libMenu.addItem(
								line.substring(line.indexOf('\t') + 1),
								function () {
									loadLib(
										line.substring(0, line.indexOf('\t'))
									);
								}
							);
						}
					});
					libMenu.popup(world, pos);
				},
				'Select categories of additional blocks to add to this project.'
			);
	}  
    
	if (visibleCostumes){	
		menu.addItem(
			localize(graphicsName) + '...',			
			function () {
					var dir = graphicsName,
						names = myself.getCostumesListNew(host+'/php/com/read_dir.php?root=/'+dir+'/&dir='),//'/'+dir+'/index.txt'),     
		//names = myself.getCostumesList('http://snap.berkeley.edu/snapsource/'+dir+'/'),
						//names = myself.getCostumesList(host+ '/' + dir + '/')
						libMenu = new MenuMorph(
							myself,
							localize('Import') + ' ' + localize(dir)
						);

					function loadCostume(name) {
						var url = host +'/'+ dir + '/' + name,       //'http://snap.berkeley.edu/snapsource/'+ dir + '/' + name,
						img = new Image();
						img.onload = function () {
							var canvas = newCanvas(new Point(img.width, img.height));
							canvas.getContext('2d').drawImage(img, 0, 0);
							myself.droppedImage(canvas, name);
						};
						img.src = url;
					}

					names.forEach(function (line) {
						if (line.length > 0) {
							libMenu.addItem(
								line,
								function () {loadCostume(line); }
							);
						}
					}); 
					libMenu.popup(world, pos);
				},
			'Select a costume from the media library'
		);
	}
	if (visibleSounds){
		menu.addItem(
			localize('Sounds') + '...',
			function () {
				var names = myself.getCostumesListNew(host+'/php/com/read_dir.php?root=/Sounds/&dir='),//this.getCostumesList(host+'/Sounds/'),
					libMenu = new MenuMorph(this, 'Import sound');

				function loadSound(name) {
					var url = host +'/Sounds/' + name, // 'http://snap.berkeley.edu/snapsource/'
						audio = new Audio();
					audio.src = url;
					audio.load();
					myself.droppedAudio(audio, name);
				}

				names.forEach(function (line) {
					if (line.length > 0) {
						libMenu.addItem(
							line,
							function () {loadSound(line); }
						);
					}
				});
				libMenu.popup(world, pos);
			},
			'Select a sound from the media library'
		);
	}
    menu.popup(world, pos);
};

IDE_Morph.prototype.getCostumesList = function (dirname) {
    var dir,
        costumes = [];

	dir = this.getURL(dirname);
	
	dir.split('\n').forEach(
        function (line) {
            var startIdx = line.search(new RegExp('href="[^./?].*"')),
                endIdx,
                name;

            if (startIdx > 0) {
                name = line.substring(startIdx + 6);
                endIdx = name.search(new RegExp('"'));
                name = name.substring(0, endIdx);
                costumes.push(name);
            }
        }
    );
    costumes.sort(function (x, y) {
        return x < y ? -1 : 1;
    });
    return costumes;
};
//////////////////////////////////////////////////////////////////////////////////////////
// if you experience problems with public access rights to folders 'Costumes' and 'Backgrounds' 
//put a index.txt file inside them, write all the filenames to it and call getCostumesListNew or use the read_dir.php
// OTHERWISE
// do nothing and use the old getCostumesList
//---------------------------------------------------------------------------------
IDE_Morph.prototype.getCostumesListNew = function (dirname) {
    var dir,
        costumes = [];

	dir = this.getURL(dirname);
	
	dir.split('\n').forEach(
        function (line) {
          
                costumes.push(line);
            }
     );
    costumes.sort(function (x, y) {
        return x < y ? -1 : 1;
    });
    return costumes;
};
///////////////////////////////////////////////////////////////////////////////////////////

IDE_Morph.prototype.aboutSnap = function () {
    var dlg, aboutTxt, noticeTxt, creditsTxt, versions = '', translations,
        module, btn1, btn2, btn3, btn4, licenseBtn, translatorsBtn,
        world = this.world();

    aboutTxt = 'Snap! 4.04\nBuild Your Own Blocks\n'
        + 'Copyright \u24B8 2014 Jens M\u00F6nig and '
        + 'Brian Harvey\n'
        + 'jens@moenig.org, bh@cs.berkeley.edu\n\n'

        + 'Snap! is developed by the University of California, Berkeley\n'
        + '          with support from the National Science Foundation '
        + 'and MioSoft.   \n'

        + 'The design of Snap! is influenced and inspired by Scratch,\n'
        + 'from the Lifelong Kindergarten group at the MIT Media Lab\n\n'

        + 'for more information see http://snap.berkeley.edu\n'
        + 'and http://scratch.mit.edu\n'
		+ '\n--------"SnapHE.gr"--------\n is an unofficial modification created by Cosmas Haritopoulos, Greece'
		+ '\n'
		+ '\n     version 2.1 with network support\n'
		+ '\nlast updated'
		+ '\n- May 2016 -';
		

    noticeTxt = localize('License')
        + '\n\n'
        + 'Snap! is free software: you can redistribute it and/or modify\n'
        + 'it under the terms of the GNU Affero General Public License as\n'
        + 'published by the Free Software Foundation, either version 3 of\n'
        + 'the License, or (at your option) any later version.\n\n'

        + 'This program is distributed in the hope that it will be useful,\n'
        + 'but WITHOUT ANY WARRANTY; without even the implied warranty of\n'
        + 'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the\n'
        + 'GNU Affero General Public License for more details.\n\n'

        + 'You should have received a copy of the\n'
        + 'GNU Affero General Public License along with this program.\n'
        + 'If not, see http://www.gnu.org/licenses/';

    creditsTxt = localize('Contributors')
        + '\n\nNathan Dinsmore: Saving/Loading, Snap-Logo Design, '
        + 'countless bugfixes'
        + '\nKartik Chandra: Paint Editor'
        + '\nIan Reynolds: UI Design, Event Bindings, '
        + 'Sound primitives'
        + '\nIvan Motyashov: Initial Squeak Porting'
        + '\nDavide Della Casa: Morphic Optimizations'
        + '\nAchal Dave: Web Audio'
        + '\nJoe Otto: Morphic Testing and Debugging';

    for (module in modules) {
        if (Object.prototype.hasOwnProperty.call(modules, module)) {
            versions += ('\n' + module + ' (' +
                            modules[module] + ')');
        }
    }
    if (versions !== '') {
        versions = localize('current module versions:') + ' \n\n' +
            'morphic (' + morphicVersion + ')' +
            versions;
    }
    translations = localize('Translations') + '\n' + SnapTranslator.credits();

    dlg = new DialogBoxMorph();
    dlg.inform('About Snap', aboutTxt, world);
    btn1 = dlg.buttons.children[0];
    translatorsBtn = dlg.addButton(
        function () {
            dlg.body.text = translations;
            dlg.body.drawNew();
            btn1.show();
            btn2.show();
            btn3.hide();
            btn4.hide();
            licenseBtn.hide();
            translatorsBtn.hide();
            dlg.fixLayout();
            dlg.drawNew();
            dlg.setCenter(world.center());
        },
        'Translators...'
    );
    btn2 = dlg.addButton(
        function () {
            dlg.body.text = aboutTxt;
            dlg.body.drawNew();
            btn1.show();
            btn2.hide();
            btn3.show();
            btn4.show();
            licenseBtn.show();
            translatorsBtn.hide();
            dlg.fixLayout();
            dlg.drawNew();
            dlg.setCenter(world.center());
        },
        'Back...'
    );
    btn2.hide();
    licenseBtn = dlg.addButton(
        function () {
            dlg.body.text = noticeTxt;
            dlg.body.drawNew();
            btn1.show();
            btn2.show();
            btn3.hide();
            btn4.hide();
            licenseBtn.hide();
            translatorsBtn.hide();
            dlg.fixLayout();
            dlg.drawNew();
            dlg.setCenter(world.center());
        },
        'License...'
    );
    btn3 = dlg.addButton(
        function () {
            dlg.body.text = versions;
            dlg.body.drawNew();
            btn1.show();
            btn2.show();
            btn3.hide();
            btn4.hide();
            licenseBtn.hide();
            translatorsBtn.hide();
            dlg.fixLayout();
            dlg.drawNew();
            dlg.setCenter(world.center());
        },
        'Modules...'
    );
    btn4 = dlg.addButton(
        function () {
            dlg.body.text = creditsTxt;
            dlg.body.drawNew();
            btn1.show();
            btn2.show();
            translatorsBtn.show();
            btn3.hide();
            btn4.hide();
            licenseBtn.hide();
            dlg.fixLayout();
            dlg.drawNew();
            dlg.setCenter(world.center());
        },
        'Credits...'
    );
    translatorsBtn.hide();
    dlg.fixLayout();
    dlg.drawNew();
};

//modified for supporting custom categories
IDE_Morph.prototype.exportSprite = function (sprite) {
    var str = this.serializer.serialize(sprite.allParts()),
		catArray=[]; //array with the custom categories that contain local custom blocks for the sprites and the block count for each
//populate the catArray
		sprite.allParts().forEach(function (spriteEl){
			spriteEl.customBlocks.forEach(function (el){
				if (contains(SpriteMorph.prototype.customCategories, el.category)){ //if the block belongs to a custom category, add the category to the array
					/*if (catArray[el.category]){ //if category already added, just increase the count
						catArray[el.category]++;
					} else{
						catArray[el.category] = 1; // else add it to the array	
					}*/
					if (!contains(catArray,el.category)){
						catArray.push(el.category);
					}
				}	
			});	
		});	
/////////////////////////////////////	
    str = '<sprites app="'
        + this.serializer.app
        + '" version="'
        + this.serializer.version
        + '">'
        + str
		+ this.serializer.format('<customCategories>%</customCategories>',  //add the custom categories tag
									  SpriteMorph.prototype.customCategoriestoXML(this.serializer,catArray)
									)
        + '</sprites>';		
    this.saveXMLAs(str, sprite.name);
};




IDE_Morph.prototype.newProject = function (hoc) {
	var myself = this;
    this.source = 'local';
    if (this.stage) {
        this.stage.destroy();
    }
    if (location.hash.substr(0, 6) !== '#lang:') {
        location.hash = '';
    }
    this.globalVariables = new VariableFrame();
    this.currentSprite = new SpriteMorph(this.globalVariables);
    this.sprites = new List([this.currentSprite]);
    StageMorph.prototype.dimensions = new Point(480, 360);
    StageMorph.prototype.hiddenPrimitives = {};
    StageMorph.prototype.codeMappings = {};
    StageMorph.prototype.codeHeaders = {};
    StageMorph.prototype.enableCodeMapping = false;
    SpriteMorph.prototype.useFlatLineEnds = false;
    this.setProjectName('');
    this.projectNotes = '';
	this.createStage();
    this.add(this.stage);
    //-----------------------------
	this.createCorralBar();
	//-----------------------------
	this.controlBar.cloudButton.show(); // enable network support if disabled
	this.createCorral();
    this.selectSprite(this.stage.children[0]);
    this.fixLayout();
// +++++++++++++++++++++ restore the standard categories //custom categories
	SpriteMorph.prototype.hiddenStandardCategories =[]; //reset the categories
	SpriteMorph.prototype.customCategories = [];
	this.createCategories();
	this.fixLayout();
	this.currentCategory = 'motion';
	this.refreshPalette(true);

// +++++++++++++++++++++
	this.nextSteps([
        function () {
			if (myself.world().HOCmode && !myself.firstProject) {  //dispatch event signaling creating new project for Hour Of Code mode, hoc means it reacts to a load_project event
				window.dispatchEvent(new CustomEvent("project_loaded"));
				}
			}
		]);
    NetworkClient.sharedVariables={}; //clear the shared variables            
};

IDE_Morph.prototype.save = nop;


IDE_Morph.prototype.openProjectString = function (str) {
    var msg,
        myself = this;
    this.nextSteps([
        function () {
            msg = myself.showMessage('opening project...');
        },
		function () {nop(); }, // yield (bug in Chrome)
        function () {
            myself.rawOpenProjectString(str);
        },
        function () {
            msg.destroy();
			if (myself.world().HOCmode && !myself.firstProject) {  //dispatch event signaling finnished loading for Hour Of Code mode
				window.dispatchEvent(new CustomEvent("project_loaded"));
			}
        },
//+++---	send the "onload" message(event). Hat blocks "when i receive 'onload' are automatically activated when the project loads.
	function() {
		var hats =[];
		myself.stage.lastMessage = "onload";
        myself.stage.children.concat(myself.stage).forEach(function (morph) {
            if (morph instanceof SpriteMorph || morph instanceof StageMorph) {
                hats = hats.concat(morph.allHatBlocksFor("onload"));
            }
        });
        hats.forEach(function (block) {
            myself.stage.threads.processes.push(myself.stage.threads.startProcess(block, myself.stage.isThreadSafe));
        });
	}
//+++---
    ]);
};


IDE_Morph.prototype.openCloudDataString = nop;
IDE_Morph.prototype.rawOpenCloudDataString = nop;

originalrawOpenBlocksString = IDE_Morph.prototype.rawOpenBlocksString;
IDE_Morph.prototype.rawOpenBlocksString = function (str, name, silently) {
	originalrawOpenBlocksString.call(this,str, name, silently)
	this.createCategories(); //custom categories
	this.fixLayout(); //custom categories
}

//modified for shared variables handling
IDE_Morph.prototype.droppedText = function (aString, name) {
    
    if (aString.indexOf('<project') === 0) {
       NetworkClient.sharedVariables={}; //if a new project was dropped, clear the shared variables
    }
   originalIDEdroppedText.call(this,aString, name);
};


IDE_Morph.prototype.toggleAppMode = function (appMode) {
    var world = this.world();
    var elements = [
        this.logo,        
        this.controlBar.settingsButton,
        this.controlBar.stageSizeButton,
		this.stageHandle,
        this.corral,
        this.corralBar,
        this.spriteEditor,
        this.spriteBar,
        this.palette ,
        this.categories
    ];
    
    if (!world.HOCmode){
        elements.push(this.controlBar.projectButton); //<======================== official site
    }
    this.isAppMode = isNil(appMode) ? !this.isAppMode : appMode;

    Morph.prototype.trackChanges = false;
    if (this.isAppMode) {
        this.setColor(this.appModeColor);
        this.controlBar.setColor(this.color);
        this.controlBar.appModeButton.refresh();
        elements.forEach(function (e) {
		e.isVisible = false;
		e.changed();
  //          e.hide();
        });

        world.children.forEach(function (morph) {
            if (morph instanceof DialogBoxMorph) {
                morph.hide();
            }
        });
    } else {
        this.setColor(this.backgroundColor);
        this.controlBar.setColor(this.frameColor);
        elements.forEach(function (e) {
		e.isVisible = true;
		e.changed();
//            e.show();
        });

        this.stage.setScale(1);
        // show all hidden dialogs
        world.children.forEach(function (morph) {
            if (morph instanceof DialogBoxMorph) {
		         morph.show();
            }
        });
        // prevent scrollbars from showing when morph appears
        world.allChildren().filter(function (c) {
            return c instanceof ScrollFrameMorph;
        }).forEach(function (s) {
            s.adjustScrollBars();
        });
    }
    this.setExtent(this.world().extent()); // resume trackChanges
};



IDE_Morph.prototype.saveProjectsBrowser = function () {
    if (this.source === 'examples') {
        this.source = 'local'; // cannot save to examples
    }
    new ProjectDialogMorph(this, 'save').popUp();
};

// IDE_Morph localization

IDE_Morph.prototype.languageMenu = function () {
    var menu = new MenuMorph(this),
        world = this.world(),
        pos = this.controlBar.settingsButton.bottomLeft(),
        myself = this;
    SnapTranslator.languages().forEach(function (lang) {
        menu.addItem(
            (SnapTranslator.language === lang ? '\u2713 ' : '    ') +
                SnapTranslator.languageName(lang),
            function () {
			this.loadNewProject=false;
			myself.setLanguage(lang); }
        );
    });
    menu.popup(world, pos);
};


IDE_Morph.prototype.reflectLanguage = function (lang, callback) {
    var projectData;
    SnapTranslator.language = lang;
	
	this.world().children.forEach(function (morph) {
		if (morph instanceof BlockEditorMorph) {
			morph.updateDefinition(); // save custom blocks
			// otherwise, initBlocks() will reset the definition
			}
	});


    if (!this.loadNewProject) {
        if (Process.prototype.isCatchingErrors) {
            try {
                projectData = this.serializer.serialize(this.stage);
            } catch (err) {
                this.showMessage('Serialization failed: ' + err);
            }
        } else {
            projectData = this.serializer.serialize(this.stage);
        }
    }
    SpriteMorph.prototype.initBlocks();
    this.spriteBar.tabBar.tabTo('scripts');
    this.createCategories();
    this.createCorralBar();
	this.fixLayout();
    if (this.loadNewProject) {
        this.newProject();
    } else {
        this.openProjectString(projectData);
    }
    this.saveSetting('language', lang);
    if (callback) { 
	callback.call(this); }
};


IDE_Morph.prototype.initializeCloud = nop;
IDE_Morph.prototype.createCloudAccount = nop;
IDE_Morph.prototype.resetCloudPassword = nop;
IDE_Morph.prototype.changeCloudPassword = nop;
IDE_Morph.prototype.logout = nop;
IDE_Morph.prototype.exportProjectAsCloudData = nop;
IDE_Morph.prototype.cloudAcknowledge = nop;
IDE_Morph.prototype.cloudResponse = nop;
IDE_Morph.prototype.cloudError = nop; 
IDE_Morph.prototype.setCloudURL = nop;

IDE_Morph.prototype.saveProjectToCloud = function (name) {
    var myself = this;
    if (name) {
        this.showMessage('Saving project\nto the cloud...');
        this.setProjectName(name);
		cloudSaveProject(this, this.projectName);
/*
        SnapCloud.saveProject(
            this,
            function () {myself.showMessage('saved.', 2); },
            this.cloudError()
        );*/

    }
};

IDE_Morph.prototype.exportProjectSummary = function (useDropShadows) {
    var html, head, meta, css, body, pname, notes, toc, globalVars,
        stage = this.stage;

    function addNode(tag, node, contents) {
        if (!node) {node = body; }
        return new XML_Element(tag, contents, node);
    }

    function add(contents, tag, node) {
        if (!tag) {tag = 'p'; }
        if (!node) {node = body; }
        return new XML_Element(tag, contents, node);
    }

    function addImage(canvas, node, inline) {
        if (!node) {node = body; }
        var para = !inline ? addNode('p', node) : null,
            pic = addNode('img', para || node);
        pic.attributes.src = canvas.toDataURL();
        return pic;
    }

    function addVariables(varFrame) {
        var names = varFrame.names().sort(),
            isFirst = true,
            ul;
        if (names.length) {
            add(localize('Variables'), 'h3');
            names.forEach(function (name) {
                /*
                addImage(
                    SpriteMorph.prototype.variableBlock(name).scriptPic()
                );
                */
                var watcher, listMorph, li, img;

                if (isFirst) {
                    ul = addNode('ul');
                    isFirst = false;
                }
                li = addNode('li', ul);
                watcher = new WatcherMorph(
                    name,
                    SpriteMorph.prototype.blockColor.variables,
                    varFrame,
                    name
                );
                listMorph = watcher.cellMorph.contentsMorph;
                if (listMorph instanceof ListWatcherMorph) {
                    listMorph.expand();
                }
                img = addImage(watcher.fullImageClassic(), li);
                img.attributes.class = 'script';
            });
        }
    }

    function addBlocks(definitions) {
        if (definitions.length) {
            add(localize('Blocks'), 'h3');
            SpriteMorph.prototype.categories().forEach(function (category) { //just the categories fix
                var isFirst = true,
                    ul;
                definitions.forEach(function (def) {
                    var li, blockImg;
                    if (def.category === category) {
                        if (isFirst) {
                            add(
                                localize(
                                    category[0].toUpperCase().concat(
                                        category.slice(1)
                                    )
                                ),
                                'h4'
                            );
                            ul = addNode('ul');
                            isFirst = false;
                        }
                        li = addNode('li', ul);
                        blockImg = addImage(
                            def.templateInstance().scriptPic(),
                            li
                        );
                        blockImg.attributes.class = 'script';
                        def.sortedElements().forEach(function (script) {
                            var defImg = addImage(
                                script instanceof BlockMorph ?
                                        script.scriptPic()
                                                : script.fullImageClassic(),
                                li
                            );
                            defImg.attributes.class = 'script';
                        });
                    }
                });
            });
        }
    }

    pname = this.projectName || localize('untitled');

    html = new XML_Element('html');
    // html.attributes.contenteditable = 'true';

    head = addNode('head', html);

    meta = addNode('meta', head);
    meta.attributes['http-equiv'] = 'Content-Type';
    meta.attributes.content = 'text/html; charset=UTF-8';

    if (useDropShadows) {
        css = 'img {' +
            'vertical-align: top;' +
            'filter: drop-shadow(2px 2px 4px rgba(0,0,0,0.5));' +
            '-webkit-filter: drop-shadow(2px 2px 4px rgba(0,0,0,0.5));' +
            '-ms-filter: drop-shadow(2px 2px 4px rgba(0,0,0,0.5));' +
            '}' +
            '.toc {' +
            'vertical-align: middle;' +
            'padding: 2px 1em 2px 1em;' +
            '}';
    } else {
        css = 'img {' +
            'vertical-align: top;' +
            '}' +
            '.toc {' +
            'vertical-align: middle;' +
            'padding: 2px 1em 2px 1em;' +
            '}' +
            '.sprite {' +
            'border: 1px solid lightgray;' +
            '}';
    }
    addNode('style', head, css);

    add(pname, 'title', head);

    body = addNode('body', html);
    add(pname, 'h1');

    /*
    if (SnapCloud.username) {
        add(localize('by ') + SnapCloud.username);
    }
    */
    if (location.hash.indexOf('#present:') === 0) {
        add(location.toString(), 'a', body).attributes.href =
            location.toString();
        addImage(
            stage.thumbnail(stage.dimensions)
        ).attributes.class = 'sprite';
        add(this.serializer.app, 'h4');
    } else {
        add(this.serializer.app, 'h4');
        addImage(
            stage.thumbnail(stage.dimensions)
        ).attributes.class = 'sprite';
    }

    // project notes
    notes = Process.prototype.reportTextSplit(this.projectNotes, 'line');
    notes.asArray().forEach(
        function (paragraph) {add(paragraph); }
    );

    // table of contents
    add(localize('Contents'), 'h4');
    toc = addNode('ul');

    // sprites & stage
    this.sprites.asArray().concat([stage]).forEach(function (sprite) {
        var tocEntry = addNode('li', toc),
            scripts = sprite.scripts.sortedElements(),
            cl = sprite.costumes.length(),
            pic,
            ol;

        addNode('hr');
        addImage(
            sprite.thumbnail(new Point(40, 40)),
            tocEntry,
            true
        ).attributes.class = 'toc';
        add(sprite.name, 'a', tocEntry).attributes.href = '#' + sprite.name;

        add(sprite.name, 'h2').attributes.id = sprite.name;
        // if (sprite instanceof SpriteMorph || sprite.costume) {
        pic = addImage(
            sprite.thumbnail(sprite.extent().divideBy(stage.scale))
        );
        pic.attributes.class = 'sprite';
        if (sprite instanceof SpriteMorph) {
            if (sprite.exemplar) {
                addImage(
                    sprite.exemplar.thumbnail(new Point(40, 40)),
                    add(localize('Kind of') + ' ' + sprite.exemplar.name),
                    true
                ).attributes.class = 'toc';
            }
            if (sprite.anchor) {
                addImage(
                    sprite.anchor.thumbnail(new Point(40, 40)),
                    add(localize('Part of') + ' ' + sprite.anchor.name),
                    true
                ).attributes.class = 'toc';
            }
            if (sprite.parts.length) {
                add(localize('Parts'), 'h3');
                ol = addNode('ul');
                sprite.parts.forEach(function (part) {
                    var li = addNode('li', ol, part.name);
                    addImage(part.thumbnail(new Point(40, 40)), li, true)
                        .attributes.class = 'toc';
                });
            }
        }

        // costumes
        if (cl > 1 || (sprite.getCostumeIdx() !== cl)) {
            add(localize('Costumes'), 'h3');
            ol = addNode('ol');
            sprite.costumes.asArray().forEach(function (costume) {
                var li = addNode('li', ol, costume.name);
                addImage(costume.thumbnail(new Point(40, 40)), li, true)
                    .attributes.class = 'toc';
            });
        }

        // sounds
        if (sprite.sounds.length()) {
            add(localize('Sounds'), 'h3');
            ol = addNode('ol');
            sprite.sounds.asArray().forEach(function (sound) {
                add(sound.name, 'li', ol);
            });
        }

        // variables
        addVariables(sprite.variables);

        // scripts
        if (scripts.length) {
            add(localize('Scripts'), 'h3');
            scripts.forEach(function (script) {
                var img = addImage(script instanceof BlockMorph ?
                        script.scriptPic()
                                : script.fullImageClassic());
                img.attributes.class = 'script';
            });
        }

        // custom blocks
        addBlocks(sprite.customBlocks);
    });

    // globals
    globalVars = stage.globalVariables();
    if (Object.keys(globalVars.vars).length || stage.globalBlocks.length) {
        addNode('hr');
        add(
            localize('For all Sprites'),
            'a',
            addNode('li', toc)
        ).attributes.href = '#global';
        add(localize('For all Sprites'), 'h2').attributes.id = 'global';

        // variables
        addVariables(globalVars);

        // custom blocks
        addBlocks(stage.globalBlocks);
    }

    this.saveFileAs(
        '<!DOCTYPE html>' + html.toString(),
        'text/html;charset=utf-8,',
        pname,
        true // request opening a new window.
    );
};


//this is a modification of the original exportScriptsPicture, 
//which simply returns the produced canvas, in order to pass it 
//to write_summary.php and save it to cloud as well.
//This produces the project summary that is visible to the teacher
//in Joomla.
//Everytime a student saves a project in the cloud, the summary picture
//is saved as well.
//Only visible sprites(not secret) and
//custom blocks(not locked and hidden) are depicted.
IDE_Morph.prototype.exportScriptsPictureAsCanvas = function () {
    var pics = [],
        pic,
        padding = 20,
        w = 0,
        h = 0,
        y = 0,
        ctx;

    // collect all script pics
    this.sprites.asArray().forEach(function (sprite) {
        if (!sprite.isSecret){
            pics.push(sprite.image);
            pics.push(sprite.scripts.scriptsPicture());
            sprite.customBlocks.forEach(function (def) {
                if (!def.isLocked && !def.isHidden){
                    pics.push(def.scriptsPicture());
                }    
            });
        }    
    });
    
    pics.push(this.stage.fullImageClassic());
    if (!this.stage.isSecret){
        pics.push(this.stage.scripts.scriptsPicture());
        this.stage.customBlocks.forEach(function (def) {
            if (!def.isLocked && !def.isHidden){
                pics.push(def.scriptsPicture());
            }    
        });
    }   
    
    // collect global block pics
    this.stage.globalBlocks.forEach(function (def) {
        if (!def.isLocked && !def.isHidden){
            pics.push(def.scriptsPicture());
        }    
    });

    pics = pics.filter(function (each) {return !isNil(each); });

    // determine dimensions of composite
    pics.forEach(function (each) {
        w = Math.max(w, each.width);
        h += (each.height);
        h += padding;
    });
    h -= padding;
    pic = newCanvas(new Point(w, h));
    ctx = pic.getContext('2d');

    // draw all parts
    pics.forEach(function (each) {
        ctx.drawImage(each, 0, y);
        y += padding;
        y += each.height;
    });
    //this.saveCanvasAs(pic, this.projectName || localize('Untitled'), true);
    return pic.toDataURL();
};



// ProjectDialogMorph inherits from DialogBoxMorph:
ProjectDialogMorph.prototype.buildContents = function () {
    var thumbnail, notification;

    this.addBody(new Morph());
    this.body.color = this.color;

    this.srcBar = new AlignmentMorph('column', this.padding / 2);

    if (this.ide.cloudMsg) {
        notification = new TextMorph(
            this.ide.cloudMsg,
            10,
            null, // style
            false, // bold
            null, // italic
            null, // alignment
            null, // width
            null, // font name
            new Point(1, 1), // shadow offset
            new Color(255, 255, 255) // shadowColor
        );
        notification.refresh = nop;
        this.srcBar.add(notification);
    }

    //this.addSourceButton('cloud', localize('Cloud'), 'cloud'); //<======================== official site
	if (!world.HOCmode){ // in HOC mode student can only save to cloud
		this.addSourceButton('local', localize('Browser'), 'storage');
	}
        
    if (this.task === 'open' && !world.HOCmode) {  
        this.addSourceButton('examples', localize('Examples'), 'poster');
    }
    this.srcBar.fixLayout();
    this.body.add(this.srcBar);

    if (this.task === 'save') {
        this.nameField = new InputFieldMorph(this.ide.projectName);
        this.body.add(this.nameField);
    }

    this.listField = new ListMorph([]);
    this.fixListFieldItemColors();
    this.listField.fixLayout = nop;
    this.listField.edge = InputFieldMorph.prototype.edge;
    this.listField.fontSize = InputFieldMorph.prototype.fontSize;
    this.listField.typeInPadding = InputFieldMorph.prototype.typeInPadding;
    this.listField.contrast = InputFieldMorph.prototype.contrast;
    this.listField.drawNew = InputFieldMorph.prototype.drawNew;
    this.listField.drawRectBorder = InputFieldMorph.prototype.drawRectBorder;

    this.body.add(this.listField);

    this.preview = new Morph();
    this.preview.fixLayout = nop;
    this.preview.edge = InputFieldMorph.prototype.edge;
    this.preview.fontSize = InputFieldMorph.prototype.fontSize;
    this.preview.typeInPadding = InputFieldMorph.prototype.typeInPadding;
    this.preview.contrast = InputFieldMorph.prototype.contrast;
    this.preview.drawNew = function () {
        InputFieldMorph.prototype.drawNew.call(this);
        if (this.texture) {
            this.drawTexture(this.texture);
        }
    };
    this.preview.drawCachedTexture = function () {
        var context = this.image.getContext('2d');
        context.drawImage(this.cachedTexture, this.edge, this.edge);
        this.changed();
    };
    this.preview.drawRectBorder = InputFieldMorph.prototype.drawRectBorder;
    this.preview.setExtent(
        this.ide.serializer.thumbnailSize.add(this.preview.edge * 2)
    );

    this.body.add(this.preview);
    this.preview.drawNew();
    if (this.task === 'save') {
        thumbnail = this.ide.stage.thumbnail(
            SnapSerializer.prototype.thumbnailSize
        );
        this.preview.texture = null;
        this.preview.cachedTexture = thumbnail;
        this.preview.drawCachedTexture();
    }

    this.notesField = new ScrollFrameMorph();
    this.notesField.fixLayout = nop;

    this.notesField.edge = InputFieldMorph.prototype.edge;
    this.notesField.fontSize = InputFieldMorph.prototype.fontSize;
    this.notesField.typeInPadding = InputFieldMorph.prototype.typeInPadding;
    this.notesField.contrast = InputFieldMorph.prototype.contrast;
    this.notesField.drawNew = InputFieldMorph.prototype.drawNew;
    this.notesField.drawRectBorder = InputFieldMorph.prototype.drawRectBorder;

    this.notesField.acceptsDrops = false;
    this.notesField.contents.acceptsDrops = false;

    if (this.task === 'open') {
        this.notesText = new TextMorph('');
    } else { // 'save'
        this.notesText = new TextMorph(this.ide.projectNotes);
        this.notesText.isEditable = true;
        this.notesText.enableSelecting();
    }

    this.notesField.isTextLineWrapping = true;
    this.notesField.padding = 3;
    this.notesField.setContents(this.notesText);
    this.notesField.setWidth(this.preview.width());

    this.body.add(this.notesField);

    if (this.task === 'open') {
        this.addButton('openProject', 'Open');
        this.action = 'openProject';
    } else { // 'save'
        this.addButton('saveProject', 'Save');
        this.action = 'saveProject';
    }

    this.deleteButton = this.addButton('deleteProject', 'Delete');
    this.addButton('cancel', 'Cancel');

    if (notification) {
        this.setExtent(new Point(455, 335).add(notification.extent()));
    } else {
        this.setExtent(new Point(455, 335));
    }
    this.fixLayout();
    this.setSource('local');
    /* //<======================== official site
	if (world.HOCmode){
		this.setSource('cloud');
	}
    */    
};


// ProjectDialogMorph ops

ProjectDialogMorph.prototype.setSource = function (source,dir) {
    var myself = this,
        user_path='',
		exdir = dir || [];


    this.source = source; //this.task === 'save' ? 'local' : source;
    this.srcBar.children.forEach(function (button) {
        button.refresh();
    });
    switch (this.source) {
/*    case 'cloud':  //<======================== official site
/////////////// HOW "cloud" works ////////////////////////////////////////
// Cloud is implement in collaboration with Joomla.
// Every student signs in and the administrator grands the proper rights.
// For every valid student, a folder inside 'studentproj' is created, with student's class and username.
// The path to the student projects is 'studentproj/<class>/<username>
// The operation is identical to 'examples'(supports subforlders too) but...
// in order to have access to the student folder, you must login to Joomla first.
// This is checked by calling th check_user.php, which checks the logged user and if is a valid one returns its projects path, otherwise ''
//////////////////////////////////////////////////////////////////////////

    user_path=myself.ide.getURL(host + '/php/com/check_userpath.php');  // if it is the first time(the 'cloud' button was pressed) check for user login
	this.ide.cloudPath=''; //reset cloud path
	if (user_path !=='') { // user is logged in
	 
		if (user_path == 'admin') {
			user_path =''; // if the administrator is logged in give access to all student projects
			this.ide.cloudPath=exdir.toString().replace(/,/g,""); //set the path so he can save on student folders
			this.ide.cloudPublic = true;
		} else { //reset the path for ordinal users
			this.ide.cloudPath = '';
			this.ide.cloudPublic = null;
		} 
		this.projectList = this.getProjectListNew('studentproj/'+user_path,exdir.toString().replace(/,/g,""));
	} else { 
		myself.ide.inform('Error','Please login to joomla');
		this.projectList=[];
		myself.destroy();
		return;
	}
	break;
*/
    case 'examples': //<======================== official site
		//user_path=myself.ide.getURL(host + '/php/com/check_userpath.php'); //check if user is logged in
		if (this.task=='open') { //everybody can open, bur only admin can save
			this.projectList = this.getProjectListNew('examples',exdir.toString().replace(/,/g,"")); 
			this.ide.cloudPublic = true;
			this.ide.cloudPath=exdir.toString().replace(/,/g,""); //set the path so admin can save on examples folders
		} else { 
		//	myself.ide.inform('Error','Please login to joomla as administrator');
			this.projectList=[];
			myself.destroy();
			return;
		}	
		// exdir is an array with the folders. Their order constructs the path (replace ',' globally) 
        break;
    case 'local':
		this.ide.cloudPath=''; //reset cloud path
        this.projectList = this.getLocalProjectList();
        break;
    }

    this.listField.destroy();
    this.listField = new ListMorph(
        this.projectList,
        this.projectList.length > 0 ?
                function (element) {
                    return element.name;
                } : null,
       // null,
		[
			[
                'bold',
                function (proj) {return proj.isfolder == true || !proj.Public ; } //make folders and private projects bold
			] 
         ],
        function () {myself.ok(); }
    );

    this.fixListFieldItemColors();
    this.listField.fixLayout = nop;
    this.listField.edge = InputFieldMorph.prototype.edge;
    this.listField.fontSize = InputFieldMorph.prototype.fontSize;
    this.listField.typeInPadding = InputFieldMorph.prototype.typeInPadding;
    this.listField.contrast = InputFieldMorph.prototype.contrast;
    this.listField.drawNew = InputFieldMorph.prototype.drawNew;
    this.listField.drawRectBorder = InputFieldMorph.prototype.drawRectBorder;

    if (this.source === 'local') {
        this.listField.action = function (item) {
            var src, xml;
            if (item.name === undefined) {return; }
            if (myself.nameField) {
                myself.nameField.setContents(item.name || '');
            }
            if (myself.task === 'open') {

                src = localStorage['-snap-project-' + item.name];
                xml = myself.ide.serializer.parse(src);

                myself.notesText.text = xml.childNamed('notes').contents
                    || '';
                myself.notesText.drawNew();
                myself.notesField.contents.adjustBounds();
                myself.preview.texture = xml.childNamed('thumbnail').contents
                    || null;
                myself.preview.cachedTexture = null;
                myself.preview.drawNew();
            }
            myself.edit();
        };
    } else { // 'examples', 'cloud' 
        this.listField.action = function (item) {            
            var src, xml;           
            if (item.name === undefined) {return; }
//----------
		if (item.isfolder==true){
			if (item.name !== "../"){
				exdir.push(item.name);
			} else {exdir.pop();}
			myself.setSource(myself.source,exdir);  
			return;
		}
//----------
            if (myself.nameField) {
                myself.nameField.setContents(item.name || '');
            }
			
            if (item.Public){ //if it is a public project or example
		src = myself.ide.getURL(
		host+ (myself.source=='examples' ? '/examples/' : '/studentproj/'+user_path) +exdir.toString().replace(/,/g,"") + item.name + '.xml' 
//+++++++++++++ add the path to find the example or student project
			);

		myself.buttons.fixLayout();
		myself.fixLayout();
            } 

            xml = myself.ide.serializer.parse(src);
            myself.notesText.text = xml.childNamed('notes').contents
                || '';
            myself.notesText.drawNew();
            myself.notesField.contents.adjustBounds();
            myself.preview.texture = xml.childNamed('thumbnail').contents
                || null;
            myself.preview.cachedTexture = null;
            myself.preview.drawNew();
            myself.edit();

//+++++++++++++ add the path to example or student project name in order to open in OpenProject
			myself.ide.cloudPublic = item.Public || null; // if cloud project is public set the variable
        };
    }
    this.body.add(this.listField);
    if (this.source === 'examples' && world.role == 'STUDENT') {
        this.deleteButton.hide();
    } else { // local, cloud
        this.deleteButton.show();
		}
    this.buttons.fixLayout();
    this.fixLayout();
    if (this.task === 'open') {
        this.clearDetails();
    }
};



//===================================================================
ProjectDialogMorph.prototype.getProjectListNew = function (root,directory) {
    var dir,
        projects = [],
		folder = directory || '',
		myself=this;
		

function endsWith(str, suffix) {
    return str.indexOf(suffix, str.length - suffix.length-1) !== -1; // -1 for ending \n character
}

    dir = this.ide.getURL(host+'/php/com/read_dir.php?root=/'+root+'/&dir='+folder);//'http://snap.berkeley.edu/snapsource/Examples/');
    dir.split('\n').forEach(
        function (line) {
            var name,
		isfolder=false,
		dta;
	
            if (line.length>0){
		if (endsWith(line,'.xml')) {
                    name = line.substring(0,line.length-4); //<======================== official site
                    isfolder = false;
		} else if (endsWith(line,'/')) {
                    name = line.substring(0,line.length);  //<======================== official site
                    isfolder = true;
		} else return;  
		
                dta = {
                    name: name,
                    thumb: null,
                    notes: null,
                    path: folder, //path is '' for ordinal users. It's useful when root folder contains subfolders (admin, examples)
                    Public : true,
                    isfolder: isfolder
		};
                projects.push(dta);
            }
 	}
    );
 
   projects.sort(function (x, y) {
		if (endsWith(x.name,'/') && !endsWith(y.name,'/')) { //put folders first -- holds for examples
		return -1;
		} else if (endsWith(y.name,'/') && !endsWith(x.name,'/'))
		{ return 1;}
        return x.name < y.name ? -1 : 1;
    });
    return projects;
};

ProjectDialogMorph.prototype.openProject = function () {
    var proj = this.listField.selected,
        src;

    if (!isObject(proj)) { //that means, (empty) selected
        return; 
    }
    
    this.ide.source = this.source;        
    if (this.source === 'cloud') {       
		this.ide.showMessage('opening..');
		if (proj.Public){//this.ide.cloudPublic){  // if this is a PUBLIC project
			src = this.ide.getURL(
				host + '/php/com/read_file.php?name='+ //+++++++++++++++++  'http://snap.berkeley.edu/snapsource/Examples/' +
                proj.path+ proj.name + '.xml'
			);
			if (src=="") { //Error handling
				this.ide.inform("ERROR","Unable to open file\n"+host + '/php/com/read_file.php?name='+proj.path+ proj.name + '.xml');
				this.destroy(); return;
			}                      
			this.ide.openProjectString(src);
			this.ide.cloudPublic = true;
			this.destroy();
		} 
               
    } else if (this.source === 'examples') {
        src = this.ide.getURL(
				host + '/examples/'+ //+++++++++++++++++  'http://snap.berkeley.edu/snapsource/Examples/' +
                proj.path + proj.name + '.xml?v=' + Date.now() //always get the latest version of the file
        );
        this.ide.openProjectString(src);
        this.destroy();
    } else { // 'local'
        this.ide.openProject(proj.name);
        this.destroy();
    }
    NetworkClient.sharedVariables={}; //clreal shared variables, if any, from previouw project
};

ProjectDialogMorph.prototype.saveProject = function () {
    var name = this.nameField.contents().text.text,
        notes = this.notesText.text,
        myself = this, founditem;

    this.ide.projectNotes = notes || this.ide.projectNotes;
    if (name) {
        if (this.source === 'cloud' || this.source=='examples') { //examples only for admin in dev mode
			 myself.ide.source = myself.source; //set the appropriate source

            if (founditem = detect(
                    this.projectList,
                    function (item) { return item.name === name; }
                )) {
			
				this.ide.confirm(
                    localize(
                        'Are you sure you want to replace'
                    ) + '\n"' + name + '"?',
                    'Replace Project',
                    function () {
						myself.ide.cloudPublic = founditem.Public;
						myself.ide.setProjectName(name);
                        myself.saveCloudProject();
                    }
                );
            } else {
                this.ide.setProjectName(name);
				if (this.ide.cloudPath=='') {
				this.ide.cloudPublic = true;} //project is always public at first save for ordinal users
                this.saveCloudProject();
            }
        } else { // 'local'
            if (detect(
                    this.projectList,
                    function (item) {return item.name === name; }
                )) {
                this.ide.confirm(
                    localize(
                        'Are you sure you want to replace'
                    ) + '\n"' + name + '"?',
                    'Replace Project',
                    function () {
                        myself.ide.setProjectName(name);
                        myself.ide.source = 'local';
                        myself.ide.saveProject(name);
                        myself.destroy();
                    }
                );
            } else {
                this.ide.setProjectName(name);
                myself.ide.source = 'local';
                this.ide.saveProject(name);
                this.destroy();
            }
        }
    }
};

ProjectDialogMorph.prototype.saveCloudProject = function () {
    var myself = this;
    this.ide.showMessage('Saving project\nto the cloud...',2);
	//myself.ide.source = 'cloud';
	cloudSaveProject(myself.ide, myself.ide.projectName);

    this.destroy();
};

ProjectDialogMorph.prototype.deleteProject = function () {
    var myself = this,
        proj,
        name,root;

    if (this.source === 'cloud' || this.source=='examples') {
        proj = this.listField.selected,
		name = proj.Public ? proj.name.substr(proj.name.lastIndexOf('/')+1)  : proj.name;
		root = this.source=='examples' ? 'examples' : 'studentproj';
        if (proj) {
            this.ide.confirm(
                localize(
                    'Are you sure you want to delete '
                ) + '\n"'+ name+ '"?',
                'Delete Project',
                function () {
				var msg;
				if (myself.ide.cloudPublic) { //delete public project?
				msg = myself.ide.getURL(host+'/php/com/delete_public.php?root='+root+'&name='+myself.ide.cloudPath+name);
					//cloudPath enables administrator to delete public projects of students
                                }
				myself.ide.showMessage(msg,1.5);
				myself.setSource(myself.source); // refresh list
                }
            );
        }
    } else { // 'local, examples'
        if (this.listField.selected) {
            name = this.listField.selected.name;
            this.ide.confirm(
                localize(
                    'Are you sure you want to delete'
                ) + '\n"' + name + '"?',
                'Delete Project',
                function () {
                    delete localStorage['-snap-project-' + name];
                    myself.setSource(myself.source); // refresh list
                }
            );
        }
    }
};

ProjectDialogMorph.prototype.shareProject = nop;
ProjectDialogMorph.prototype.unshareProject = nop;
ProjectDialogMorph.prototype.getExamplesProjectList = nop;
ProjectDialogMorph.prototype.installCloudProjectList = nop;
ProjectDialogMorph.prototype.openCloudProject = nop;
ProjectDialogMorph.prototype.rawOpenCloudProject = nop;

var originalSpriteIconMorphInit = SpriteIconMorph.prototype.init;
SpriteIconMorph.prototype.init = function (aSprite, aTemplate) {
	originalSpriteIconMorphInit.call(this,aSprite, aTemplate);
	if(world.role!='STUDENT' || !this.object.isLocked ){ 
	this.isDraggable = true;}
	else {this.isDraggable = false;}  // if in STUDENT mode, and Sprite isLOCKED, then icon can not be dragged == deleted
	
};


SpriteIconMorph.prototype.userMenu = function () {
    var menu = new MenuMorph(this),
		ide = this.parentThatIsA(IDE_Morph);
        myself = this;
    if (this.object instanceof StageMorph && !world.HOCmode) {
        menu.addItem(
            'pic...',
            function () {
                window.open(myself.object.fullImageClassic().toDataURL());
            },
            'open a new window\nwith a picture of the stage'
        );
        return menu;
    }
    if (!(this.object instanceof SpriteMorph)) {return null; }
    menu.addItem("show", 'showSpriteOnStage');
    if(world.role!='STUDENT' || !this.object.isLocked ){  // if isLocked can not be deleted, duplicated, inherited or nested in STUDENT role
		menu.addItem("duplicate", 'duplicateSprite');
		if (ide.sprites.asArray().length>1 || !ide.stage.isSecret){
			menu.addItem("delete", 'removeSprite'); 
		}        
		menu.addLine();
		if (StageMorph.prototype.enableInheritance) {
			menu.addItem("parent...", 'chooseExemplar');
		}
		if (this.object.anchor) {
			menu.addItem(
				localize('detach from') + ' ' + this.object.anchor.name,
				function () {myself.object.detachFromAnchor(); }
			);
		}
		if (this.object.parts.length) {
			menu.addItem(
				'detach all parts',
				function () {myself.object.detachAllParts(); }
			);
		}
	}	
	if (!world.HOCmode){
		menu.addItem("export...", 'exportSprite');
	}
	//share the sprite over the network
	if (NetworkClient.io !== null && NetworkClient.io.connected){
		menu.addItem("share...", function(){
			ide.emitSprite(myself.object);
		}); 
	}	
    return menu;
};


//------------ cloudSaveProject ------------------
//Saves a student project and its summary to the cloud
function cloudSaveProject(ide, name){
	var url,data,head,request,root,sumUrl,sumData,sumHead,sumRequest ;

	data = encodeURIComponent(ide.serializer.serialize(ide.stage)); 
	if (ide.cloudPublic){ //if it is a public cloud project
		url = host + '/php/com/write_public.php';
		name = ide.cloudPath + name; //if the administrator is logged save in the selected directory
		root = ide.source=='examples' ? 'examples' : 'studentproj';
                head = "root="+root+"&name="+name+"&data=" +data;
                if (root=='studentproj'){ //save the summary only on student projects                    
                    sumUrl = host + '/php/com/write_summary.php';
                    sumData = ide.exportScriptsPictureAsCanvas();
                    sumHead = "root="+root+"&name="+name+"&data=" +sumData;
                }    
	} 


	try {
		request = new XMLHttpRequest()//{responseType: "json"});
		request.open('POST', url, false);
		request.setRequestHeader("Content-type","application/x-www-form-urlencoded");
		request.send(head);
		if (request.status === 200) {
                         if (root=='studentproj'){ //save the summary only on student projects
                            try { //The project has been saved. Now save the Summary as well
                                sumRequest = new XMLHttpRequest()//{responseType: "json"});
                                sumRequest.open('POST', sumUrl, false);
                                sumRequest.setRequestHeader("Content-type","application/x-www-form-urlencoded");
                                sumRequest.send(sumHead);
                                if (request.status === 200 && sumRequest.status === 200) {
                                    ide.inform('Success','The project has been saved to the cloud');//ide.showMessage(request.responseText,1.5);
                                } else {
                                    ide.inform('Error','The summary was not saved to the cloud');
                                }    
                            } catch (err) {
                                ide.inform('Error','Failed to connect to the cloud\nSummary waw not saved')//ide.showMessage('general error...',2);
                            }
                        } else{
                            ide.inform('Success','The project has been saved to the cloud');
                        }       
		} else {
			ide.inform('Error','The project was not saved to the cloud')//ide.showMessage('save failed',2);
		}      
	} catch (err) {
		ide.inform('Error','Failed to connect to the cloud\nNothing saved')//ide.showMessage('general error...',2);
	}
}

//change Stage Handle color for flat design if sprite bar is hidden
OriginalStageHandleMorphInit = StageHandleMorph.prototype.init;
StageHandleMorph.prototype.init = function (target){
	OriginalStageHandleMorphInit.call(this,target);	
	this.color = MorphicPreferences.isFlat && target.hideSpriteBar ? //target is the stage
				this.color.darker(15): this.color;
	this.drawNew();	
}