//custom categories
SpriteMorph.prototype.standardCategories =
    [
        'motion',
        'control',
        'looks',
        'sensing',
        'sound',
        'operators',
        'pen',
        'variables',
	'lists',
        'other'//,
		//'depository'		
    ];
SpriteMorph.prototype.hiddenStandardCategories = [];   //custom categories
SpriteMorph.prototype.customCategories = [];		   //custom categories	
SpriteMorph.prototype.blockColor = {
    motion : new Color(74, 108, 212),
    looks : new Color(143, 86, 227),
    sound : new Color(207, 74, 217),
    pen : new Color(0, 161, 120),
    control : new Color(230, 168, 34),
    sensing : new Color(4, 148, 220),
    operators : new Color(98, 194, 19),
    variables : new Color(243, 118, 29),
    lists : new Color(217, 77, 17),
    other: new Color(150, 150, 150),
	depository : new Color(170, 70, 0)
};

SpriteMorph.prototype.categories = function (){
	var ide, //The primary IDE_Morph
			categories = SpriteMorph.prototype.standardCategories.concat(SpriteMorph.prototype.customCategories),
                        visibleCategories =  categories.filter(function(cat) {return SpriteMorph.prototype.hiddenStandardCategories.indexOf(cat) < 0;});           
	if (typeof world !== 'undefined'){
		ide = world.children[0];
		if (ide) { //in student mode filter out the hidden standard categories
			categories = world.role=="STUDENT" ? ( ide.stage.depositoryCommands.length>0 || visibleCategories.length==0 ? ['depository'] 
                                                                                                : visibleCategories
												)
                                                            : categories.concat(['depository']);  
		}
	}
	return categories;
}

originalSpriteMorphinitBlocks = SpriteMorph.prototype.initBlocks;
SpriteMorph.prototype.initBlocks = function () {
	originalSpriteMorphinitBlocks();
//--@@--  lockedReceiveMessage is special command for the teachers that can create a hat block to respond to a single message
//--@@-- when saved and putted on scripts, it appears in student as an ordinary hat block
	SpriteMorph.prototype.blocks.lockedReceiveMessage = {
				teachersOnly: true,
				type: 'hat',
				category: 'control',
				spec: '        %ls        ',
				defaults: [[localize('any message')]]
	};
	SpriteMorph.prototype.blocks.constantValue = { //for consant inputs inside blocks, visible in teachers palette only
				teachersOnly: true,
				type: 'reporter',
				category: 'other',
				spec: '%ls'				
	};
//--@@--
//-- Network support
	SpriteMorph.prototype.blocks.doBroadcastOnNetwork = {
            type: 'command',
            category: 'control',
            spec: 'broadcast %msg on Network'
    };
	SpriteMorph.prototype.blocks.doReportUserData = {
            type: 'reporter',
            category: 'sensing',
            spec: 'variable %nvar of user %usr'
    };
	SpriteMorph.prototype.blocks.doBroadcastVariable = {
            type: 'command',
            category: 'variables',
            spec: 'update %svar for user %nusr'
    };
//-- Network support	
}
SpriteMorph.prototype.initBlocks();

var originalSpriteMorphInit = SpriteMorph.prototype.init;
SpriteMorph.prototype.init = function(globals){
	originalSpriteMorphInit.call(this,globals);
	this.isSecret = false; //is secret sprite
	this.isLocked = false; // hidden rotation buttons
        this.hints = null; //hints script
}

var originalSpriteMorphVariableBlock = SpriteMorph.prototype.variableBlock;
SpriteMorph.prototype.variableBlock = function (varName) {
    var block = originalSpriteMorphVariableBlock.call(this,varName);
	block.isHidden = false; //------------------------------
    return block;
};


/////////////////////////////////
SpriteMorph.prototype.blockTemplates = function (category) {
    var blocks = [], myself = this, varNames, button,
        cat = category || 'motion', txt,
		inheritedVars = this.inheritedVariableNames(),
		ide = this.parentThatIsA(IDE_Morph), // for variables 
                bugBlock; //for weird bug 
		//stage, // for depository

    function block(selector, isGhosted) {
        if (StageMorph.prototype.hiddenPrimitives[selector] && world.role=='STUDENT') { // --------------- hide when STUDENT
            return null;
        }
		// else ...
        var newBlock = SpriteMorph.prototype.blockForSelector(selector, true);
        newBlock.isTemplate = true;
        if (isGhosted) {newBlock.ghost(); }
        if (StageMorph.prototype.hiddenPrimitives[selector]){ //if hidden in teachers mode
            newBlock.hide();
        }
	return newBlock;
    }

	function watcherToggle(selector) {
        if (StageMorph.prototype.hiddenPrimitives[selector]) {
            return null;
        }
        var info = SpriteMorph.prototype.blocks[selector];
        return new ToggleMorph(
            'checkbox',
            this,
            function () {
                myself.toggleWatcher(
                    selector,
                    localize(info.spec),
                    myself.blockColor[info.category]
                );
            },
            null,
            function () {
                return myself.showingWatcher(selector);
            },
            null
        );
    }
	
    function variableBlock(varName,isHidden) {
        var newBlock = SpriteMorph.prototype.variableBlock(varName);
        newBlock.isDraggable = false;
        newBlock.isTemplate = true;
        if (contains(inheritedVars, varName)) {
            newBlock.ghost();
        }
        if (isHidden){newBlock.hide();}
        return newBlock;
    }
//+++++++++++++++++++++++++++++++++++++++++++++++
	function customBlock(spec) {
		return detect(ide.stage.globalBlocks, function(definition){			
					return definition.blockSpec() === spec;
				});
	}
// ++++++++++++++++++++++++++++++++++++++++++++++
   
    function variableWatcherToggle(varName) {
        return new ToggleMorph(
            'checkbox',
            this,
            function () {
                myself.toggleVariableWatcher(varName);
				},
            /*varName,*/null,
            function () {
                return myself.showingVariableWatcher(varName);
            },
            null
        );
    }

    function helpMenu() {
        var menu = new MenuMorph(this);
        menu.addItem('help...', 'showHelp');
        return menu;
    }
	
	function addVar(pair) {
        var ide;
        if (pair) {
			if  (!(world.role=='STUDENT' && pair[0].indexOf("$$") == 0 )) { //handle hiddens
				if (myself.isVariableNameInUse(pair[0], pair[1])) {
					myself.inform('that name is already in use');
				} else {
						ide = myself.parentThatIsA(IDE_Morph);
						myself.addVariable(pair[0], pair[1]);
						if (!myself.showingVariableWatcher(pair[0])) {
							myself.toggleVariableWatcher(pair[0], pair[1]);
						}
						ide.flushBlocksCache('variables'); // b/c of inheritance
						ide.refreshPalette();
				}
			} else { myself.inform('Variable name can not start with $$');} //handle hiddens	
        }
    }

/////////////////////////////////////////////////////////////////////	add the buttons for special blocks: $$run$$ etc
	if (ide) {
		ide.stage.specialBlocks.forEach( function (def){
			var blk = def.templateInstance();	
			if (blk.blockSpec === "$$run$$") {
				button = new PushButtonMorph(
							myself,
							function () {
							blk.receiver = function () { return myself;} // palette has not been created yet. Overide the receiver to current sprite in order to execute the block
							ide.stage.threads.toggleProcess(blk, myself);
						   },
							'    '+localize('run')+'     '
						);
				button.labelColor = new Color(0, 150, 50);
				button.fontSize = 12;
				button.corner = 6;
				button.padding = 5;
				button.edge = 4;
                                button.fixLayout();
				blocks.push(button);
			} else {
				button = new PushButtonMorph(
							myself,
							function () {
							blk.receiver = function () { return myself;} // palette has not been created yet. Overide the receiver to current sprite in order to execute the block
							ide.stage.threads.toggleProcess(blk,myself);
						   },
							"   "+blk.blockSpec.replace(/\$\$/g,"") + "   "
						);
				button.fontSize = 11;
				button.labelColor = blk.color;//new Color(200, 0, 200);
                                button.fixLayout();
				blocks.push(button);
			}
		});
		
		txt = new TextMorph('---------------------------------------');
			txt.fontSize = 10;
			txt.setColor(new Color(255,255,255));//this.paletteTextColor);
			blocks.push(txt);  
			blocks.push('-');
	}
////////////////////////////////////////////////
	if (cat === 'motion') {

        blocks.push(block('forward'));
        blocks.push(block('turn'));
        blocks.push(block('turnLeft'));
        blocks.push('-');
        blocks.push(block('setHeading'));
        blocks.push(block('doFaceTowards'));
        blocks.push('-');
        blocks.push(block('gotoXY'));
        blocks.push(block('doGotoObject'));
        blocks.push(block('doGlide'));
        blocks.push('-');
        blocks.push(block('changeXPosition'));
        blocks.push(block('setXPosition'));
        blocks.push(block('changeYPosition'));
        blocks.push(block('setYPosition'));
        blocks.push('-');
        blocks.push(block('bounceOffEdge'));
        blocks.push('-');
        blocks.push(watcherToggle('xPosition'));
        //blocks.push(block('xPosition'));
        blocks.push(block('xPosition', this.inheritsAttribute('x position')));
        blocks.push(watcherToggle('yPosition'));
        blocks.push(block('yPosition', this.inheritsAttribute('y position')));
        //blocks.push(block('yPosition'));
        blocks.push(watcherToggle('direction'));
        //blocks.push(block('direction'));
        blocks.push(block('direction', this.inheritsAttribute('direction')));
        if (ide){ // if the pelette is not loaded for the first time
            if (world.role !== 'STUDENT' || !ide.stage.noCustomBlocks){
                blocks.push('=');
                blocks.push(this.makeBlockButton(cat));
            }
        } else { //else, always load button
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }

    } else if (cat === 'looks') {

        blocks.push(block('doSwitchToCostume'));
        blocks.push(block('doWearNextCostume'));
        blocks.push(watcherToggle('getCostumeIdx'));
        //blocks.push(block('getCostumeIdx'));
        blocks.push(block('getCostumeIdx', this.inheritsAttribute('costume #')));
        blocks.push('-');
        blocks.push(block('doSayFor'));
        blocks.push(block('bubble'));
        blocks.push(block('doThinkFor'));
        blocks.push(block('doThink'));
        blocks.push('-');
        blocks.push(block('changeEffect'));
        blocks.push(block('setEffect'));
        blocks.push(block('clearEffects'));
        blocks.push('-');
        blocks.push(block('changeScale'));
        blocks.push(block('setScale'));
        blocks.push(watcherToggle('getScale'));
        //blocks.push(block('getScale'));
        blocks.push(block('getScale', this.inheritsAttribute('size')));
        blocks.push('-');
        blocks.push(block('show'));
        blocks.push(block('hide'));
        blocks.push('-');
        blocks.push(block('comeToFront'));
        blocks.push(block('goBack'));
        
        // for debugging: ///////////////

        if (this.world().isDevMode) {
            blocks.push('-');
            txt = new TextMorph(localize(
                'development mode \ndebugging primitives:'
            ));
            txt.fontSize = 9;
            txt.setColor(this.paletteTextColor);
            blocks.push(txt);
            blocks.push('-');
            blocks.push(block('log'));
            blocks.push(block('alert'));
            blocks.push('-');
            blocks.push(block('doScreenshot'));
        }

    /////////////////////////////////

   /////////////////////////////////
        if (world.role !== 'STUDENT' || !ide.stage.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }    

    } else if (cat === 'sound') {

        blocks.push(block('playSound'));
        blocks.push(block('doPlaySoundUntilDone'));
        blocks.push(block('doStopAllSounds'));
        blocks.push('-');
        blocks.push(block('doRest'));
        blocks.push(block('doPlayNote'));
        blocks.push(block('doSetInstrument'));
        blocks.push('-');
        blocks.push(block('doChangeTempo'));
        blocks.push(block('doSetTempo'));
        blocks.push(watcherToggle('getTempo'));
        blocks.push(block('getTempo'));
        if (world.role !== 'STUDENT' || !ide.stage.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }    
    
    } else if (cat === 'pen') {

        blocks.push(block('clear'));
        blocks.push('-');
        blocks.push(block('down'));
        blocks.push(block('up'));
        blocks.push('-');
        blocks.push(block('setColor'));
        blocks.push(block('changeHue'));
        blocks.push(block('setHue'));
        blocks.push('-');
        blocks.push(block('changeBrightness'));
        blocks.push(block('setBrightness'));
        blocks.push('-');
        blocks.push(block('changeSize'));
        blocks.push(block('setSize'));
        blocks.push('-');
        blocks.push(block('doStamp'));
        blocks.push(block('floodFill'));
        blocks.push(block('reportPenTrailsAsCostume'));
        if (world.role !== 'STUDENT' || !ide.stage.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }    

    } else if (cat === 'control') {
//@@ special block for teacher
	if (world.role !== 'STUDENT'){ 
        blocks.push(block('lockedReceiveMessage'));    
	}
//@@	
        blocks.push(block('receiveGo'));
        blocks.push(block('receiveKey'));
        
        bugBlock=block('receiveInteraction');
        if (bugBlock){ //if the block is not hidden
            bugBlock.fixLabelColor();
            blocks.push(bugBlock);
        }    
        
        blocks.push(block('receiveCondition'));
        blocks.push(block('receiveMessage'));
        blocks.push('-');
        blocks.push(block('doBroadcast'));
        blocks.push(block('doBroadcastAndWait'));
        blocks.push(watcherToggle('getLastMessage'));
        blocks.push(block('getLastMessage'));
// Network support:
        if (!StageMorph.prototype.noNetworkSupport) {
			blocks.push('=');
            blocks.push(block('doBroadcastOnNetwork'));
			blocks.push('=');
        }
///////////////////////////////		
        blocks.push('-');
        blocks.push(block('doWarp'));
        blocks.push('-');
        blocks.push(block('doWait'));
        blocks.push(block('doWaitUntil'));
        blocks.push('-');
        blocks.push(block('doForever'));
        blocks.push(block('doRepeat'));
        blocks.push(block('doUntil'));
        blocks.push('-');
        blocks.push(block('doIf'));
        blocks.push(block('doIfElse'));
        blocks.push('-');
        blocks.push(block('doReport'));
        blocks.push('-');
    /*
    // old STOP variants, migrated to a newer version, now redundant
        blocks.push(block('doStopBlock'));
        blocks.push(block('doStop'));
        blocks.push(block('doStopAll'));
    */
        blocks.push(block('doStopThis'));
     //   blocks.push(block('doStopOthers'));
        blocks.push('-');
        blocks.push(block('doRun'));
        blocks.push(block('fork'));
        blocks.push(block('evaluate'));
        blocks.push('-');
        blocks.push(block('doTellTo'));
        blocks.push(block('reportAskFor'));
        blocks.push('-');
    /*
    // list variants commented out for now (redundant)
        blocks.push(block('doRunWithInputList'));
        blocks.push(block('forkWithInputList'));
        blocks.push(block('evaluateWithInputList'));
        blocks.push('-');
    */
        blocks.push(block('doCallCC'));
        blocks.push(block('reportCallCC'));
        blocks.push('-');
        blocks.push(block('receiveOnClone'));
        blocks.push(block('createClone'));
        
        bugBlock=block('newClone');
        if (bugBlock){ //if the block is not hidden
            bugBlock.fixLabelColor();
            blocks.push(bugBlock);
        }    
        
        blocks.push(block('removeClone'));
        blocks.push('-');
        blocks.push(block('doPauseAll'));
        if (world.role !== 'STUDENT' || !ide.stage.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat))
        }    

    } else if (cat === 'sensing') {

        blocks.push(block('reportTouchingObject'));
        blocks.push(block('reportTouchingColor'));
        blocks.push(block('reportColorIsTouchingColor'));
        blocks.push('-');
        blocks.push(block('doAsk'));
        blocks.push(watcherToggle('getLastAnswer'));
        blocks.push(block('getLastAnswer'));
        blocks.push('-');
        blocks.push(watcherToggle('reportMouseX'));
        blocks.push(block('reportMouseX'));
        blocks.push(watcherToggle('reportMouseY'));
        blocks.push(block('reportMouseY'));
        blocks.push(block('reportMouseDown'));
        blocks.push('-');
        blocks.push(block('reportKeyPressed'));
        blocks.push('-');
        blocks.push(block('reportDistanceTo'));
        blocks.push('-');
        blocks.push(block('doResetTimer'));
        blocks.push(watcherToggle('getTimer'));
        blocks.push(block('getTimer'));
        blocks.push('-');
        
        bugBlock=block('reportAttributeOf')
        if (bugBlock){ //if the block is not hidden
            bugBlock.fixLabelColor();
            blocks.push(bugBlock);
        }    
        
        if (SpriteMorph.prototype.enableFirstClass) {
            bugBlock=block('reportGet')
            if (bugBlock){ //if the block is not hidden
                bugBlock.fixLabelColor();
                blocks.push(bugBlock);
            }     
        }
        blocks.push('-');
        
        blocks.push(block('reportURL'));
        blocks.push('-');
        blocks.push(block('reportIsFastTracking'));
        blocks.push(block('doSetFastTracking'));
        blocks.push('-');
        blocks.push(block('reportDate'));
// Network support:
        if (!ide.stage.noNetworkSupport) {
			blocks.push('=');
            blocks.push(block('doReportUserData'));
        }
///////////////////////////////
        if (world.role !== 'STUDENT' || !ide.stage.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }    
    
    } else if (cat === 'operators') {

        blocks.push(block('reifyScript'));
        blocks.push(block('reifyReporter'));
        blocks.push(block('reifyPredicate'));
        blocks.push('#');
        blocks.push('-');
        blocks.push(block('reportSum'));
        blocks.push(block('reportDifference'));
        blocks.push(block('reportProduct'));
        blocks.push(block('reportQuotient'));
        blocks.push('-');
        blocks.push(block('reportModulus'));
        blocks.push(block('reportRound'));
        blocks.push(block('reportMonadic'));
        blocks.push(block('reportRandom'));
        blocks.push('-');
        blocks.push(block('reportLessThan'));
        blocks.push(block('reportEquals'));
        blocks.push(block('reportGreaterThan'));
        blocks.push('-');
        blocks.push(block('reportAnd'));
        blocks.push(block('reportOr'));
        blocks.push(block('reportNot'));
        blocks.push(block('reportBoolean')); // v 4.0.10.2
        blocks.push('-');
       /* blocks.push(block('reportTrue'));
        blocks.push(block('reportFalse'));*/
        blocks.push('-');
        blocks.push(block('reportJoinWords'));
        blocks.push(block('reportTextSplit'));
        blocks.push(block('reportLetter'));
        blocks.push(block('reportStringSize'));
        blocks.push('-');
        blocks.push(block('reportUnicode'));
        blocks.push(block('reportUnicodeAsLetter'));
        blocks.push('-');
        blocks.push(block('reportIsA'));
        blocks.push(block('reportIsIdentical'));
        blocks.push('-');
        blocks.push(block('reportJSFunction'));
        if (world.role !== 'STUDENT' || !ide.stage.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }

    /////////////////////////////////

	} else if (cat === 'variables') {
		if (world.role !== 'STUDENT' || !ide.stage.onlyScriptVars){
			button = new PushButtonMorph(
				null,
				function () {
					new VariableDialogMorph(
						null,
						addVar,
						myself
					).prompt(
						'Variable name',
						null,
						myself.world()
					);
				},
				'Make a variable'
			);
			button.userMenu = helpMenu;
			button.selector = 'addVariable';
			button.showHelp = BlockMorph.prototype.showHelp;
			blocks.push(button);

			if (this.deletableVariableNames(world.role=='STUDENT').length > 0) { //if world.role == 'STUDENT' excludeHiddens
				button = new PushButtonMorph(
					null,
					function () {
						var menu = new MenuMorph(
							myself.deleteVariable,
							null,
							myself
						);
						myself.deletableVariableNames(world.role=='STUDENT').forEach(function (name) {
							menu.addItem(name, name,null,null,false,false,null,true); //+++++++++++++++++++++++++++++ don't localize var names
						});
						menu.popUpAtHand(myself.world());
					},
					'Delete a variable'
				);
				button.userMenu = helpMenu;
				button.selector = 'deleteVariable';
				button.showHelp = BlockMorph.prototype.showHelp;
				blocks.push(button);
			}

			blocks.push('-');
		}	
	
        varNames = this.variables.allNames();
        if (varNames.length > 0) {
            varNames.forEach(function (name) {
            
//========================== hide the hidden vars from student ===========================================================
				var frame = myself.variables.find(name);
				if (frame.hiddenVars[name]){  //if it's a hidden variable
                                    if (world.role !== 'STUDENT'){
                                        blocks.push(variableWatcherToggle(name));
					blocks.push(variableBlock(name,true)); //put the fainted variable in teachers mode
                                    }    // or not at all, in student mode
				} else{
                                    blocks.push(variableWatcherToggle(name));
                                    blocks.push(variableBlock(name));
                                }
//========================================================================================================================
            });
            blocks.push('-');
        }

        blocks.push(block('doSetVar'));
        blocks.push(block('doChangeVar'));
        blocks.push(block('doShowVar'));
        blocks.push(block('doHideVar'));
        blocks.push(block('doDeclareVariables'));
	// Network support:
        if (!ide.stage.noNetworkSupport) {
			blocks.push('=');
            blocks.push(block('doBroadcastVariable'));
        }
	///////////////////////////////		

    // inheritance:

        if (StageMorph.prototype.enableInheritance) {
            blocks.push('-');
            blocks.push(block('doDeleteAttr'));
        }

    ///////////////////////////////

        blocks.push('=');

        blocks.push(block('reportNewList'));
        blocks.push('-');
        blocks.push(block('reportCONS'));
        blocks.push(block('reportListItem'));
        blocks.push(block('reportCDR'));
        blocks.push('-');
        blocks.push(block('reportListLength'));
        blocks.push(block('reportListContainsItem'));
        blocks.push('-');
        blocks.push(block('doAddToList'));
        blocks.push(block('doDeleteFromList'));
        blocks.push(block('doInsertInList'));
        blocks.push(block('doReplaceInList'));

    // for debugging: ///////////////

        if (this.world().isDevMode) {
            blocks.push('-');
            txt = new TextMorph(localize(
                'development mode \ndebugging primitives:'
            ));
            txt.fontSize = 9;
            txt.setColor(this.paletteTextColor);
            blocks.push(txt);
            blocks.push('-');
            blocks.push(block('reportMap'));
            blocks.push('-');
            blocks.push(block('doForEach'));
            blocks.push(block('doShowTable'));
        }

    /////////////////////////////////

        blocks.push('=');

        if (StageMorph.prototype.enableCodeMapping) {
            blocks.push(block('doMapCodeOrHeader'));
            blocks.push(block('doMapStringCode'));
            blocks.push(block('doMapListCode'));
            blocks.push('-');
            blocks.push(block('reportMappedCode'));
            blocks.push('-');
        }
		if (world.role !== 'STUDENT' || !ide.stage.noCustomBlocks){
                    
		/*	button = new PushButtonMorph(
				null,
				function () {
					var ide = myself.parentThatIsA(IDE_Morph),
						stage = myself.parentThatIsA(StageMorph);
					new BlockDialogMorph(
						null, 
						function (definition) {
							if (definition.spec !== '' && !(world.role=="STUDENT" && definition.spec.indexOf("$$")==0)) { //handle hiddens, do not allow student to create a hidden block(starting with $$)
								if (definition.isGlobal) {
									stage.globalBlocks.push(definition);
								} else {
									myself.customBlocks.push(definition);
								}
								if (definition.spec.indexOf("$$")==0) { //handle hiddens, hide the block if it starts with $$
									definition.isHidden = true;
									 ide.flushBlocksCache();
									} //handle hiddens end
								ide.flushPaletteCache();
								ide.refreshPalette();
								new BlockEditorMorph(definition, myself).popUp();
							} else if (definition.spec.indexOf("$$")==0) { myself.inform("Custom block name can not start with $$");} //handle hiddens
						},
						myself
					).prompt(
						'Make a block',
						null,
						myself.world()
					);
				},
				'Make a block'
			);
			button.userMenu = helpMenu;
			button.selector = 'addCustomBlock';
			button.showHelp = BlockMorph.prototype.showHelp;
			blocks.push(button);
                */
                blocks.push(this.makeBlockButton());
		}
		if (world.role !== 'STUDENT'){ //constant block
			blocks.push(block('constantValue'));		
		}
    } 
//////+++++++++++++++++++++ depository category +++++++++++++++++++ /////////////////
	else if (cat =='depository'){
		if (ide){
			var l = ide.stage.depositoryCommands.length, i, customDepositoryBlock;
			if (world.role!=='STUDENT'){
					ide.stage.depositoryCommands.forEach(function (blk) {
					switch (blk[0]){
					case 'primitive' :	blocks.push(block(blk[1]));
										break;
					case 'variable'  :  blocks.push(variableWatcherToggle(blk[1]));  //--++ put watcher toggle on depository also
										blocks.push(variableBlock(blk[1]));
										break;
					case 'custom-block': blocks.push(customBlock(blk[1]).templateInstance());
										 break;
					}
			});
			} else {		// ---------- STUDENT mode depository -------------------		
				if (l>0) {
					i=0;
					if (ide.stage.depositoryCommands[i][0] == 'variable') {		// put variables first
						txt = new TextMorph(localize('Variables'));
						txt.isBold = true;
						txt.isItalic = true;
						if (MorphicPreferences.isFlat){
							txt.setColor(new Color(5,5,5));  //for flat design
						} else {
							txt.setColor(new Color(255,255,255));
						}	
						blocks.push(txt);
						blocks.push('-');		
							while (i<l && ide.stage.depositoryCommands[i][0] == 'variable') {				
									blocks.push(variableWatcherToggle(ide.stage.depositoryCommands[i][1]));  //--++ put watcher toggle on depository also
									blocks.push(variableBlock(ide.stage.depositoryCommands[i][1]));					
									i++;
									}					
					}
					if ( i<l){ // handle primitives or locked custom blocks first
						if (ide.stage.depositoryCommands[i][0] == 'primitive') {	
							blocks.push('-');
							txt = new TextMorph(localize('commands'));//'Εντολές');
							txt.isBold = true;
							txt.isItalic = true;
							if (MorphicPreferences.isFlat){
								txt.setColor(new Color(5,5,5));  //for flat design
							} else {
								txt.setColor(new Color(255,255,255));
							}	
							blocks.push(txt);
							blocks.push('-');
							blocks.push(block(ide.stage.depositoryCommands[i][1])); //put the first primitive
							i++; 
						} else {
							customDepositoryBlock = customBlock(ide.stage.depositoryCommands[i][1]);
							if (customDepositoryBlock.isLocked){
								blocks.push('-');
								txt = new TextMorph(localize('commands'));//'Εντολές');
								txt.isBold = true;
								txt.isItalic = true;
								if (MorphicPreferences.isFlat){
									txt.setColor(new Color(5,5,5));  //for flat design
								} else {
									txt.setColor(new Color(255,255,255));
								}	
								blocks.push(txt);
								blocks.push('-');
								blocks.push(customDepositoryBlock.templateInstance()); //put the first primitive
								i++;
							} 	
						}	
						while (i<l) { // deal with the rest of primitives or locked customs
							if (ide.stage.depositoryCommands[i][0] == 'primitive') {
								blocks.push(block(ide.stage.depositoryCommands[i][1]));  //--++ put primitive
								i++;
							} else {
								customDepositoryBlock = customBlock(ide.stage.depositoryCommands[i][1]);
								if (customDepositoryBlock.isLocked){
									blocks.push(customDepositoryBlock.templateInstance()); //--++ put locked custom block
									i++;
								} else {  //we've reached the first unlocked custom block, break
									break;
								}
							}
							
						}		
					}
				
					if ( i<l) {// put unlocked custom blocks last
						blocks.push('-');
						txt = new TextMorph(localize('custom blocks'));
						txt.isBold = true;
						txt.isItalic = true;
						if (MorphicPreferences.isFlat){
							txt.setColor(new Color(5,5,5));  //for flat design
						} else {
							txt.setColor(new Color(255,255,255));
						}	
						blocks.push(txt);
						blocks.push('-');
						while (i<l) {
							blocks.push(customBlock(ide.stage.depositoryCommands[i][1]).templateInstance()); //--++ put unlocked custom block
							i++;
						}
					}
						
				}
			}		
		}
	} 
// +++++++++++++++++++++++++++ depository category end ++++++++++++++++++++++++++++++++

	 return blocks;
}

SpriteMorph.prototype.makeBlock = function () {
    // prompt the user to make a new block
    var ide = this.parentThatIsA(IDE_Morph),
        stage = this.parentThatIsA(StageMorph),
        category = ide.currentCategory,
        clr = SpriteMorph.prototype.blockColor[category],
        myself = this,
        dlg;
    dlg = new BlockDialogMorph(
        null,
        function (definition) {
            if (definition.spec !== '' && !(world.role=="STUDENT" && definition.spec.indexOf("$$")==0)) { //handle hiddens, do not allow student to create a hidden block(starting with $$)
		if (definition.isGlobal) {
                    stage.globalBlocks.push(definition);
		} else {
                    myself.customBlocks.push(definition);
		}
		if (definition.spec.indexOf("$$")==0) { //handle hiddens, hide the block if it starts with $$
                    definition.isHidden = true;
                    ide.flushBlocksCache();
                } //handle hiddens end
		ide.flushPaletteCache();
		ide.refreshPalette();
		new BlockEditorMorph(definition, myself).popUp();
		} else if (definition.spec.indexOf("$$")==0) {
                    myself.inform("Custom block name can not start with $$");
                } //handle hiddens
        },
        myself
    );
    if (category !== 'variables') {
        dlg.category = category;
        dlg.categories.children.forEach(function (each) {
            each.refresh();
        });
        dlg.types.children.forEach(function (each) {
            each.setColor(clr);
        each.refresh();
        });
    }
    dlg.prompt(
        'Make a block',
        null,
        myself.world()
    );
};


//////////////////////////////////////////////////////////////////////

SpriteMorph.prototype.deletableVariableNames = function (excludeHiddens) {
    var myself = this,
		locals = this.variables.names(),
        inherited = this.inheritedVariableNames();
	if (!excludeHiddens){	
		return locals.concat(
			this.globalVariables().names().filter(
				function (each) {
					return !contains(locals, each) && !contains(inherited, each);
				}
			)
		);
	} else {
		locals = locals.filter(  //filter out local hidden variables
			function (v){
				return !myself.variables.hiddenVars[v];	
		});
		return locals.concat(
			this.globalVariables().names().filter( //filter out global hidden and locked variables
				function (each) {
					return !contains(locals, each) && !contains(inherited, each) && !myself.globalVariables().hiddenVars[each] && !myself.globalVariables().vars[each].isLocked; 
				}
			)
		);
	}
};

SpriteMorph.prototype.inheritedVariableNames = function (shadowedOnly) {
    var names = [],
        own = (world.role !== 'STUDENT') ? this.variables.names() : this.variables.visibleNames(), // do not add the hidden inherited variables, when in STUDENT mode
        current = this.variables.parentFrame;

    function test(each) {
        return shadowedOnly ? contains(own, each) : !contains(own, each);
    }

    while (current.owner instanceof SpriteMorph) {
        names.push.apply(
            names,
            current.names().filter(test)
        );
        current = current.parentFrame;
    }
    return names;
};


SpriteMorph.prototype.palette = function (category) {
    if (!this.paletteCache[category] || category=='depository') {  // always recreate the depository palette	
        this.paletteCache[category] = this.freshPalette(category);	
    }
    return this.paletteCache[category];
};

// SpriteMorph blocks searching - show hidden primitives to teacher and hide hidden custom block from student

SpriteMorph.prototype.blocksMatching = function (
    searchString,
    strictly,
    types, // optional, ['hat', 'command', 'reporter', 'predicate']
    varNames // optional, list of reachable unique variable names
) {
    // answer an array of block templates whose spec contains
    // the given search string, ordered by descending relevance
    // types is an optional array containing block types the search
    // is limited to, e.g. "command", "hat", "reporter", "predicate".
    // Note that "predicate" is not subsumed by "reporter" and has
    // to be specified explicitly.
    // if no types are specified all blocks are searched
    var blocks = [],
        blocksDict,
        myself = this,
        search = searchString.toLowerCase(),
        stage = this.parentThatIsA(StageMorph),
        reporterized;

    if (!types || !types.length) {
        types = ['hat', 'command', 'reporter', 'predicate', 'ring'];
    }
    if (!varNames) {varNames = []; }

    function labelOf(aBlockSpec) {
        var words = (BlockMorph.prototype.parseSpec(aBlockSpec)),
            filtered = words.filter(
                function (each) {return (each.indexOf('%') !== 0); }
            );
        return filtered.join(' ');
    }

    function fillDigits(anInt, totalDigits, fillChar) {
        var ans = String(anInt);
        while (ans.length < totalDigits) {ans = fillChar + ans; }
        return ans;
    }

    function relevance(aBlockLabel, aSearchString) {
        var lbl = ' ' + aBlockLabel,
            idx = lbl.indexOf(aSearchString),
            atWord;
        if (idx === -1) {return -1; }
        atWord = (lbl.charAt(idx - 1) === ' ');
        if (strictly && !atWord) {return -1; }
        return (atWord ? '1' : '2') + fillDigits(idx, 4, '0');
    }

    function primitive(selector) {
        var newBlock = SpriteMorph.prototype.blockForSelector(selector, true);
        newBlock.isTemplate = true;
        return newBlock;
    }

    // variable getters
    varNames.forEach(function (vName) {
        var rel = relevance(labelOf(vName), search);
        if (rel !== -1) {
            blocks.push([myself.variableBlock(vName), rel + '1']);
        }
    });
    // custom blocks
    [this.customBlocks, stage.globalBlocks].forEach(function (blocksList) {
        blocksList.forEach(function (definition) {
            if (contains(types, definition.type)) {
                var spec = localize(definition.blockSpec()).toLowerCase(),
                    rel = relevance(labelOf(spec), search);
                if (rel !== -1) {
                    if (world.role !== 'STUDENT' || (!definition.isHidden && !contains(SpriteMorph.prototype.hiddenStandardCategories,definition.category))){  // do not show hidden custom blocks to student
			blocks.push([definition.templateInstance(), rel + '2']);
                    }
                }
            }
        });
    });
    // primitives
    blocksDict = SpriteMorph.prototype.blocks;
    Object.keys(blocksDict).forEach(function (selector) {		
        if (((!StageMorph.prototype.hiddenPrimitives[selector] && !contains(SpriteMorph.prototype.hiddenStandardCategories,blocksDict[selector].category)) || world.role!=='STUDENT'   )&& //do not hide hidden primitives from teacher,
                contains(types, blocksDict[selector].type)) {
            var block = blocksDict[selector],
                spec = localize(block.alias || block.spec).toLowerCase(),
                rel = relevance(labelOf(spec), search);
            if (
                (rel !== -1) &&
                    (!block.dev) &&
                    (!block.only || (block.only === myself.constructor))
            ) {
                blocks.push([primitive(selector), rel + '3']);
            }
        }
    });
     // infix arithmetic expression
    if (contains(types, 'reporter')) {   // v 4.0.10.2
        reporterized = this.reporterize(searchString);
        if (reporterized) {
            // reporterized.isTemplate = true;
            // reporterized.isDraggable = false;
            blocks.push([reporterized, '']);
        }
    }
    blocks.sort(function (x, y) {return x[1] < y[1] ? -1 : 1; });
    return blocks.map(function (each) {return each[0]; });
};

SpriteMorph.prototype.freshPalette = function (category) {
    var palette = new ScrollFrameMorph(null, null, this.sliderColor),
        unit = SyntaxElementMorph.prototype.fontSize,
        x = 0,
        y = 5,
        ry = 0,
        blocks,
        hideNextSpace = false,
        myself = this,
        stage = this.parentThatIsA(StageMorph),
        oldFlag = Morph.prototype.trackChanges,
        shade = new Color(140, 140, 140),
        searchButton,
        makeButton,
        ide=this.parentThatIsA(IDE_Morph);

    Morph.prototype.trackChanges = false;
    palette.owner = this;
    palette.padding = unit / 2;
    palette.color = this.paletteColor;
    palette.growth = new Point(0, MorphicPreferences.scrollBarSize);
    
    if (category !== 'depository'){ // do not create toolbar on depository
        // toolbar:
        palette.toolBar = new AlignmentMorph('column');

        searchButton = new PushButtonMorph(
            this,
            "searchBlocks",
            new SymbolMorph("magnifierOutline", 16)
        );
        searchButton.alpha = 0.2;
        searchButton.padding = 1;
        searchButton.hint = localize('find blocks') + '...';
        searchButton.labelShadowColor = shade;
        searchButton.drawNew();
        searchButton.fixLayout();
        palette.toolBar.add(searchButton);

        if (!ide || world.role !== 'STUDENT' || !ide.stage.noCustomBlocks){ //do not show when custom block creation is forbidden
            makeButton = new PushButtonMorph(
                this,
                "makeBlock",
                new SymbolMorph("cross", 16)
            );
            makeButton.alpha = 0.2;
            makeButton.padding = 1;
            makeButton.hint = localize('Make a block') + '...';
            makeButton.labelShadowColor = shade;
            makeButton.drawNew();
            makeButton.fixLayout();
            palette.toolBar.add(makeButton);
        }    

        palette.toolBar.fixLayout();
        palette.add(palette.toolBar);
    }
    // menu:

    palette.userMenu = function () {
        var menu = new MenuMorph(),
            ide = this.parentThatIsA(IDE_Morph),
            more = {
                operators:
                    ['reifyScript', 'reifyReporter', 'reifyPredicate'],
                control:
                    ['doWarp'],
                variables:
                    [
                        'doDeclareVariables',
                        'reportNewList',
                        'reportCONS',
                        'reportListItem',
                        'reportCDR',
                        'reportListLength',
                        'reportListContainsItem',
                        'doAddToList',
                        'doDeleteFromList',
                        'doInsertInList',
                        'doReplaceInList'
                    ]
            };

        function hasHiddenPrimitives() {
            var defs = SpriteMorph.prototype.blocks,
                hiddens = StageMorph.prototype.hiddenPrimitives;
            return Object.keys(hiddens).some(function (any) {
                return !isNil(defs[any]) && (defs[any].category === category 
                    || contains((more[category] || []), any));
            });
        }

        function canHidePrimitives() {
            return palette.contents.children.some(function (any) {
                return contains(
                    Object.keys(SpriteMorph.prototype.blocks),
                    any.selector
                ) && !any.isHidden && !SpriteMorph.prototype.blocks[any.selector].teachersOnly;  //because in teacher mode, blocks are not actually hidden
            });
        }
		if (category !=='depository' || world.role !== 'STUDENT') {		// do not add the search blocks function in the depository, for student
			//menu.addPair('find blocks...', function () {myself.searchBlocks();},'⌘F' );
                    menu.addPair(
                        [
                            new SymbolMorph(
                                'magnifyingGlass',
                                MorphicPreferences.menuFontSize
                            ),
                            localize('find blocks') + '...'
                        ],
                        function () {myself.searchBlocks(); },
                        '^F'
                    );    
		}	
        if (canHidePrimitives()) {
            //disable hide for student and the depository
            if (world.role !== 'STUDENT' && category !== 'depository') { 
                menu.addItem(
                    'hide primitives',
                    function () {
                      var defs = SpriteMorph.prototype.blocks;
                        Object.keys(defs).forEach(function (sel) {
                            if (defs[sel].category === category && !SpriteMorph.prototype.blocks[sel].teachersOnly) {
                                StageMorph.prototype.hiddenPrimitives[sel] = true;
								    }
						
                        });
                        (more[category] || []).forEach(function (sel) {
                            StageMorph.prototype.hiddenPrimitives[sel] = true;
							
                        });  
			ide.flushBlocksCache(category);
			ide.refreshPalette();
                    }
                );
            }
        }
        if (hasHiddenPrimitives()) {
            //disable show for student.
            if (world.role !== 'STUDENT') {
                menu.addItem(
                    'show primitives',
                    function () {
                        var hiddens = StageMorph.prototype.hiddenPrimitives,
                            defs = SpriteMorph.prototype.blocks;
                        Object.keys(hiddens).forEach(function (sel) {
                            if (defs[sel] &&(defs[sel].category === category)) {
                                delete StageMorph.prototype.hiddenPrimitives[sel];
                            }
                        });
                        (more[category] || []).forEach(function (sel) {
                            delete StageMorph.prototype.hiddenPrimitives[sel];
                        });
					    ide.flushBlocksCache(category);
                        ide.refreshPalette();
                    }
                );
            }
        }
		
		if (world.role !== 'STUDENT' && category=='depository' && ide.stage.depositoryCommands.length>0) { //if you are a teacher in the depository and it is not empty, you can clear ti
			menu.addItem(
                    'clear depository',
                    function () {
                        ide.stage.depositoryCommands = [];
					    ide.flushBlocksCache('depository');
                        ide.refreshPalette();
                    }
                );
		}
        return menu;
    };

    // primitives:

    blocks = this.blocksCache[category];
    if (!blocks) {	
        blocks = myself.blockTemplates(category);
        if (this.isCachingPrimitives) {
            myself.blocksCache[category] = blocks;
        }
    }	
    blocks.forEach(function (block) {
        if (block === null) {
            return;
        }
        if (block === '-') {
            if (hideNextSpace) {return; }
            y += unit * 0.8;
            hideNextSpace = true;
        } else if (block === '=') {
            if (hideNextSpace) {return; }
            y += unit * 1.6;
            hideNextSpace = true;
        } else if (block === '#') {
if (hideNextSpace) {return; }
            x = 0;
            y = ry;
        } else {
            hideNextSpace = false;
            if (x === 0) {
                y += unit * 0.3;
            }
            block.setPosition(new Point(x, y));
            palette.addContents(block);
            if (block instanceof ToggleMorph
                    || (block instanceof RingMorph)) {
                x = block.right() + unit / 2;
                ry = block.bottom();
            } else {
                //? if (block instanceof PushButtonMorph) {block.fixLayout(); }//if (block.fixLayout) {block.fixLayout(); }
                x = 0;
                y += block.height();
            }
        }
    });

    // global custom blocks:

    if (stage) {
        y += unit * 1.6;
        stage.globalBlocks.forEach(function (definition) {
            var block;
            if (world.role!=='STUDENT' || !definition.isHidden){ //////////////////////// if custom block isHidden dont put on palette for STUDENT
		if (definition.category === category ||
                    (category === 'variables'
                        && contains(
                            ['lists', 'other'],
                            definition.category
                        ))) {
                block = definition.templateInstance();                
                y += unit * 0.3;
                block.setPosition(new Point(x, y));
                if (definition.isHidden) {  // hide(faint) the hiddens (for teacher)
                    block.hide();
                }
                palette.addContents(block);
                x = 0;
                y += block.height();
            }
	}
        });
    }

    // local custom blocks:

    y += unit * 1.6;
    this.customBlocks.forEach(function (definition) {
        var block;
	if (world.role!=='STUDENT' || !definition.isHidden){ //////////////////////// if custom block isHidden dont put on palette for STUDENT
            if (definition.category === category ||
                (category === 'variables'
                    && contains(
                        ['lists', 'other'],
                        definition.category
                    ))) {
            block = definition.templateInstance();
            y += unit * 0.3;
            block.setPosition(new Point(x, y));
            if (definition.isHidden) {  // hide(faint) the hiddens (for teacher)
                    block.hide();
            }
            palette.addContents(block);
            x = 0;
            y += block.height();
            }
	}
    });
    
    // inherited custom blocks:

    // y += unit * 1.6;
    if (this.exemplar) {
        this.inheritedBlocks(true).forEach(function (definition) {
            var block;
            if (world.role!=='STUDENT' || !definition.isHidden){ //////////////////////// if custom block isHidden dont put on palette for STUDENT
                if (definition.category === category ||
                        (category === 'variables'
                            && contains(
                                ['lists', 'other'],
                                definition.category
                            ))) {
                    block = definition.templateInstance();
                    y += unit * 0.3;
                    block.setPosition(new Point(x, y));
                    if (definition.isHidden) {  // hide(faint) the hiddens (for teacher)
                        block.hide();
                    }
                    palette.addContents(block);
                    block.ghost();
                    x = 0;
                    y += block.height();
                }
            }    
        });
    }
    
//layout

    palette.scrollX(palette.padding);
    palette.scrollY(palette.padding);

    Morph.prototype.trackChanges = oldFlag;
    return palette;
};

// SpriteMorph variable management

SpriteMorph.prototype.deleteVariable = function (varName) {
    var ide = this.parentThatIsA(IDE_Morph),block_d,idx_d,frame;

	if (!contains(this.inheritedVariableNames(true), varName)) {
        // check only shadowed variables
        this.deleteVariableWatcher(varName);
    }
    this.variables.deleteVar(varName);
    if (ide) {
//+++++++++ delete from depository if exists ++++++++++++++
		frame = this.variables.parentFrame.silentFind(varName); //check if is global var
		if (!frame) { //if does not exist after deletion, means it was a global var, so clear from depository if needed
			block_d = ['variable', varName, 'vars'];   //search the variable in the depository 
			idx_d = indexOf(ide.stage.depositoryCommands, block_d);
			if (idx_d !== -1) { 					  // delete if found
				ide.stage.depositoryCommands.splice(idx_d, 1);
			}
			ide.flushBlocksCache('depository');
		}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        ide.flushBlocksCache('variables'); // b/c the var could be global
        ide.refreshPalette();
    }
};

SpriteMorph.prototype.userMenu = function () {
    var ide = this.parentThatIsA(IDE_Morph),
		myself = this,
        menu = new MenuMorph(this),
		doNotShow = world.HOCmode || (world.role=='STUDENT' && (this.isSecret || (ide && ide.stage.hideCorral)));

	if (ide && (ide.isAppMode || doNotShow)) {
        // menu.addItem('help', 'nop');
        return menu;
    }
    if(world.role!='STUDENT' || !this.isLocked ){  // if isLocked can not be deleted, duplicated or nested in STUDENT role    
        menu.addItem("duplicate", 'duplicate');
        if (StageMorph.prototype.enableInheritance) {
            menu.addItem("clone", 'instantiate');
            menu.addLine();
        }
        
            if (ide.sprites.asArray().length>1 || !ide.stage.isSecret){
                    menu.addItem("delete", 'remove');
            }	
        menu.addItem("move", 'moveCenter');
        if (this.costume) {
            menu.addItem(
                "pivot",
                'moveRotationCenter',
                'edit the costume\'s\nrotation center'
            );
        }
        if (this.isTemporary) {
            if (StageMorph.prototype.enableInheritance) {
                menu.addItem(
                    "edit",
                    'perpetuateAndEdit',
                    'make permanent and\nshow in the sprite corral'
                );
            }
        } else {
            menu.addItem("edit", 'edit');
        }
        menu.addLine();
        if (this.anchor) {
            menu.addItem(
                localize('detach from') + ' ' + this.anchor.name,
                'detachFromAnchor'
            );
        }
        if (this.parts.length) {
            menu.addItem('detach all parts', 'detachAllParts');
        }
    }    
    menu.addItem("export...", 'exportSprite');
	//Network support
	if (NetworkClient.io !== null && NetworkClient.io.connected){
		menu.addItem("share...", function(){
			ide.emitSprite(myself);
		}); 
	}
	
    return menu;
};

SpriteMorph.prototype.allHatBlocksFor = function (message) {
    if (typeof message === 'number') {message = message.toString(); }
    return this.scripts.children.filter(function (morph) {
        var event;
        if (morph.selector) {
            if ((morph.selector === 'receiveMessage') || (morph.selector === 'lockedReceiveMessage')) {
                event = morph.inputs()[0].evaluate();
                return event === message
                    || (event instanceof Array
                        && message !== '__shout__go__'
                        && message !== '__clone__init__');
            }
            if (morph.selector === 'receiveGo') {
                return message === '__shout__go__';
            }
            if (morph.selector === 'receiveOnClone') {
                return message === '__clone__init__';
            }
        }
        return false;
    });
};


SpriteMorph.prototype.thumbnail = function (extentPoint) {
  var src = this.image, // at this time sprites aren't composite morphs
        scale = Math.min(
            (extentPoint.x / src.width),
            (extentPoint.y / src.height)
        ),
        xOffset = (extentPoint.x - (src.width * scale)) / 2,
        yOffset = (extentPoint.y - (src.height * scale)) / 2,
        trg = newCanvas(extentPoint),
        ctx = trg.getContext('2d');
		
	if (this.isSecret) {     //faint the thumbnail if secret
			ctx.globalAlpha = 0.2;
	} else { ctx.globalAlpha = 1; }
        
    function xOut(style, alpha, width) {
        var inset = Math.min(extentPoint.x, extentPoint.y) / 10;
        ctx.strokeStyle = style;
        ctx.globalAlpha = alpha;
        ctx.compositeOperation = 'lighter';
        ctx.lineWidth = width || 1;
        ctx.moveTo(inset, inset);
        ctx.lineTo(trg.width - inset, trg.height - inset);
        ctx.moveTo(inset, trg.height - inset);
        ctx.lineTo(trg.width - inset, inset);
        ctx.stroke();
    }
        
    ctx.save();
    if (this.isCorpse) {
        ctx.globalAlpha = 0.3;
    }
    if (src.width && src.height) {
        ctx.scale(scale, scale);
        ctx.drawImage(
            src,
            Math.floor(xOffset / scale),
            Math.floor(yOffset / scale)
        );
    }
    if (this.isCorpse) {
        ctx.restore();
        xOut('white', 0.8, 6);
        xOut('black', 0.8, 1);
    }
    return trg;
}

//do not allow edit on double click for HOCmode, or STUDENT mode and hidden Sprites
SpriteMorph.prototype.mouseDoubleClick = function () {
    if (this.isClone || world.HOCmode || (world.role == 'STUDENT' && this.isSecret)) {return; }
    this.edit();
};


////////// StageMorph modification ///////////////////////
originalStageMorphInit = StageMorph.prototype.init;
StageMorph.prototype.init = function(globals){
	originalStageMorphInit.call(this,globals);
	
	this.specialBlocks = []; 			//for special blocks like $$start$ etc. Not to be serialized
	this.depositoryCommands = []; 		// depository 
	this.exerciseMode = false;          //Exercise Mode
	this.hideCostumes = false;  		//hidden costumes tab
	this.hideSounds = false;			//hidden sounds tab
	this.hideSpriteBar = false;  		//hidden Sprite Bar
	this.hideCorral = false;			//hidden Corral
	this.isSecret = false;   			// stage morph hide or not
	this.canAddSprites = true; 			//sprites can be added to stage
        this.noNetworkSupport = false;
        this.onlyScriptVars = false;
        this.noCustomBlocks = false;
        this.importExportHOC = false;        //importing-exporting in HOC mode
        this.hints = null; //hints script
}
//+++++++++++++++++++++++++++++++++++++++++ Check for the special hidden custom blocks: $$run$$
StageMorph.prototype.findSpecialCustomBlock = function(spec){ //for detecting the special run block
	return detect(this.globalBlocks, function (block){
					return block.blockSpec() === spec;
				});	
}

StageMorph.prototype.findSpecialBlocks = function (){	
	return this.globalBlocks.filter(function (def){
				return def.blockSpec().search(/^\$\$[\w\sΆ-ώ]+\$\$$/) == 0 && def.isHidden;// && def.blockSpec() !== "$$run$$";
			});	
}
//++++++++++++++++++++++++++++++++++++++++

StageMorph.prototype.blockTemplates = function (category) {
    var blocks = [], myself = this, varNames, button,
        cat = category || 'motion', txt,
		ide = this.parentThatIsA(IDE_Morph), // for variables "
		bugBlock; //for weird bug
                
    function block(selector, isGhosted) {
        if (StageMorph.prototype.hiddenPrimitives[selector] && world.role=='STUDENT') { // --------------- hide when STUDENT
            return null;
        }
		// else ...
        var newBlock = SpriteMorph.prototype.blockForSelector(selector, true);
        newBlock.isTemplate = true;
        if (isGhosted) {newBlock.ghost(); }
        if (StageMorph.prototype.hiddenPrimitives[selector]){ //if hidden in teachers mode
            newBlock.hide();
        }
	return newBlock;
    }

    function variableBlock(varName,isHidden) {
        var newBlock = SpriteMorph.prototype.variableBlock(varName);
        newBlock.isDraggable = false;
        newBlock.isTemplate = true;        
        if (isHidden){newBlock.hide();}
        return newBlock;
    }
	
	 function watcherToggle(selector) {
			if (StageMorph.prototype.hiddenPrimitives[selector]) {
				return null;
			}
			var info = SpriteMorph.prototype.blocks[selector];
			return new ToggleMorph(
				'checkbox',
				this,
				function () {
					myself.toggleWatcher(
						selector,
						localize(info.spec),
						myself.blockColor[info.category]
					);
				},
				null,
				function () {
					return myself.showingWatcher(selector);
				},
				null
			);
		}
   
    function variableWatcherToggle(varName) {
        return new ToggleMorph(
            'checkbox',
            this,
            function () {
                myself.toggleVariableWatcher(varName);
				},
            varName,//null,
            function () {
                return myself.showingVariableWatcher(varName);
            },
            null
        );
    }

    function addVar(pair) {
        if (pair) {
            if  (!(world.role=='STUDENT' && pair[0].indexOf("$$") == 0 )) { //handle hiddens
		if (myself.isVariableNameInUse(pair[0])) {
                    myself.inform('that name is already in use');
		} else {
                    myself.addVariable(pair[0], pair[1]);
                    myself.toggleVariableWatcher(pair[0], pair[1]);
                    myself.blocksCache[cat] = null;
                    myself.paletteCache[cat] = null;
                    myself.parentThatIsA(IDE_Morph).refreshPalette();
		}
            } else { myself.inform('Variable name can not start with $$');} //handle hiddens	
        }
    }

/////////////////////////////////////////////////////////////////////	add the buttons for special blocks: $$run$$ etc
	if (ide) {
		ide.stage.specialBlocks.forEach( function (def){
			var blk = def.templateInstance();	
			if (blk.blockSpec === "$$run$$") {
				button = new PushButtonMorph(
							myself,
							function () {
							blk.receiver = function () { return myself;} // palette has not been created yet. Overide the receiver to current sprite in order to execute the block
							ide.stage.threads.toggleProcess(blk,myself);
						   },
							'    '+localize('run')+'     '
						);
				button.labelColor = new Color(0, 150, 50);
				button.fontSize = 12;
				button.corner = 6;
				button.padding = 5;
				button.edge = 4;
				blocks.push(button);
			} else {
				button = new PushButtonMorph(
							myself,
							function () {
							blk.receiver = function () { return myself;} // palette has not been created yet. Overide the receiver to current sprite in order to execute the block
							ide.stage.threads.toggleProcess(blk,myself);
						   },
							"   "+blk.blockSpec.replace(/\$\$/g,"") + "   "
						);
				button.fontSize = 11;
				button.labelColor = blk.color;//new Color(200, 0, 200);
				blocks.push(button);
			}
		});
		
		txt = new TextMorph('---------------------------------------');
			txt.fontSize = 10;
			txt.setColor(new Color(255,255,255));//this.paletteTextColor);
			blocks.push(txt);  
			blocks.push('-');
	}
//////////////////////////////////////////////////////////////////////
	if (cat === 'motion') {

        txt = new TextMorph(localize(
            'Stage selected:\nno motion primitives'
        ));
        txt.fontSize = 9;
        txt.setColor(this.paletteTextColor);
        blocks.push(txt);

    } else if (cat === 'looks') {

        blocks.push(block('doSwitchToCostume'));
        blocks.push(block('doWearNextCostume'));
        blocks.push(watcherToggle('getCostumeIdx'));
        blocks.push(block('getCostumeIdx'));
        blocks.push('-');
        blocks.push(block('changeEffect'));
        blocks.push(block('setEffect'));
        blocks.push(block('clearEffects'));
        blocks.push('-');
        blocks.push(block('show'));
        blocks.push(block('hide'));
        if (world.role !== 'STUDENT' || !this.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        } 
    

    /////////////////////////////////

    } else if (cat === 'sound') {

        blocks.push(block('playSound'));
        blocks.push(block('doPlaySoundUntilDone'));
        blocks.push(block('doStopAllSounds'));
        blocks.push('-');
        blocks.push(block('doRest'));
        blocks.push('-');
        blocks.push(block('doPlayNote'));
        blocks.push('-');
        blocks.push(block('doChangeTempo'));
        blocks.push(block('doSetTempo'));
        blocks.push(watcherToggle('getTempo'));
        blocks.push(block('getTempo'));
        if (world.role !== 'STUDENT' || !this.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }
   
    } else if (cat === 'pen') {

        blocks.push(block('clear'));
        blocks.push(block('reportPenTrailsAsCostume'));
        if (world.role !== 'STUDENT' || !this.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }

    } else if (cat === 'control') {
//@@ special block for teacher		
		if (world.role !== 'STUDENT'){ 
			blocks.push(block('lockedReceiveMessage'));    
		}
//@@		
        blocks.push(block('receiveGo'));
        blocks.push(block('receiveKey'));       
        
        bugBlock=block('receiveInteraction');
        if (bugBlock){ //if the block is not hidden
            bugBlock.fixLabelColor();
            blocks.push(bugBlock);
        }
        blocks.push(block('receiveCondition'));
        blocks.push(block('receiveMessage'));
        blocks.push('-');
        blocks.push(block('doBroadcast'));
        blocks.push(block('doBroadcastAndWait'));
        blocks.push(watcherToggle('getLastMessage'));
        blocks.push(block('getLastMessage'));

// Network support:
		if (!this.noNetworkSupport) {
			blocks.push('=');
            blocks.push(block('doBroadcastOnNetwork'));
			blocks.push('=');
        }
		
///////////////////////////////
		
        blocks.push('-');
        blocks.push(block('doWarp'));
        blocks.push('-');
        blocks.push(block('doWait'));
        blocks.push(block('doWaitUntil'));
        blocks.push('-');
        blocks.push(block('doForever'));
        blocks.push(block('doRepeat'));
        blocks.push(block('doUntil'));
        blocks.push('-');
        blocks.push(block('doIf'));
        blocks.push(block('doIfElse'));
        blocks.push('-');
        blocks.push(block('doReport'));
        blocks.push('-');
    /*
    // old STOP variants, migrated to a newer version, now redundant
        blocks.push(block('doStopBlock'));
        blocks.push(block('doStop'));
        blocks.push(block('doStopAll'));
    */
        blocks.push(block('doStopThis'));
        //blocks.push(block('doStopOthers'));
        blocks.push('-');
        blocks.push(block('doRun'));
        blocks.push(block('fork'));
        blocks.push(block('evaluate'));
        blocks.push('-');
        blocks.push(block('doTellTo'));
        blocks.push(block('reportAskFor'));
        blocks.push('-');
    /*
    // list variants commented out for now (redundant)
        blocks.push(block('doRunWithInputList'));
        blocks.push(block('forkWithInputList'));
        blocks.push(block('evaluateWithInputList'));
        blocks.push('-');
    */
        blocks.push(block('doCallCC'));
        blocks.push(block('reportCallCC'));
        blocks.push('-');
        blocks.push(block('createClone'));
        blocks.push('-');
        blocks.push(block('doPauseAll'));
        if (world.role !== 'STUDENT' || !this.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }

    } else if (cat === 'sensing') {

        blocks.push(block('doAsk'));
        blocks.push(watcherToggle('getLastAnswer'));
        blocks.push(block('getLastAnswer'));
        blocks.push('-');
        blocks.push(watcherToggle('reportMouseX'));
        blocks.push(block('reportMouseX'));
        blocks.push(watcherToggle('reportMouseY'));
        blocks.push(block('reportMouseY'));
        blocks.push(block('reportMouseDown'));
        blocks.push('-');
        blocks.push(block('reportKeyPressed'));
        blocks.push('-');
        blocks.push(block('doResetTimer'));
        blocks.push(watcherToggle('getTimer'));
        blocks.push(block('getTimer'));
        blocks.push('-');
        
        bugBlock=block('reportAttributeOf');
        if (bugBlock){ //if the block is not hidden
            bugBlock.fixLabelColor();
            blocks.push(bugBlock);
        }    
        
        if (SpriteMorph.prototype.enableFirstClass) {
            bugBlock=block('reportGet')
            if (bugBlock){ //if the block is not hidden
                bugBlock.fixLabelColor();
                blocks.push(bugBlock);
            }    
        }
        blocks.push('-');
        
        blocks.push(block('reportURL'));
        blocks.push('-');
        blocks.push(block('reportIsFastTracking'));
        blocks.push(block('doSetFastTracking'));
        blocks.push('-');
        blocks.push(block('reportDate'));
// Network support:
        if (!StageMorph.prototype.noNetworkSupport) {
			blocks.push('=');
            blocks.push(block('doReportUserData'));
        }
///////////////////////////////	
        if (world.role !== 'STUDENT' || !this.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }   

    /////////////////////////////////

    } else if (cat === 'operators') {

        blocks.push(block('reifyScript'));
        blocks.push(block('reifyReporter'));
        blocks.push(block('reifyPredicate'));
        blocks.push('#');
        blocks.push('-');
        blocks.push(block('reportSum'));
        blocks.push(block('reportDifference'));
        blocks.push(block('reportProduct'));
        blocks.push(block('reportQuotient'));
        blocks.push('-');
        blocks.push(block('reportModulus'));
        blocks.push(block('reportRound'));
        blocks.push(block('reportMonadic'));
        blocks.push(block('reportRandom'));
        blocks.push('-');
        blocks.push(block('reportLessThan'));
        blocks.push(block('reportEquals'));
        blocks.push(block('reportGreaterThan'));
        blocks.push('-');
        blocks.push(block('reportAnd'));
        blocks.push(block('reportOr'));
        blocks.push(block('reportNot'));
        blocks.push(block('reportBoolean'));
        blocks.push('-');
        /*blocks.push(block('reportTrue'));
        blocks.push(block('reportFalse'));*/
        blocks.push('-');
        blocks.push(block('reportJoinWords'));
        blocks.push(block('reportTextSplit'));
        blocks.push(block('reportLetter'));
        blocks.push(block('reportStringSize'));
        blocks.push('-');
        blocks.push(block('reportUnicode'));
        blocks.push(block('reportUnicodeAsLetter'));
        blocks.push('-');
        blocks.push(block('reportIsA'));
        blocks.push(block('reportIsIdentical'));
        blocks.push('-');
        blocks.push(block('reportJSFunction'));

        if (world.role !== 'STUDENT' || !this.noCustomBlocks){
            blocks.push('=');
            blocks.push(this.makeBlockButton(cat));
        }

    //////////////////////////////////

	} else if (cat === 'variables') {
		if (world.role !== 'STUDENT' || !this.onlyScriptVars){
			button = new PushButtonMorph(
				null,
				function () {
					new VariableDialogMorph(
						null,
						addVar,
						myself
					).prompt(
						'Variable name',
						null,
						myself.world()
					);
				},
				'Make a variable'
			);
			
			blocks.push(button);

			if (this.variables.allNames(world.role=='STUDENT').length > 0) { // world.role=='STUDENT' means only visible names
				button = new PushButtonMorph(
					null,
					function () {
						var menu = new MenuMorph(
							myself.deleteVariable,
							null,
							myself
						);
						myself.variables.allNames(world.role=='STUDENT').forEach(function (name) { // world.role=='STUDENT' means allVISIBLEnames
							menu.addItem(name, name,null,null,false,false,null,true); //+++++++++++++++++++++++++++++ don't localize var names
						});
						menu.popUpAtHand(myself.world());
					},
					'Delete a variable'
				);
				
				blocks.push(button);
			}

			blocks.push('-');
		}
		
        varNames = this.variables.allNames();
        if (varNames.length > 0) {
            varNames.forEach(function (name) {
            
//========================== hide the hidden vars from student ===========================================================
				var frame = myself.variables.find(name);
				if (frame.hiddenVars[name]){  //if it's a hidden variable
                                    if (world.role !== 'STUDENT'){
                                        blocks.push(variableWatcherToggle(name));
					blocks.push(variableBlock(name,true)); //put the fainted variable in teachers mode
                                    }    // or not at all, in student mode
				} else{
                                    blocks.push(variableWatcherToggle(name));
                                    blocks.push(variableBlock(name));
                                }
//========================================================================================================================
            });
            blocks.push('-');
        }

        blocks.push(block('doSetVar'));
        blocks.push(block('doChangeVar'));
        blocks.push(block('doShowVar'));
        blocks.push(block('doHideVar'));
        blocks.push(block('doDeclareVariables'));
	// Network support:
        if (!this.noNetworkSupport) {
			blocks.push('=');
            blocks.push(block('doBroadcastVariable'));
        }
	///////////////////////////////	
 
    ///////////////////////////////

        blocks.push('=');

        blocks.push(block('reportNewList'));
        blocks.push('-');
        blocks.push(block('reportCONS'));
        blocks.push(block('reportListItem'));
        blocks.push(block('reportCDR'));
        blocks.push('-');
        blocks.push(block('reportListLength'));
        blocks.push(block('reportListContainsItem'));
        blocks.push('-');
        blocks.push(block('doAddToList'));
        blocks.push(block('doDeleteFromList'));
        blocks.push(block('doInsertInList'));
        blocks.push(block('doReplaceInList'));

    // for debugging: ///////////////

        if (this.world().isDevMode) {
            blocks.push('-');
            txt = new TextMorph(localize(
                'development mode \ndebugging primitives:'
            ));
            txt.fontSize = 9;
            txt.setColor(this.paletteTextColor);
            blocks.push(txt);
            blocks.push('-');
            blocks.push(block('reportMap'));
        }

    /////////////////////////////////

        blocks.push('=');

        if (StageMorph.prototype.enableCodeMapping) {
            blocks.push(block('doMapCodeOrHeader'));
            blocks.push(block('doMapStringCode'));
            blocks.push(block('doMapListCode'));
            blocks.push('-');
            blocks.push(block('reportMappedCode'));
            blocks.push('-');
        }
		if (world.role !== 'STUDENT' || !this.noCustomBlocks){
                    blocks.push(this.makeBlockButton());
		}
		
		if (world.role !== 'STUDENT'){ //constant block
			blocks.push(block('constantValue'));  
		}	
    } 
 
	 return blocks;
}


StageMorph.prototype.userMenu = function () {
    var ide = this.parentThatIsA(IDE_Morph),
        menu = new MenuMorph(this),
        myself = this,
		doNotShow = world.HOCmode || (world.role=='STUDENT' && (this.isSecret || (this.hideCorral)));

    if (ide && (ide.isAppMode || doNotShow) ) { //disable stage menu in HOCmode
        // menu.addItem('help', 'nop');
        return menu;
    }
//////////////////////////////////////////////
	if(world.role!='STUDENT' || !this.isSecret ){ 
		menu.addItem("edit", 'edit');	// hide edit from stage menu if stage isSecret
	}
//////////////////////////////////////////
    menu.addItem("show all", 'showAll');
	if (world.role !== 'STUDENT' || !world.HOCmode) {
		menu.addItem(
			"pic...",
			function () {
				ide.saveCanvasAs(
					myself.fullImageClassic(),
					myself.name
				);
			},
			'open a new window\nwith a picture of the stage'
		);
		menu.addLine();
		menu.addItem(
        		"pen trails",
			function () {
                            var costume = ide.currentSprite.reportPenTrailsAsCostume().copy();
                            ide.currentSprite.addCostume(costume);
                            ide.currentSprite.wearCostume(costume);
                            ide.hasChangedMedia = true;
                            ide.spriteBar.tabBar.tabTo('costumes');
			},
			ide.currentSprite instanceof SpriteMorph ?
                            'turn all pen trails and stamps\n' +
                                'into a new costume for the\ncurrently selected sprite'
                                    : 'turn all pen trails and stamps\n' +
                                        'into a new background for the stage'
			);

	}	
    return menu;
};

StageMorph.prototype.thumbnail = function (extentPoint, excludedSprite) {

//    answer a new Canvas of extentPoint dimensions containing
//    my thumbnail representation keeping the originial aspect ratio

    var myself = this,
        src = this.image,
        scale = Math.min(
            (extentPoint.x / src.width),
            (extentPoint.y / src.height)
        ),
        trg = newCanvas(extentPoint),
        ctx = trg.getContext('2d'),
        fb,
        fimg;

if (this.isSecret && excludedSprite == undefined) {     //faint the thumbnail if secret
ctx.globalAlpha = 0.2;
} else { ctx.globalAlpha = 1; }


    ctx.scale(scale, scale);
    ctx.drawImage(
        src,
        0,
        0
    );
    ctx.drawImage(
        this.penTrails(),
        0,
        0,
        this.dimensions.x * this.scale,
        this.dimensions.y * this.scale
    );
    this.children.forEach(function (morph) {
        if (morph.isVisible && (morph !== excludedSprite)) {
            fb = morph.fullBounds();
            fimg = morph.fullImage();
            if (fimg.width && fimg.height) {
                ctx.drawImage(
                    morph.fullImage(),
                    fb.origin.x - myself.bounds.origin.x,
                    fb.origin.y - myself.bounds.origin.y
                );
            }
        }
    });
    return trg;
};

StageMorph.prototype.categories = SpriteMorph.prototype.categories;
StageMorph.prototype.blockColor = SpriteMorph.prototype.blockColor;
StageMorph.prototype.palette = SpriteMorph.prototype.palette;
StageMorph.prototype.blocksMatching = SpriteMorph.prototype.blocksMatching;
StageMorph.prototype.addVariable = SpriteMorph.prototype.addVariable;
StageMorph.prototype.freshPalette = SpriteMorph.prototype.freshPalette;
StageMorph.prototype.deleteVariable = SpriteMorph.prototype.deleteVariable;

SpriteMorph.prototype.constantValue = function (cValue){  // constant blocks
	return cValue;
}
StageMorph.prototype.constantValue = SpriteMorph.prototype.constantValue;
