//modified, so loadCustom blocks can update the hidden standard categories (used in loadBlocks and loadSprites)
SnapSerializer.prototype.loadObject = function (object, model,udpdateCategories) {
    // private
    var blocks = model.require('blocks');
        dispatches = model.childNamed('dispatches');
        
    // load the instrument
    if (model.attributes.instrument) {
        object.instrument = +model.attributes.instrument;
    }    
    this.loadInheritanceInfo(object, model);
    this.loadNestingInfo(object, model);
   if (!(object.inheritanceInfo &&
            (object.inheritanceInfo.delegated instanceof Array) &&
            contains(object.inheritanceInfo.delegated, 'costumes'))) {
        this.loadCostumes(object, model);
    }
    // load sounds unless they're inherited
    if (!(object.inheritanceInfo &&
            (object.inheritanceInfo.delegated instanceof Array) &&
            contains(object.inheritanceInfo.delegated, 'sounds'))) {
        this.loadSounds(object, model);
    }
    this.loadCustomBlocks(object, blocks,false,false,udpdateCategories||false);
    if (dispatches) { //-??
        this.loadCustomBlocks(object, dispatches, false, true);
    }
    this.populateCustomBlocks(object, blocks);
    this.loadVariables(object.variables, model.require('variables'),object);
    if (!(object.inheritanceInfo &&
            (object.inheritanceInfo.delegated instanceof Array) &&
            contains(object.inheritanceInfo.delegated, 'scripts'))) {
        this.loadScripts(object, object.scripts, model.require('scripts'));
    }
};

SnapSerializer.prototype.rawLoadProjectModel = function (xmlNode) {
// public - answer a new Project represented by the given XML top node
    var myself = this,
        project = {sprites: {}},
        model,
        nameID,
        hints,hVarsBlocks;

    this.project = project;

    model = {project: xmlNode };
    if (+xmlNode.attributes.version > this.version) {
        throw 'Project uses newer version of Serializer';
    }

    /* Project Info */
	
    this.objects = {};
    project.name = model.project.attributes.name;
    if (!project.name) {
        nameID = 1;
        while (
            Object.prototype.hasOwnProperty.call(
                localStorage,
                '-snap-project-Untitled ' + nameID
            )
        ) {
            nameID += 1;
        }
        project.name = 'Untitled ' + nameID;
    }
    model.notes = model.project.childNamed('notes');
    if (model.notes) {
        project.notes = model.notes.contents;
    }
    model.globalVariables = model.project.childNamed('variables');
    project.globalVariables = new VariableFrame();
	
/*manage categories*/     //custom categories

// hidden standard categories
		SpriteMorph.prototype.hiddenStandardCategories = []; //empty the hiddenStandardCategories array
		if (model.project.childNamed('hiddenStandardCategories')) { //if exists,(does not exist in official project
				model.project.childNamed('hiddenStandardCategories').contents.split(' ').forEach(
					function (sel) {
						if (sel) {
							 SpriteMorph.prototype.hiddenStandardCategories.push(sel);
						}
					}
				);}
// custom categories
			SpriteMorph.prototype.customCategories.forEach(function (cat){
				delete SpriteMorph.prototype.blockColor[cat];          //clear the blockColors array from the colors of the previous custom categories if any
			});
			SpriteMorph.prototype.customCategories = [];  // clear the rest of the arrays
			if (model.project.childNamed('customCategories')) { //if there is a child named 'customCategories'
				model.project.childNamed('customCategories').childrenNamed('category').forEach( function (model){
					var name, color, count;
					if (Object.prototype.hasOwnProperty.call(
									model.attributes,
									'name'
								)) {
								name = model.attributes.name;
							}
					if (Object.prototype.hasOwnProperty.call(
									model.attributes,
									'color'
								)) {
								color = myself.loadColor(model.attributes.color);
							}
					if (Object.prototype.hasOwnProperty.call(
									model.attributes,
									'count'
								)) {
								count = parseInt(model.attributes.count);
							}
					SpriteMorph.prototype.customCategories.push(name);
					SpriteMorph.prototype.blockColor[name] = color;
				});
			}
			
//====manage categories============== //custom categories end
	    /* Stage */

    model.stage = model.project.require('stage');
    StageMorph.prototype.frameRate = 0;
    project.stage = new StageMorph(project.globalVariables);
    if (Object.prototype.hasOwnProperty.call(
            model.stage.attributes,
            'id'
        )) {
        this.objects[model.stage.attributes.id] = project.stage;
    }
    if (model.stage.attributes.name) {
        project.stage.name = model.stage.attributes.name;
    }
//////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'isSecret'
			)){	project.stage.isSecret = model.stage.attributes.isSecret !== 'false';} // --------------------- is secret stage 
	else {project.stage.isSecret=false;}
//---------------------------------------------------------------------------
//////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'blockExecutionOnClick'
			)){	project.stage.exerciseMode = model.stage.attributes.blockExecutionOnClick == 'false';} // --------------------- disable block execution on click 
				else {project.stage.exerciseMode=false;}
//---------------------------------------------------------------------------
////////////////////////////// 
//////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'addsprites'
			)){	project.stage.canAddSprites = model.stage.attributes.addsprites !== 'false';} // --------------------- can add sprites
				else {project.stage.canAddSprites=true;}
//---------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'importExportHOC'
			)){	project.stage.importExportHOC = model.stage.attributes.importExportHOC !== 'false';} // --------------------- can add sprites
				else {project.stage.importExportHOC=false;}
//---------------------------------------------------------------------------
//////////////////////////////  
////////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'hideCostumes'
			)){	project.stage.hideCostumes = model.stage.attributes.hideCostumes !== 'false';} // --------------------- can add sprites
				else {project.stage.hideCostumes=false;}
//---------------------------------------------------------------------------
//////////////////////////////  
//////////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'hideSounds'
			)){	project.stage.hideSounds = model.stage.attributes.hideSounds !== 'false';} // --------------------- can add sprites
				else {project.stage.hideSounds=false;}
//---------------------------------------------------------------------------
//////////////////////////////
////////////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'hideSpriteBar'
			)){	project.stage.hideSpriteBar = model.stage.attributes.hideSpriteBar !== 'false';} // --------------------- can add sprites
				else {project.stage.hideSpriteBar=false;}
//---------------------------------------------------------------------------
//////////////////////////////
//////////////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'hideCorral'
			)){	project.stage.hideCorral = model.stage.attributes.hideCorral !== 'false';} // --------------------- can add sprites
				else {project.stage.hideCorral=false;}
//---------------------------------------------------------------------------
//////////////////////////////
////////////////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'noNetworkSupport'
			)){	project.stage.noNetworkSupport = model.stage.attributes.noNetworkSupport !== 'false';} // --------------------- can add sprites
				else {project.stage.noNetworkSupport=false;}
//---------------------------------------------------------------------------
//////////////////////////////
////////////////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'onlyScriptVars'
			)){	project.stage.onlyScriptVars = model.stage.attributes.onlyScriptVars !== 'false';} // --------------------- can add sprites
				else {project.stage.onlyScriptVars=false;}
//---------------------------------------------------------------------------
//////////////////////////////
//////////////////////////////////////////
//--------------------------------------------------------------------------
	if (Object.prototype.hasOwnProperty.call(
				model.stage.attributes,
				'noCustomBlocks'
			)){	project.stage.onlyScriptVars = model.stage.attributes.noCustomBlocks !== 'false';} // --------------------- can add sprites
				else {project.stage.noCustomBlocks=false;}
//---------------------------------------------------------------------------
//////////////////////////////
//////////////////////////////  
	if (model.stage.attributes.scheduled === 'true') {
        project.stage.fps = 30;
        StageMorph.prototype.frameRate = 30;
    }
    model.pentrails = model.stage.childNamed('pentrails');
    if (model.pentrails) {
        project.pentrails = new Image();
        project.pentrails.onload = function () {
            if (project.stage.trailsCanvas) { // work-around a bug in FF
                normalizeCanvas(project.stage.trailsCanvas); // retina normalization
                var context = project.stage.trailsCanvas.getContext('2d');
                context.drawImage(project.pentrails, 0, 0);
                project.stage.changed();
            }
        };
        project.pentrails.src = model.pentrails.contents;
    }
    project.stage.setTempo(model.stage.attributes.tempo);
    StageMorph.prototype.dimensions = new Point(480, 360);
    if (model.stage.attributes.width) {
        StageMorph.prototype.dimensions.x =
            Math.max(+model.stage.attributes.width, 480);
    }
    if (model.stage.attributes.height) {
        StageMorph.prototype.dimensions.y =
            Math.max(+model.stage.attributes.height, 180);
    }
    project.stage.setExtent(StageMorph.prototype.dimensions);
    SpriteMorph.prototype.useFlatLineEnds =
        model.stage.attributes.lines === 'flat';
    BooleanSlotMorph.prototype.isTernary =
        model.stage.attributes.ternary !== 'false';    
    project.stage.isThreadSafe =
        model.stage.attributes.threadsafe === 'true';
	project.stage.hideCostumes =						//--++-- hide costumes, sounds, sprite bar and corral
        model.stage.attributes.hideCostumes === 'true';
	project.stage.hideSounds =
        model.stage.attributes.hideSounds === 'true'; 
	project.stage.hideSpriteBar =
        model.stage.attributes.hideSpriteBar === 'true'; 
	project.stage.hideCorral =
        model.stage.attributes.hideCorral === 'true'; 
	project.stage.onlyScriptVars =
        model.stage.attributes.onlyScriptVars === 'true'; 
	project.stage.noCustomBlocks =
        model.stage.attributes.noCustomBlocks === 'true'; 		//--++--			
    StageMorph.prototype.enableCodeMapping =
        model.stage.attributes.codify === 'true';
	project.stage.noNetworkSupport = 
		model.stage.attributes.noNetworkSupport  === 'true'; //network support	
    StageMorph.prototype.enableInheritance =
        model.stage.attributes.inheritance === 'true';
    StageMorph.prototype.enableSublistIDs =
        model.stage.attributes.sublistIDs === 'true';    
	
	model.hiddenPrimitives = model.project.childNamed('hidden');
    if (model.hiddenPrimitives) {
        model.hiddenPrimitives.contents.split(' ').forEach(
            function (sel) {
                if (sel) {
                    StageMorph.prototype.hiddenPrimitives[sel] = true;
                }
            }
        );
    }

    model.codeHeaders = model.project.childNamed('headers');
    if (model.codeHeaders) {
        model.codeHeaders.children.forEach(function (xml) {
            StageMorph.prototype.codeHeaders[xml.tag] = xml.contents;
        });
    }

    model.codeMappings = model.project.childNamed('code');
    if (model.codeMappings) {
        model.codeMappings.children.forEach(function (xml) {
            StageMorph.prototype.codeMappings[xml.tag] = xml.contents;
        });
    }

    model.globalBlocks = model.project.childNamed('blocks');
    if (model.globalBlocks) {
        this.loadCustomBlocks(project.stage, model.globalBlocks, true);
        this.populateCustomBlocks(
            project.stage,
            model.globalBlocks,
            true
        );
    }
	
//++++++++++++++++++++++ deal with exercise MODE
	if (world.role == 'STUDENT') {
		/*var runBlock = project.stage.findSpecialCustomBlock("$$run$$"); // check for the $$run$$ block
		if (runBlock) {
			project.stage.specialBlocks.push(runBlock);
			project.stage.exerciseMode = true;
		}*/
		project.stage.specialBlocks =  project.stage.specialBlocks.concat(project.stage.findSpecialBlocks());  //populate the rest of special Blocks array
	}
//++++++++++++++++++++++++++++


//++++++++++++++++++++++++++++++++++++ load depository +++++++++++++++++++++++++++++++++
	model.depository = model.project.childNamed('depository');
	var variables=[],primitives=[],customBlocks=[],
		categories = SpriteMorph.prototype.standardCategories.concat(SpriteMorph.prototype.customCategories); //for sorting blocks	
	// ------		
		if (model.depository) {
			if (model.depository.childNamed('primitives')) { //primitives
				model.depository.childNamed('primitives').contents.split(' ').forEach(
					function (sel) {
						var temp;
						if (sel) {
							temp = SpriteMorph.prototype.blockForSelector(sel, true);;
							primitives.push(['primitive',sel,temp.category]);
						}
				});
			}
			if (model.depository.childNamed('variables')) {    // variables
				model.depository.childNamed('variables').childrenNamed('variable').forEach(
					function (model) {					
						variables.push(['variable',model.attributes.name,'vars']);						
					});
			}
			if (model.depository.childNamed('custom-blocks')) {
				model.depository.childNamed('custom-blocks').childrenNamed('custom-block').forEach( // custom blocks
					function (model) {
						var isLocked = detect(project.stage.globalBlocks,function(def){
							return def.blockSpec() == model.attributes.s && def.isLocked;
						});
						if (isLocked){
							primitives.push(['custom-block',model.attributes.s,model.attributes.cat]);  // locked custom blocks are treated as primitives
						} else {	
							customBlocks.push(['custom-block',model.attributes.s,model.attributes.cat]);
						}	
				});
			} 
	// ----- sort the depository blocks, putting variables first, followed by commands sorted by category and putting editable custom blocks in the end -----
			primitives.sort(function (a,b) {
				return categories.indexOf(a[2]) - categories.indexOf(b[2]);
			});			
			customBlocks.sort(function (a,b) {
				return categories.indexOf(a[2]) - categories.indexOf(b[2]);
			});
			
			project.stage.depositoryCommands = variables.concat(primitives,customBlocks);
			
		}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		this.loadObject(project.stage, model.stage);
                // ----- deal with hints
                hints = model.stage.childNamed('hints');
                if (hints){
                    project.stage.hints = new HintsEditorMorph(project.stage);
                    if (world.role !== "STUDENT"){
                        myself.loadScripts(project.stage.hints, project.stage.hints.scripts, hints);
                    } else {
                        project.stage.hints.scriptsBackUp = new ScriptsMorph();
                        myself.loadScripts(project.stage.hints, project.stage.hints.scriptsBackUp, hints);
                        myself.loadScriptsInHistory(project.stage.hints, project.stage.hints.scripts, hints);
                        if (project.stage.hints.scriptsBackUp.children.length>0){ //if there are block to drop
                         //animate first step
                            project.stage.hints.fps=2;
                            project.stage.hints.isAnimating = true;
                            project.stage.hints.nextSteps([
                                 nop,
                                 function(){ 
                                    this.scripts.scrollFrame.toolBar.undoButton.mouseClickLeft();
                                    this.fps=0;
                                    this.scripts.isAnimating = false;
                                } 
                             ]);
                        } 
                    }
                    hVarsBlocks = hints.childNamed('vars-and-blocks');
                    if (hVarsBlocks){
                        if (world.role !== "STUDENT"){
                            myself.loadScripts(project.stage.hints, project.stage.hints.varAndCustomScripts, hVarsBlocks);
                        } else {
                            project.stage.hints.varAndCustomScriptsBackUp = new ScriptsMorph();
                            myself.loadScripts(project.stage.hints, project.stage.hints.varAndCustomScriptsBackUp, hVarsBlocks);
                            myself.loadScriptsAsButtons(project.stage.hints, project.stage.hints.varAndCustomScripts, hVarsBlocks);
                        }    
                    }
                } else {
                    project.stage.hints = null;
                }
                // ----- deal with hints

    /* Sprites */

    model.sprites = model.stage.require('sprites');
    project.sprites[project.stage.name] = project.stage;

    model.sprites.childrenNamed('sprite').forEach(function (model) {
        myself.loadValue(model);
    });

    // restore inheritance and nesting associations
    myself.project.stage.children.forEach(function (sprite) {
        var exemplar, anchor;
        if (sprite.inheritanceInfo) { // only sprites can inherit
            exemplar = myself.project.sprites[
                sprite.inheritanceInfo.exemplar
            ];
            if (exemplar) {
                sprite.setExemplar(exemplar);
            }
            sprite.inheritedAttributes = sprite.inheritanceInfo.delegated || [];
        }
        if (sprite.nestingInfo) { // only sprites may have nesting info
            anchor = myself.project.sprites[sprite.nestingInfo.anchor];
            if (anchor) {
                anchor.attachPart(sprite);
            }
            sprite.rotatesWithAnchor = (sprite.nestingInfo.synch === 'true');
        }
    });
    myself.project.stage.children.forEach(function (sprite) {
       var costume;
        if (sprite.nestingInfo) { // only sprites may have nesting info
            sprite.nestingScale = +(sprite.nestingInfo.scale || sprite.scale);
            delete sprite.nestingInfo;
        }
        ['scripts', 'costumes', 'sounds'].forEach(function (att) {
            if (sprite.inheritsAttribute(att)) {
                sprite.refreshInheritedAttribute(att);
            }
        });
        if (sprite.inheritsAttribute('costumes')) {
            costume = sprite.costumes.asArray()[
                sprite.inheritanceInfo.costumeNumber - 1
            ];
            if (costume) {
                if (costume.loaded) {
                    sprite.wearCostume(costume, true);
                } else {
                    costume.loaded = function () {
                        sprite.wearCostume(costume, true);
                        this.loaded = true;
                    };
                }
            }
        }
        delete sprite.inheritanceInfo; 
    });

    /* Global Variables */

    if (model.globalVariables) {		
        this.loadVariables(
            project.globalVariables,
            model.globalVariables
        );
    }
    this.objects = {};

    /* Watchers */

    model.sprites.childrenNamed('watcher').forEach(function (model) {
        var watcher, color, target, hidden, extX, extY;

        color = myself.loadColor(model.attributes.color);
        target = Object.prototype.hasOwnProperty.call(
            model.attributes,
            'scope'
        ) ? project.sprites[model.attributes.scope] : null;

        // determine whether the watcher is hidden, slightly
        // complicated to retain backward compatibility
        // with former tag format: hidden="hidden"
        // now it's: hidden="true"
        hidden = Object.prototype.hasOwnProperty.call(
            model.attributes,
            'hidden'
        ) && (model.attributes.hidden !== 'false');

        if (Object.prototype.hasOwnProperty.call(
                model.attributes,
                'var'
            )) {
            watcher = new WatcherMorph(
                model.attributes['var'], 
                color, 
                isNil(target) ? project.globalVariables
                    : target.variables,
                model.attributes['var'],
                hidden
            );
        } else {
            watcher = new WatcherMorph(
                localize(myself.watcherLabels[model.attributes.s]),
                color,
                target,
                model.attributes.s,
                hidden
            );
        }
        watcher.setStyle(model.attributes.style || 'normal');
        if (watcher.style === 'slider') {
            watcher.setSliderMin(model.attributes.min || '1', true);
            watcher.setSliderMax(model.attributes.max || '100', true);
        }
        watcher.setPosition(
            project.stage.topLeft().add(new Point(
                +model.attributes.x || 0,
                +model.attributes.y || 0
            ))
        );
        project.stage.add(watcher);
        watcher.onNextStep = function () {this.currentValue = null; };

        // set watcher's contentsMorph's extent if it is showing a list and
        // its monitor dimensions are given
        if (watcher.currentValue instanceof List) {
            extX = model.attributes.extX;
            if (extX) {
                watcher.cellMorph.contentsMorph.setWidth(+extX);
            }
            extY = model.attributes.extY;
            if (extY) {
                watcher.cellMorph.contentsMorph.setHeight(+extY);
            }
            // adjust my contentsMorph's handle position
            watcher.cellMorph.contentsMorph.handle.drawNew();
        }
    });
    
    // clear sprites' inherited methods caches, if any
    myself.project.stage.children.forEach(function (sprite) {
        sprite.inheritedMethodsCache = [];
    });
    
    this.objects = {};
    return project;
};

SnapSerializer.prototype.loadBlocks = function (xmlString, targetStage) {
    // public - answer a new Array of custom block definitions
    // represented by the given XML String
    var stage = new StageMorph(),
        model,
		myself = this; //custom categories


    this.project = {
        stage: stage,
        sprites: {},
        targetStage: targetStage // for secondary custom block def look-up
    };
    model = this.parse(xmlString);
    if (+model.attributes.version > this.version) {
        throw 'Module uses newer version of Serializer';
    }   
    this.loadCustomBlocks(stage, model, true,false,true); //the second true means update standard categories       
    this.populateCustomBlocks(
        stage,
        model,
        true
    );            
    this.objects = {};
    stage.globalBlocks.forEach(function (def) {
        def.receiver = null;
    });
    this.objects = {};
    this.project = {};
    this.mediaDict = {};

//custom categories
	if (model.childNamed('customCategories')) { //if there are custom blocks that belong to custom categories
		model.childNamed('customCategories').childrenNamed('category').forEach( function (model){
			var name, color,count;
			if (Object.prototype.hasOwnProperty.call(
							model.attributes,
							'name'
						)) {
						name = model.attributes.name;
					}
			if (Object.prototype.hasOwnProperty.call(
							model.attributes,
							'color'
						)) {
						color = myself.loadColor(model.attributes.color);
					}
			if (Object.prototype.hasOwnProperty.call(
							model.attributes,
							'count'
						)) {
						count = parseInt(model.attributes.count);
					}		
			if (!contains(SpriteMorph.prototype.customCategories,name)){ //if the custom category not already present, add it		
				SpriteMorph.prototype.customCategories.push(name);
				SpriteMorph.prototype.blockColor[name] = color;
			}
		});
	}
//custom categories end
    return stage.globalBlocks; //categories.length == 0 ? {'blocks':stage.globalBlocks} : {'blocks':stage.globalBlocks, 'categories':categories} ;
//custom categories end
};

SnapSerializer.prototype.loadSprites = function (xmlString, ide) {
	// public - import a set of sprites represented by xmlString
    // into the current project of the ide
    var model, project, myself = this;

    project = this.project = {
        globalVariables: ide.globalVariables,
        stage: ide.stage,
        sprites: {}
    };
    project.sprites[project.stage.name] = project.stage;

    model = this.parse(xmlString);
    if (+model.attributes.version > this.version) {
        throw 'Module uses newer version of Serializer';
    }
//custom categories
	if (model.childNamed('customCategories')) { //if the sprite has custom blocks that belong to custom categories
		model.childNamed('customCategories').childrenNamed('category').forEach( function (model){
			var name, color,count;
			if (Object.prototype.hasOwnProperty.call(
							model.attributes,
							'name'
						)) {
						name = model.attributes.name;
					}
			if (Object.prototype.hasOwnProperty.call(
							model.attributes,
							'color'
						)) {
						color = myself.loadColor(model.attributes.color);
					}
			/*if (Object.prototype.hasOwnProperty.call(
							model.attributes,
							'count'
						)) {
						count = parseInt(model.attributes.count);
					}	*/	
			if (!contains(SpriteMorph.prototype.customCategories,name)){ //if the custom category not already present, add it		
				SpriteMorph.prototype.customCategories.push(name);
				SpriteMorph.prototype.blockColor[name] = color;
			} 
		});
	}
//custom categories end
	model.childrenNamed('sprite').forEach(function (model) {
        var sprite  = new SpriteMorph(project.globalVariables);

        if (model.attributes.id) {
            myself.objects[model.attributes.id] = sprite;
        }
        if (model.attributes.name) {
            sprite.name = model.attributes.name;
            project.sprites[model.attributes.name] = sprite;
        }
        if (model.attributes.color) {
            sprite.color = myself.loadColor(model.attributes.color);
        }
        if (model.attributes.pen) {
            sprite.penPoint = model.attributes.pen;
        }
        project.stage.add(sprite);
        ide.sprites.add(sprite);
        sprite.scale = parseFloat(model.attributes.scale || '1');
        sprite.rotationStyle = parseFloat(
            model.attributes.rotation || '1'
        );
        sprite.isDraggable = model.attributes.draggable !== 'false';
//--------------------------------------------------------------------------
		if (Object.prototype.hasOwnProperty.call(
					model.attributes,
					'isSecret'
				)){	sprite.isSecret = model.attributes.isSecret !== 'false';}
					else {sprite.isSecret=false;}// is secret
		if (Object.prototype.hasOwnProperty.call(
					model.attributes,
					'isLocked'
				)){	sprite.isLocked = model.attributes.isLocked !== 'false';}
					else {sprite.isLocked=false;}//hide rotation
//---------------------------------------------------------------------------
	sprite.isVisible = model.attributes.hidden !== 'true';
        sprite.heading = parseFloat(model.attributes.heading) || 0;
        sprite.drawNew();
        sprite.gotoXY(+model.attributes.x || 0, +model.attributes.y || 0);
        myself.loadObject(sprite, model,true); // true means update the standard categories
	});
	 // restore inheritance and nesting associations
    project.stage.children.forEach(function (sprite) {
        var exemplar, anchor;
        if (sprite.inheritanceInfo) { // only sprites can inherit
            exemplar = project.sprites[
                sprite.inheritanceInfo.exemplar
            ];
            if (exemplar) {
                sprite.setExemplar(exemplar);
            }
        }
        if (sprite.nestingInfo) { // only sprites may have nesting info
            anchor = project.sprites[sprite.nestingInfo.anchor];
            if (anchor) {
                anchor.attachPart(sprite);
            }
            sprite.rotatesWithAnchor = (sprite.nestingInfo.synch === 'true');
        }
    });
    project.stage.children.forEach(function (sprite) {
        delete sprite.inheritanceInfo;
        if (sprite.nestingInfo) { // only sprites may have nesting info
            sprite.nestingScale = +(sprite.nestingInfo.scale || sprite.scale);
            delete sprite.nestingInfo;
        }
    });

    this.objects = {};
    this.project = {};
    this.mediaDict = {};
	
	ide.createCategories();
    ide.createCorral();
    ide.fixLayout();
}

SnapSerializer.prototype.loadVariables = function (varFrame, element,object) {
    // private
    var myself = this;
	
    element.children.forEach(function (child) {
        var v,value;
        if (child.tag !== 'variable') {
            return;
        }
        value = child.children[0];

        /*varFrame.vars[child.attributes.name] = new Variable(value ? //+
                myself.loadValue(value) : 0);*/
        v = new Variable(); // v 4.0.10.2
        v.isTransient = (child.attributes.transient === 'true');
        v.value = (v.isTransient || !value ) ? 0 : myself.loadValue(value,object);
        varFrame.vars[child.attributes.name] = v;
		if (child.attributes.isHidden && child.attributes.isHidden =="true") {varFrame.hiddenVars[child.attributes.name] = true;} // ----------------------- add hidden vars to hiddenvars array
		if (child.attributes.isLocked && child.attributes.isLocked =="true") {varFrame.vars[child.attributes.name].isLocked=true;} //check if variable is locked
    });
};

SnapSerializer.prototype.loadCustomBlocks = function (
    object,
    element,
    isGlobal,
    isDispatch,
	updateStCategories //if true unhide the standard categories of the blocks
) {
    // private
    var myself = this;
    element.children.forEach(function (child) {
        var definition, names, inputs, vars, header, code, comment, i;
        if (child.tag !== 'block-definition') {		
            return;
        }
		
        definition = new CustomBlockDefinition(
            child.attributes.s || '',
            object
        );
        definition.category = child.attributes.category || 'other';
// update standard categories
		if (updateStCategories) { //for loadBlocks and loadSprites
			var count,idx;
			if (contains(['variables','lists','other'],definition.category)){ 
				idx = SpriteMorph.prototype.hiddenStandardCategories.indexOf('variables');
				count = 3;
			} else {
				idx = SpriteMorph.prototype.hiddenStandardCategories.indexOf(definition.category);
				count = 1;
			}

			if (idx >= 0) { //if the custom block belongs to a hidden standard category
				SpriteMorph.prototype.hiddenStandardCategories.splice(idx,count); //unhide the standard category
			}
		}
/////////////////////////////		
        definition.type = child.attributes.type || 'command';
		definition.isLocked = child.attributes.isLocked=='true' || false; //////////////////// load the isLocked attribute
		definition.isHidden = child.attributes.isHidden=='true' || false; //////////////////// load the isHidden attribute
        definition.isGlobal = (isGlobal === true);
        if (isDispatch) {
            object.inheritedMethodsCache.push(definition);
        } else {
            if (definition.isGlobal) {
                object.globalBlocks.push(definition);
            } else {
                object.customBlocks.push(definition);
            }
        }

        names = definition.parseSpec(definition.spec).filter(
            function (str) {
                return str.charAt(0) === '%' && str.length > 1;
            }
        ).map(function (str) {
            return str.substr(1);
        });

        definition.names = names;
        inputs = child.childNamed('inputs');
        if (inputs) {
            i = -1;
            inputs.children.forEach(function (child) {
                var options = child.childNamed('options');
                if (child.tag !== 'input') {
                    return;
                }
                i += 1;
                definition.declarations[names[i]] = [
                    child.attributes.type,
                    contains(['%b', '%boolUE'], child.attributes.type) ?
                        (child.contents ? child.contents === 'true' : null)
                            : child.contents,
                    options ? options.contents : undefined,
                    child.attributes.readonly === 'true'
                ];
            });
        }

        vars = child.childNamed('variables');
        if (vars) {
            definition.variableNames = myself.loadValue(
                vars.require('list')
            ).asArray();
        }

        header = child.childNamed('header');
        if (header) {
            definition.codeHeader = header.contents;
        }

        code = child.childNamed('code');
        if (code) {
            definition.codeMapping = code.contents;
        }

        comment = child.childNamed('comment');
        if (comment) {
            definition.comment = myself.loadComment(comment);
        }
	
    });
};

SnapSerializer.prototype.loadBlock = function (model, isReporter, object) {
    // private
    var block, info, inputs, isGlobal, receiver, migration,
        migrationOffset = 0;
//--------------------------------------------------------------
    var isHidden="false";                                              
    if (Object.prototype.hasOwnProperty.call(
            model.attributes,
             'isHidden'                                                            
        )) {
		isHidden= model.attributes['isHidden'];										
    }
//	isVisible = isHidden == "false"; // for backward compatibility
// --------------------------------read the isDraggable attribute
 var isDraggable="true";                                              
    if (Object.prototype.hasOwnProperty.call(
            model.attributes,
             'isDraggable'                                                           
        )) {
		isDraggable= model.attributes['isDraggable'];										
    }
 //--------------------------------------------------------------------------------  
    if (model.tag === 'block') {
        if (Object.prototype.hasOwnProperty.call(
                model.attributes,
                'var'
            )) {
            var block = SpriteMorph.prototype.variableBlock(
                model.attributes['var']);
           //-----------------------------  
			//block.isDraggable = isDraggable == "true"; //+++++++++++++++++
			block.setDraggable(isDraggable == "true");
			block.isHidden = isHidden === "true";
			if (block.isHidden){
			block.hide(world.role=='STUDENT');
			} else { block.show();}
			//-----------------------------    
			//	block.isVisible = isVisible === "true";
            return block;
        }
        block = SpriteMorph.prototype.blockForSelector(model.attributes.s);
        migration = SpriteMorph.prototype.blockMigrations[model.attributes.s];
        if (migration) {
            migrationOffset = migration.offset;
        }
//-----------------------------        
				//block.isVisible = isVisible === "true";
            if (block) { //block is not obsolete                   
		block.isHidden = isHidden === "true";
		if (block.isHidden){
			block.hide(world.role=='STUDENT');
		} else { 
			block.show();
		}
            }    
//block.isVisible = isVisible === "true";
//-----------------------------    
	} else if (model.tag === 'custom-block') {
        isGlobal = model.attributes.scope ? false : true;
        receiver = isGlobal ? this.project.stage : 
                    (object instanceof HintsEditorMorph ? object.target :object);        
        if (isGlobal) {
            info = detect(receiver.globalBlocks, function (block) {
                return block.blockSpec() === model.attributes.s;
            });           
            if (!info && this.project.targetStage) { // importing block files
                info = detect(
                    this.project.targetStage.globalBlocks,
                    function (block) {
                        return block.blockSpec() === model.attributes.s;
                    }
                );
            }
        } else {          
           // lookup in inherited methods
            info = detect(receiver.customBlocks, function (block) {
                return block.blockSpec() === model.attributes.s;
            }) || ( receiver instanceof SpriteMorph &&
                    detect(receiver.inheritedMethodsCache, function (block) {
                return block.blockSpec() === model.attributes.s;
            }));
             
        }
        
        if (!info) {
            return this.obsoleteBlock(isReporter);
        }
        block = info.type === 'command' ? new CustomCommandBlockMorph(
            info,
            false
        ) : new CustomReporterBlockMorph(
            info,
            info.type === 'predicate',
            false
        );
//////////////////////////
		block.isHidden = isHidden === "true";
		if (block.isHidden){
			block.hide(world.role=='STUDENT');
		} else { 
			block.show();
		}
//block.isVisible = isVisible === "true";
/////////////////////////////
   //     block.isVisible = isVisible === "true";
    }
    if (block === null) {
        block = this.obsoleteBlock(isReporter);
    }

// -------------------------------------------
	//block.isDraggable = isDraggable == "true";
	block.setDraggable(isDraggable == "true");
// --------------------------------------------
    inputs = block.inputs();
    model.children.forEach(function (child, i) {
        if (child.tag === 'variables') {
            this.loadVariables(block.variables, child,object);
        } else if (child.tag === 'comment') {
            block.comment = this.loadComment(child);
            block.comment.block = block;
        } else if (child.tag === 'receiver') {
            nop(); // ignore
        } else {
            this.loadInput(child, inputs[i + migrationOffset], block, object);
        }
    }, this);
    block.cachedInputs = null;
    return block;
};

SnapSerializer.prototype.loadValue = function (model,object) {
    // private
    var v, i, lst, items, el, center, image, name, audio, option, bool, origin, hints,
        hVarsBlocks,myself = this;

    function record() {
        if (Object.prototype.hasOwnProperty.call(
                model.attributes,
                'id'
            )) {
            myself.objects[model.attributes.id] = v;
        }
        if (Object.prototype.hasOwnProperty.call(
                model.attributes,
                'mediaID'
            )) {
            myself.mediaDict[model.attributes.mediaID] = v;
        }
    }
    switch (model.tag) {
    case 'ref':
        if (Object.prototype.hasOwnProperty.call(model.attributes, 'id')) {
            return this.objects[model.attributes.id];
        }
        if (Object.prototype.hasOwnProperty.call(
                model.attributes,
                'mediaID'
            )) {
            return this.mediaDict[model.attributes.mediaID];
        }
        throw new Error('expecting a reference id');
    case 'l':
        option = model.childNamed('option');
        /*return option ? [option.contents] : model.contents;*/
        if (option) {
            return [option.contents];
        }
        bool = model.childNamed('bool');
        if (bool) {
            return this.loadValue(bool);
        }
        return model.contents;
    case 'bool':
        return model.contents === 'true';
    case 'list':
        if (model.attributes.hasOwnProperty('linked')) {
            /*items = model.childrenNamed('item');
            if (items.length === 0) {
                v = new List();
                record();
                return v;
            }
            items.forEach(function (item) {
                var value = item.children[0];
                if (v === undefined) {
                    v = new List();
                    record();
                } else {
                    v = v.rest = new List();
                }
                v.isLinked = true;
                if (!value) {
                    v.first = 0;
                } else {
                    v.first = myself.loadValue(value);
                }
            });
            return v;*/
            v = new List();
            v.isLinked = true;
            record();
            lst = v;
            items = model.childrenNamed('item');
            items.forEach(function (item, i) {
                var value = item.children[0];
                if (!value) {
                    v.first = 0;
                } else {
                    v.first = myself.loadValue(value,object);
                }
                var tail = model.childNamed('list') ||
                    model.childNamed('ref');
                if (tail) {
                    v.rest = myself.loadValue(tail,object);
                } else {
                    if (i < (items.length - 1)) {
                        v.rest = new List();
                        v = v.rest;
                        v.isLinked = true;
                    }
                }
            });
            return lst;
        }
        v = new List();
        record();
        v.contents = model.childrenNamed('item').map(function (item) {
            var value = item.children[0];
            if (!value) {
                return 0;
            }
            return myself.loadValue(value,object);
        });
        return v;
    case 'sprite':
        v  = new SpriteMorph(myself.project.globalVariables);
        if (model.attributes.id) {
            myself.objects[model.attributes.id] = v;
        }
        if (model.attributes.name) {
            v.name = model.attributes.name;
            myself.project.sprites[model.attributes.name] = v;
        }
        if (model.attributes.idx) {
            v.idx = +model.attributes.idx;
        }
        if (model.attributes.color) {
            v.color = myself.loadColor(model.attributes.color);
        }
        if (model.attributes.pen) {
            v.penPoint = model.attributes.pen;
        }
        myself.project.stage.add(v);
        v.scale = parseFloat(model.attributes.scale || '1');
        v.rotationStyle = parseFloat(
            model.attributes.rotation || '1'
        );
        v.isDraggable = model.attributes.draggable !== 'false';
//--------------------------------------------------------------------------
		if (Object.prototype.hasOwnProperty.call(
					model.attributes,
					'isSecret'
				)){	v.isSecret = model.attributes.isSecret !== 'false';}
		else {v.isSecret=false;}// is secret
		if (Object.prototype.hasOwnProperty.call(
					model.attributes,
					'isLocked'
				)){	v.isLocked = model.attributes.isLocked !== 'false';}
		else {v.isLocked=false;}//hide rotation
//---------------------------------------------------------------------------
        v.isVisible = model.attributes.hidden !== 'true';
        v.heading = parseFloat(model.attributes.heading) || 0;
        v.drawNew();
        v.gotoXY(+model.attributes.x || 0, +model.attributes.y || 0);
        myself.loadObject(v, model);
        // ----- deal with hints
        hints = model.childNamed('hints');
        if (hints){            
            v.hints = new HintsEditorMorph(v);
            if (world.role !== "STUDENT"){
                myself.loadScripts(v.hints, v.hints.scripts, hints);              
            } else{               
                v.hints.scriptsBackUp = new ScriptsMorph();                  
                myself.loadScripts(v.hints, v.hints.scriptsBackUp, hints);            
                myself.loadScriptsInHistory(v.hints, v.hints.scripts, hints);
                if (v.hints.scriptsBackUp.children.length>0){ //if there are block to drop
                    //animate first step
                    v.hints.fps=2;
                    v.hints.nextSteps([
                        nop,
                        function(){ 
                           this.scripts.scrollFrame.toolBar.undoButton.mouseClickLeft();
                           this.fps=0;
                       } 
                    ]);
                }    
            }
            hVarsBlocks = hints.childNamed('vars-and-blocks');
                if (hVarsBlocks){
                    if (world.role !== "STUDENT"){
                        myself.loadScripts(v.hints, v.hints.varAndCustomScripts, hVarsBlocks);
                    } else {
                        v.hints.varAndCustomScriptsBackUp = new ScriptsMorph();
                        myself.loadScripts(v.hints, v.hints.varAndCustomScriptsBackUp, hVarsBlocks);
                        myself.loadScriptsAsButtons(v.hints, v.hints.varAndCustomScripts, hVarsBlocks);
                    }    
                }
        } else {
            v.hints = null;
        }
        // ----- deal with hints
        return v;
    case 'context':
        v = new Context(null);
        record();
        el = model.childNamed('origin');
        if (el) {
            el = el.childNamed('ref') || el.childNamed('sprite');
            if (el) {
                v.origin = this.loadValue(el);
            }
        }
        el = model.childNamed('receiver');
        if (el) {
            el = el.childNamed('ref') || el.childNamed('sprite');
            if (el) {
                v.receiver = this.loadValue(el);
            }
        }
        origin = v.origin || v.receiver || object; // for local blocks look up

        el = model.childNamed('script');
        if (el) {
            v.expression = this.loadScript(el,origin);
        } else {
            el = model.childNamed('block') ||
                model.childNamed('custom-block');
            if (el) {
                v.expression = this.loadBlock(el,origin);
            } else {
                el = model.childNamed('l');
                if (el) {
                    /*v.expression = new InputSlotMorph(el.contents);*/
                     bool = el.childNamed('bool');
                    if (bool) {
                        v.expression = new BooleanSlotMorph(
                            this.loadValue(bool)
                        );
                    } else {
                        v.expression = new InputSlotMorph(el.contents);
                    }
                }
            }
        }
        if (v.expression instanceof BlockMorph) { // v 4.0.10.2
            // bind empty slots to implicit formal parameters
            i = 0;
            v.expression.allEmptySlots().forEach(function (slot) {
                i += 1;
                if (slot instanceof MultiArgMorph) {
                    slot.bindingID = ['arguments'];
                } else {
                    slot.bindingID = i;
                }
            });
            // and remember the number of detected empty slots
            v.emptySlots = i;
        }
      /*  el = model.childNamed('receiver');
        if (el) {
            el = el.childNamed('ref') || el.childNamed('sprite');
            if (el) {
                v.receiver = this.loadValue(el);
            }
        }*/
        el = model.childNamed('inputs');
        if (el) {
            el.children.forEach(function (item) {
                if (item.tag === 'input') {
                    v.inputs.push(item.contents);
                }
            });
        }
        el = model.childNamed('variables');
        if (el) {
            this.loadVariables(v.variables, el, origin);
        }
        el = model.childNamed('context');
        if (el) {
            v.outerContext = this.loadValue(el,origin);
        }
        if (v.outerContext && v.receiver &&
                !v.outerContext.variables.parentFrame) {
            v.outerContext.variables.parentFrame = v.receiver.variables;
        }
        return v;
    case 'costume':
        center = new Point();
        if (Object.prototype.hasOwnProperty.call(
                model.attributes,
                'center-x'
            )) {
            center.x = parseFloat(model.attributes['center-x']);
        }
        if (Object.prototype.hasOwnProperty.call(
                model.attributes,
                'center-y'
            )) {
            center.y = parseFloat(model.attributes['center-y']);
        }
        if (Object.prototype.hasOwnProperty.call(
                model.attributes,
                'name'
            )) {
            name = model.attributes.name;
        }
        if (Object.prototype.hasOwnProperty.call(
                model.attributes,
                'image'
            )) {
            image = new Image();
            if (model.attributes.image.indexOf('data:image/svg+xml') === 0
                    && !MorphicPreferences.rasterizeSVGs) {
                v = new SVG_Costume(null, name, center);
                image.onload = function () {
                    v.contents = image;
                    v.version = +new Date();
                    if (typeof v.loaded === 'function') {
                        v.loaded();
                    } else {
                        v.loaded = true;
                    }
                };
            } else {
                v = new Costume(null, name, center);
                image.onload = function () {
                    var canvas = newCanvas(
                            new Point(image.width, image.height),
                             true // nonRetina
                        ),
                        context = canvas.getContext('2d');
                    context.drawImage(image, 0, 0);
                    v.contents = canvas;
                    v.version = +new Date();
                    if (typeof v.loaded === 'function') {
                        v.loaded();
                    } else {
                        v.loaded = true;
                    }
                };
            }
            image.src = model.attributes.image;
        }
        record();
        return v;
    case 'sound':
        audio = new Audio();
        audio.src = model.attributes.sound;
        v = new Sound(audio, model.attributes.name);
        if (Object.prototype.hasOwnProperty.call(
                model.attributes,
                'mediaID'
            )) {
            myself.mediaDict[model.attributes.mediaID] = v;
        }
        return v;
    }
    return undefined;
};

SnapSerializer.prototype.openProject = function (project, ide) {
    var stage = ide.stage,
        sprites = [],
        sprite;
    if (!project || !project.stage) {
        return;
    }
    ide.projectName = project.name;
    ide.projectNotes = project.notes || '';
    if (ide.globalVariables) {
        ide.globalVariables = project.globalVariables;
    }
    if (stage) {
        stage.destroy();
    }
    ide.add(project.stage);
    ide.stage = project.stage;
    sprites = ide.stage.children.filter(function (child) {
        return child instanceof SpriteMorph;
    });
    sprites.sort(function (x, y) {
        return x.idx - y.idx;
    });

    ide.sprites = new List(sprites);
////////////////////////////////////////////////////////////
    sprite = ide.chooseSprite(sprites,project.stage); // choose the first not secret sprite
///////////////////////////////////////////////
   //sprite = sprites[0] || project.stage;

    if (sizeOf(this.mediaDict) > 0) {
        ide.hasChangedMedia = false;
        this.mediaDict = {};
    } else {
        ide.hasChangedMedia = true;
    }
    project.stage.drawNew();
//network support	
	if (project.stage.noNetworkSupport && world.role == "STUDENT") {
		ide.controlBar.cloudButton.hide();
	} else {
		ide.controlBar.cloudButton.show();
	}	
//network support	
//---------------------
	ide.createCorralBar();
//---------------------
    ide.createCorral();
    ide.selectSprite(sprite);
    ide.fixLayout();

    ide.world().keyboardReceiver = project.stage;
	
//++++++++++++++++ recreate the categories //custom categories
	ide.createCategories();
	ide.currentCategory = SpriteMorph.prototype.categories()[0]; // the first category in the list (depository or motion)
	ide.fixLayout();	
	ide.refreshPalette(true); 
//+++++++++++++++++++++++++++++
};


StageMorph.prototype.depositorytoXML = function (serializer) {
var depository = this.depositoryCommands,
	primitives = [],
	vars = [],
	myself=this,
	customBlocks =[];

// populate the arrays
	depository.forEach(function (el){
		switch (el[0]){
			case 'variable' 			: 	vars.push(serializer.format('<variable name="@"/>',el[1]));
											break;
			case 'custom-block' 		:	customBlocks.push(serializer.format('<custom-block s="@" cat="@"/>',el[1],el[2])); 
											break;
			default 					:	primitives.push(el[1]); //primitives									
		}
	});	
// create the XML tree
	if (depository.length>0) {
	return serializer.format(  '<primitives>%</primitives>' +
						'<variables>%</variables>' +
						'<custom-blocks>%</custom-blocks>',
						primitives.reduce(
						function (a, b) {return a + ' ' + b; }, ''),
						vars.reduce(
						function (a, b) {return a + b; }, ''),
						customBlocks.reduce(
						function (a, b) {return a + b; }, '')
						);}
	else {return '';}
}
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++

StageMorph.prototype.toXML = function (serializer) {
    var thumbnail = normalizeCanvas(   //retina
            this.thumbnail(SnapSerializer.prototype.thumbnailSize),
            true
        ), //this.thumbnail(SnapSerializer.prototype.thumbnailSize),
        thumbdata,
        ide = this.parentThatIsA(IDE_Morph),
		catArray=[]; //for custom categories serialization

    // catch cross-origin tainting exception when using SVG costumes
    try {
        thumbdata = thumbnail.toDataURL('image/png');
    } catch (error) {
        thumbdata = null;
    }

    function code(key) {
        var str = '';
        Object.keys(StageMorph.prototype[key]).forEach(
            function (selector) {
                str += (
                    '<' + selector + '>' +
                        XML_Element.prototype.escape(
                            StageMorph.prototype[key][selector]
                        ) +
                        '</' + selector + '>'
                );
            }
        );
        return str;
    }

    this.removeAllClones();
// custom categories -- populate the array
	SpriteMorph.prototype.customCategories.forEach(function(cat){
		catArray.push(cat);
	});
//////////////////////////////////////////	
    return serializer.format(
        '<project name="@" app="@" version="@">' +
            '<notes>$</notes>' +
            '<thumbnail>$</thumbnail>' +
            '<stage name="@" width="@" height="@" ' +
			' isSecret="@"' +     // stage morph is secret
			' blockExecutionOnClick="@"' + //exercise Mode 
			' addsprites="@"' + // sprites can be added to stage
                        ' importExportHOC="@"' + // sprites can be added to stage
            ' costume="@" tempo="@" threadsafe="@" '+ 
            '%' +
            'hideCostumes="@" hideSounds="@" hideSpriteBar="@" hideCorral="@" onlyScriptVars="@" noCustomBlocks="@" ' + //--++--   hide costumes, sounds, sprite bar and corral 
            'lines="@" ' +
            'ternary="@" ' +        
            'codify="@" ' +
			'noNetworkSupport="@" ' +
            'inheritance="@" ' +
            'sublistIDs="@" ' +
            'scheduled="@" ~>' +
            '<pentrails>$</pentrails>' +
            '<costumes>%</costumes>' +
            '<sounds>%</sounds>' +
            '<variables>%</variables>' +
            '<blocks>%</blocks>' +
            '<scripts>%</scripts>' +
            (!this.hints ? '%' : '<hints>%</hints>') + //hints scripts store
            '<sprites>%</sprites>' +
            '</stage>' +
            '<hidden>$</hidden>' +
			'<depository>%</depository>' + //// depository node 
            '<headers>%</headers>' +
            '<code>%</code>' +
            '<blocks>%</blocks>' +
            '<variables>%</variables>' +
			'<hiddenStandardCategories>%</hiddenStandardCategories>' +   //custom categories
			'<customCategories>%</customCategories>' +		 //custom categories
            '</project>',
        (ide && ide.projectName) ? ide.projectName : 'Untitled',
        serializer.app,
        serializer.version,
		(ide && ide.projectNotes) ? ide.projectNotes : '',
        thumbdata,
        this.name,
        StageMorph.prototype.dimensions.x,
        StageMorph.prototype.dimensions.y,
		this.isSecret,            //stage morph isSecret attribute
		!this.exerciseMode, //block execution on click
		this.canAddSprites,       // sprites can be added to stage
                this.importExportHOC, //importing-exporting in HOCmode
        this.getCostumeIdx(),
        this.getTempo(),
        this.isThreadSafe,
        this.instrument ?
                ' instrument="' + parseInt(this.instrument) + '" ' : '',
		this.hideCostumes, //--++-- hide costumes tabs
		this.hideSounds,  //--++-- hide sounds tabs
		this.hideSpriteBar,  //--++-- hide sprite bar
		this.hideCorral,  //--++-- hide corral
		this.onlyScriptVars, //--++-- allow only script vars
		this.noCustomBlocks, //--++-- forbid custom blocks creation
        SpriteMorph.prototype.useFlatLineEnds ? 'flat' : 'round',
        BooleanSlotMorph.prototype.isTernary,
        this.enableCodeMapping,
		this.noNetworkSupport, //network support
		this.enableInheritance,
                this.enableSublistIDs,
        StageMorph.prototype.frameRate !== 0,
        //this.trailsCanvas.toDataURL('image/png'),
        normalizeCanvas(this.trailsCanvas, true).toDataURL('image/png'), //retina
        serializer.store(this.costumes, this.name + '_cst'),
        serializer.store(this.sounds, this.name + '_snd'),
        serializer.store(this.variables),
        serializer.store(this.customBlocks),
        serializer.store(this.scripts),
        !this.hints ? '' : serializer.store( world.role=="STUDENT" ? this.hints.scriptsBackUp: this.hints.scripts) +
                '<vars-and-blocks>'+serializer.store(world.role=="STUDENT" ? this.hints.varAndCustomScriptsBackUp: this.hints.varAndCustomScripts)+'</vars-and-blocks>',
        serializer.store(this.children),
        Object.keys(StageMorph.prototype.hiddenPrimitives).reduce(
                function (a, b) {return a + ' ' + b; },
                ''
            ),
		this.depositorytoXML(serializer),// serialize depository
        code('codeHeaders'),
        code('codeMappings'),
        serializer.store(this.globalBlocks),
        (ide && ide.globalVariables) ?
                    serializer.store(ide.globalVariables) : '',
		SpriteMorph.prototype.hiddenStandardCategories.reduce(
					function (a, b) {return a + ' ' + b; }, ''),   //hidden categories
		SpriteMorph.prototype.customCategoriestoXML(serializer,catArray)	  //custom categories
    );
};

//custom categories
SpriteMorph.prototype.customCategoriestoXML = function(serializer,catArray) {
	var result ='';
	//SpriteMorph.prototype.customCategories	
	/*Object.keys(catArray)*/catArray.forEach( function (el) {
		result += serializer.format('<category name="@" color="@,@,@"/>', //count="@" />',
									 el,
									 SpriteMorph.prototype.blockColor[el].r,
									 SpriteMorph.prototype.blockColor[el].g,
									 SpriteMorph.prototype.blockColor[el].b//,
									 //catArray[el]
		);
	});
	return result;
}
//custom categories end

SpriteMorph.prototype.toXML = function (serializer) {	
    var stage = this.parentThatIsA(StageMorph),
        ide = stage ? stage.parentThatIsA(IDE_Morph) : null,
        idx = ide ? ide.sprites.asArray().indexOf(this) + 1 : 0,
        noCostumes = this.inheritsAttribute('costumes'),
        noSounds = this.inheritsAttribute('sounds'),
        noScripts = this.inheritsAttribute('scripts'),
		returnstring,      //custom categories
		customCategories=[];  //custom categories 
    returnstring = serializer.format(
        '<sprite name="@" idx="@" x="@" y="@"' +
            ' heading="@"' +
            ' scale="@"' +
            ' rotation="@"' +
             '%' +
            ' draggable="@"' +
			' isSecret="@"' +  //is hidden
			' isLocked="@"' +  //is locked
            '%' +
            ' costume="@" color="@,@,@" pen="@" ~>' +
            '%' + // inheritance info
            '%' + // nesting info
            (noCostumes ? '%' : '<costumes>%</costumes>') +
            (noSounds ? '%' : '<sounds>%</sounds>') +
            '<blocks>%</blocks>' +
            '<variables>%</variables>' +
            (this.exemplar ? '<dispatches>%</dispatches>' : '%') +
            (noScripts ? '%' : '<scripts>%</scripts>') +
            (!this.hints ? '%' : '<hints>%</hints>') + //hints scripts store
            '</sprite>',
        this.name,
        idx,
        this.xPosition(),
        this.yPosition(),
        this.heading,
        this.scale,
        this.rotationStyle,
        this.instrument ?
                ' instrument="' + parseInt(this.instrument) + '" ' : '',
        this.isDraggable,
		this.isSecret,
		this.isLocked,
        this.isVisible ? '' : ' hidden="true"',
        this.getCostumeIdx(),
        this.color.r,
        this.color.g,
        this.color.b,
        this.penPoint,
		
		// inheritance info
        this.exemplar
            ? '<inherit exemplar="' +
                    this.exemplar.name +
                    '">' +
                    (this.inheritedAttributes.length ?
                        serializer.store(new List(this.inheritedAttributes))
                        : '') +
                    '</inherit>'
            : '',
			
        // nesting info
        this.anchor
            ? '<nest anchor="' +
                    this.anchor.name +
                    '" synch="'
                    + this.rotatesWithAnchor
                    + (this.scale === this.nestingScale ? '' :
                            '"'
                            + ' scale="'
                            + this.nestingScale)

                    + '"/>'
            : '',

        noCostumes ? '' : serializer.store(this.costumes, this.name + '_cst'),
        noSounds ? '' : serializer.store(this.sounds, this.name + '_snd'),
       !this.customBlocks ? '' : serializer.store(this.customBlocks),
        serializer.store(this.variables),
        this.exemplar ? serializer.store(this.inheritedMethods()) : '',
        noScripts ? '' : serializer.store(this.scripts),
        !this.hints ? '' : serializer.store(world.role == "STUDENT" ? this.hints.scriptsBackUp : this.hints.scripts) +
                '<vars-and-blocks>'+serializer.store(world.role=="STUDENT" ? this.hints.varAndCustomScriptsBackUp: this.hints.varAndCustomScripts)+'</vars-and-blocks>'
    );

	return returnstring;
};

VariableFrame.prototype.toXML = function (serializer) {
    var myself = this;
    return Object.keys(this.vars).reduce(function (vars, v) {
        var val = myself.vars[v].value, //+
			h,l, 
            dta;		
		
		h = myself.hiddenVars[v]? true : false; // ----------------------------------------	
		l = myself.vars[v].isLocked? true : false;
                
        if (myself.vars[v].isTransient) { // v 4.0.10.2
            dta = serializer.format(
                '<variable name="@" isHidden="@" isLocked="@" transient="true"/>',
                v, h, l);        
        } else if (val === undefined || val === null) {
            dta = serializer.format('<variable name="@" isHidden="@" isLocked="@" />', v,h,l); //-------------------------------------------
        } else {
            dta = serializer.format(
                '<variable name="@" isHidden="@" isLocked="@" >%</variable>', //----------------------------------------------
                v,
				h,
				l,
			typeof val === 'object' ? /*serializer.store(val)*/
                        /*: typeof val === 'boolean' ?
                                serializer.format('<bool>$</bool>', val)
                                : serializer.format('<l>$</l>', val)*/
                                (isSnapObject(val) ? ''
                                : serializer.store(val))
                                : typeof val === 'boolean' ?
                                        serializer.format(
                                            '<bool>$</bool>', val
                                        )
                                        : serializer.format('<l>$</l>', val)
            );
        }
        return vars + dta;
    }, '');
};

BlockMorph.prototype.toBlockXML = function (serializer) {
        //do not serialize the inputs of blocks dealing with network data
    var inputXML = (this.selector == 'doReportUserData'|| this.selector == 'doBroadcastVariable') ? "<l/><l/>":   serializer.store(this.inputs());
   	return serializer.format(
        '<block s="@" isHidden="@" isDraggable="@">%%</block>',
        this.selector,
        this.isHidden,
		this.isDraggable, // block is draggable
        inputXML,
        this.comment ? this.comment.toXML(serializer) : ''
	);
};

ReporterBlockMorph.prototype.toXML = function (serializer) {
    return this.selector === 'reportGetVar' ? serializer.format(
        '<block var="@" isHidden="@" isDraggable="@"/>', // hide custom variables from scripts
        this.blockSpec,
		this.isHidden,
		this.isDraggable  // var block is draggable
    ) : this.toBlockXML(serializer);
};

CustomCommandBlockMorph.prototype.toBlockXML = function (serializer) {   
    var scope = this.isGlobal ? undefined : 'local';
        //: this.definition.receiver.name;
    return serializer.format(
        '<custom-block s="@" isHidden="@" isDraggable="@"%>%%%</custom-block>',
        this.blockSpec,
		this.isHidden,
		this.isDraggable, //+++
        this.isGlobal ?
                '' : serializer.format(' scope="@"', scope),
        serializer.store(this.inputs()),
        this.isGlobal &&
        	this.definition.variableNames.length &&
            !serializer.isExportingBlocksLibrary ?
                '<variables>' +
                    this.variables.toXML(serializer) +
                    '</variables>'
                        : '',
        this.comment ? this.comment.toXML(serializer) : ''
    );
};
CustomReporterBlockMorph.prototype.toBlockXML =
        CustomCommandBlockMorph.prototype.toBlockXML;

CustomBlockDefinition.prototype.toXML = function (serializer) {
    var myself = this;


    function encodeScripts(array) {
        return array.reduce(function (xml, element) {
            if (element instanceof BlockMorph) {
                return xml + element.toScriptXML(serializer, true);
            }
            if (element instanceof CommentMorph && !element.block) {
                return xml + element.toXML(serializer);
            }
            return xml;
        }, '');
    }

    return serializer.format(
       '<block-definition s="@" type="@" category="@" isLocked="@" isHidden="@">' +  ///////////// add the isLocked,isHidden definition attribute ////////////////////
            '%' +
            (this.variableNames.length ? '<variables>%</variables>' : '@') +
            '<header>@</header>' +
            '<code>@</code>' +
            '<inputs>%</inputs>%%' +
            '</block-definition>',
        this.spec,
        this.type,
        this.category || 'other',
		this.isLocked, ///////// the isLocked definition attribute ////////////////////
		this.isHidden, ///////// the isHidden definition attribute ///////////////////
        this.comment ? this.comment.toXML(serializer) : '',
        (this.variableNames.length ?
                serializer.store(new List(this.variableNames)) : ''),
        this.codeHeader || '',
        this.codeMapping || '',
        Object.keys(this.declarations).reduce(function (xml, decl) {
                return xml + serializer.format(
                    '<input type="@"$>$%</input>',
                    myself.declarations[decl][0],
                    myself.declarations[decl][3] ?
                            ' readonly="true"' : '',
                    myself.declarations[decl][1],
                    myself.declarations[decl][2] ?
                            '<options>' + myself.declarations[decl][2] +
                                '</options>'
                                : ''
                );
            }, ''),
        this.body ? serializer.store(this.body.expression) : '',
        this.scripts.length > 0 ?
                    '<scripts>' + encodeScripts(this.scripts) + '</scripts>'
                        : ''
    );
};

