VariableFrame.prototype.hiddenVars = {};

//========================================= all VISIBLE names dict ================================================
VariableFrame.prototype.allVisibleNamesDict = function () {
    var dict = {}, current = this;

    function addKeysToDict(srcDictV,srcDictH, trgtDict) {
        var eachKey;
        for (eachKey in srcDictV) {
            if (Object.prototype.hasOwnProperty.call(srcDictV, eachKey) && !Object.prototype.hasOwnProperty.call(srcDictH, eachKey)) {
                trgtDict[eachKey] = eachKey;
            }
        }
    }

    while (current) {
        addKeysToDict(current.vars,current.hiddenVars, dict);
        current = current.parentFrame;
    }
    return dict;
};
//=================================================================================================================

VariableFrame.prototype.allNames = function (hidden) {
/*
    only show the names of the lexical scope, hybrid scoping is
    reserved to the daring ;-)
*/
    var answer = [], each, dict;
// ============== if hidden return all visible =======================

	if (hidden) {
		dict= this.allVisibleNamesDict();
	} else {
		dict= this.allNamesDict();
	}
//===============================================================
    for (each in dict) {
        if (Object.prototype.hasOwnProperty.call(dict, each)) {
            answer.push(each);
        }
    }
    return answer;
};

VariableFrame.prototype.visibleNames = function () { // filter the hidden vars
    var each, names = [];
    for (each in this.vars) {
        if (Object.prototype.hasOwnProperty.call(this.vars, each)) {
			if (!this.hiddenVars[each]){
				names.push(each);
			}	
        }
    }
    return names;
};


VariableFrame.prototype.addVar = function (name, value) {
    this.vars[name] = new Variable(value === 0 ? 0
              : value === false ? false
                       : value === '' ? '' : value || 0); 
    if (typeof(name)=="string"){
	if (name.indexOf("$$")==0){  //handle hiddens				   
		this.hiddenVars[name] = true;	
	}
    }    
};

VariableFrame.prototype.deleteVar = function (name) {
    var frame = this.find(name);
    if (frame) {
	//Network support
		if (NetworkClient.sharedVariables[name]){ //(frame.vars[name].isShared){ //if deleted variable is shared, stop sharing
                    delete NetworkClient.sharedVariables[name];
                    NetworkClient.io.emit("unshare_variable",name);
		}
	//Network support			
        delete frame.vars[name];
		if (frame.hiddenVars[name]){
			delete frame.hiddenVars[name];
		}		
    }
};

